import "./cljs_env.js";
goog.provide('sci.impl.evaluator');

sci.impl.evaluator.macros = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Symbol(null,"fn","fn",465265323,null),"null",new cljs.core.Symbol(null,"do","do",1686842252,null),"null",new cljs.core.Symbol(null,"defn","defn",-126010802,null),"null",new cljs.core.Symbol(null,"syntax-quote","syntax-quote",407366680,null),"null",new cljs.core.Symbol(null,"def","def",597100991,null),"null"], null), null);
/**
 * The and macro from clojure.core. Note: and is unrolled in the analyzer, this is a fallback.
 */
sci.impl.evaluator.eval_and = (function sci$impl$evaluator$eval_and(ctx,bindings,args){
var args__$1 = cljs.core.seq(args);
var args__$2 = args__$1;
while(true){
if(args__$2){
var x = cljs.core.first(args__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,x) : sci.impl.evaluator.eval.call(null,ctx,bindings,x));
if(cljs.core.truth_(v)){
var xs = cljs.core.next(args__$2);
if(xs){
var G__82121 = xs;
args__$2 = G__82121;
continue;
} else {
return v;
}
} else {
return v;
}
} else {
return true;
}
break;
}
});
/**
 * The or macro from clojure.core. Note: or is unrolled in the analyzer, this is a fallback.
 */
sci.impl.evaluator.eval_or = (function sci$impl$evaluator$eval_or(ctx,bindings,args){
var args__$1 = cljs.core.seq(args);
var args__$2 = args__$1;
while(true){
if(args__$2){
var x = cljs.core.first(args__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,x) : sci.impl.evaluator.eval.call(null,ctx,bindings,x));
if(cljs.core.truth_(v)){
return v;
} else {
var xs = cljs.core.next(args__$2);
if(xs){
var G__82122 = xs;
args__$2 = G__82122;
continue;
} else {
return v;
}
}
} else {
return null;
}
break;
}
});
/**
 * The let macro from clojure.core
 */
sci.impl.evaluator.eval_let = (function sci$impl$evaluator$eval_let(ctx,bindings,let_bindings,exprs){
var vec__81089 = (function (){var ctx__$1 = ctx;
var bindings__$1 = bindings;
var let_bindings__$1 = let_bindings;
while(true){
var let_name = cljs.core.first(let_bindings__$1);
var let_bindings__$2 = cljs.core.rest(let_bindings__$1);
var let_val = cljs.core.first(let_bindings__$2);
var rest_let_bindings = cljs.core.next(let_bindings__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx__$1,bindings__$1,let_val) : sci.impl.evaluator.eval.call(null,ctx__$1,bindings__$1,let_val));
var bindings__$2 = cljs.core._assoc(bindings__$1,let_name,v);
if(cljs.core.not(rest_let_bindings)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [ctx__$1,bindings__$2], null);
} else {
var G__82123 = ctx__$1;
var G__82124 = bindings__$2;
var G__82125 = rest_let_bindings;
ctx__$1 = G__82123;
bindings__$1 = G__82124;
let_bindings__$1 = G__82125;
continue;
}
break;
}
})();
var ctx__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81089,(0),null);
var bindings__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81089,(1),null);
if(cljs.core.truth_(exprs)){
var exprs__$1 = exprs;
while(true){
var e = cljs.core.first(exprs__$1);
var ret = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx__$1,bindings__$1,e) : sci.impl.evaluator.eval.call(null,ctx__$1,bindings__$1,e));
var nexprs = cljs.core.next(exprs__$1);
if(nexprs){
var G__82131 = nexprs;
exprs__$1 = G__82131;
continue;
} else {
return ret;
}
break;
}
} else {
return null;
}
});
sci.impl.evaluator.handle_meta = (function sci$impl$evaluator$handle_meta(ctx,bindings,m){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2((function (){var temp__5751__auto__ = cljs.core.meta(m);
if(cljs.core.truth_(temp__5751__auto__)){
var mm = temp__5751__auto__;
if(cljs.core.truth_((cljs.core.truth_(mm)?mm.get(new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978)):null))){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,m) : sci.impl.evaluator.eval.call(null,ctx,bindings,m));
} else {
return m;
}
} else {
return m;
}
})(),new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978));
});
sci.impl.evaluator.eval_map = (function sci$impl$evaluator$eval_map(ctx,bindings,expr){
var temp__5751__auto__ = cljs.core.meta(expr);
if(cljs.core.truth_(temp__5751__auto__)){
var m = temp__5751__auto__;
if(cljs.core.truth_((function (){var G__81094 = new cljs.core.Keyword(null,"eval","eval",-1103567905);
var G__81095 = new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978).cljs$core$IFn$_invoke$arity$1(m);
return (sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(G__81094,G__81095) : sci.impl.utils.kw_identical_QMARK_.call(null,G__81094,G__81095));
})())){
return cljs.core.with_meta(cljs.core.zipmap(cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__81092_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__81092_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__81092_SHARP_));
}),cljs.core.keys(expr)),cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__81093_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__81093_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__81093_SHARP_));
}),cljs.core.vals(expr))),sci.impl.evaluator.handle_meta(ctx,bindings,m));
} else {
return expr;
}
} else {
return expr;
}
});
sci.impl.evaluator.eval_def = (function sci$impl$evaluator$eval_def(ctx,bindings,var_name,init,m){
var init__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,init) : sci.impl.evaluator.eval.call(null,ctx,bindings,init));
var m__$1 = (function (){var or__4223__auto__ = m;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.meta(var_name);
}
})();
var m__$2 = sci.impl.evaluator.eval_map(ctx,bindings,m__$1);
var cnn = sci.impl.vars.getName(new cljs.core.Keyword(null,"ns","ns",441598760).cljs$core$IFn$_invoke$arity$1(m__$2));
var assoc_in_env = (function (env){
var the_current_ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(env,new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469)),cnn);
var prev = cljs.core.get.cljs$core$IFn$_invoke$arity$2(the_current_ns,var_name);
var prev__$1 = (((!(sci.impl.vars.var_QMARK_(prev))))?sci.impl.vars.__GT_SciVar(prev,cljs.core.symbol.cljs$core$IFn$_invoke$arity$2(cljs.core.str.cljs$core$IFn$_invoke$arity$1(cnn),cljs.core.str.cljs$core$IFn$_invoke$arity$1(var_name)),cljs.core.meta(prev),false):prev);
var v = (cljs.core.truth_((sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword("sci.impl","var.unbound","sci.impl/var.unbound",-1824207647),init__$1) : sci.impl.utils.kw_identical_QMARK_.call(null,new cljs.core.Keyword("sci.impl","var.unbound","sci.impl/var.unbound",-1824207647),init__$1)))?(function (){var G__81096 = prev__$1;
cljs.core.alter_meta_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__81096,cljs.core.merge,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([m__$2], 0));

return G__81096;
})():(function (){
sci.impl.vars.bindRoot(prev__$1,init__$1);

cljs.core.alter_meta_BANG_.cljs$core$IFn$_invoke$arity$variadic(prev__$1,cljs.core.merge,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([m__$2], 0));

return prev__$1;
})()
);
var the_current_ns__$1 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(the_current_ns,var_name,v);
return cljs.core.assoc_in(env,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn], null),the_current_ns__$1);
});
var env = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"env","env",-1815813235).cljs$core$IFn$_invoke$arity$1(ctx),assoc_in_env);
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(env,new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469)),cnn),var_name);
});
sci.impl.evaluator.eval_case = (function sci$impl$evaluator$eval_case(var_args){
var G__81098 = arguments.length;
switch (G__81098) {
case 4:
return sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$4 = (function (ctx,bindings,case_map,case_val){
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_val) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_val));
var temp__5751__auto__ = cljs.core.find(case_map,v);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__81103 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81103,(0),null);
var found = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81103,(1),null);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,found) : sci.impl.evaluator.eval.call(null,ctx,bindings,found));
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('')));
}
}));

(sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$5 = (function (ctx,bindings,case_map,case_val,case_default){
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_val) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_val));
var temp__5751__auto__ = cljs.core.find(case_map,v);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__81111 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81111,(0),null);
var found = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81111,(1),null);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,found) : sci.impl.evaluator.eval.call(null,ctx,bindings,found));
} else {
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_default) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_default));
}
}));

(sci.impl.evaluator.eval_case.cljs$lang$maxFixedArity = 5);

sci.impl.evaluator.eval_try = (function sci$impl$evaluator$eval_try(ctx,bindings,body,catches,finally$){
try{var _STAR_in_try_STAR__orig_val__81139 = sci.impl.utils._STAR_in_try_STAR_;
var _STAR_in_try_STAR__temp_val__81140 = true;
(sci.impl.utils._STAR_in_try_STAR_ = _STAR_in_try_STAR__temp_val__81140);

try{return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,body) : sci.impl.evaluator.eval.call(null,ctx,bindings,body));
}finally {(sci.impl.utils._STAR_in_try_STAR_ = _STAR_in_try_STAR__orig_val__81139);
}}catch (e81118){if((e81118 instanceof Error)){
var e = e81118;
var temp__5751__auto__ = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (_,c){
var clazz = new cljs.core.Keyword(null,"class","class",-2030961996).cljs$core$IFn$_invoke$arity$1(c);
if(cljs.core.truth_((function (){var or__4223__auto__ = (sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"default","default",-1987822328),clazz) : sci.impl.utils.kw_identical_QMARK_.call(null,new cljs.core.Keyword(null,"default","default",-1987822328),clazz));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
if((clazz instanceof sci.impl.types.EvalFn)){
var c__4254__auto__ = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,clazz) : sci.impl.evaluator.eval.call(null,ctx,bindings,clazz));
var x__4255__auto__ = e;
return (x__4255__auto__ instanceof c__4254__auto__);
} else {
return (e instanceof clazz);
}
}
})())){
return cljs.core.reduced(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("sci.impl.evaluator","try-result","sci.impl.evaluator/try-result",-1394897780),(function (){var G__81132 = ctx;
var G__81133 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(bindings,new cljs.core.Keyword(null,"binding","binding",539932593).cljs$core$IFn$_invoke$arity$1(c),e);
var G__81134 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(c);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81132,G__81133,G__81134) : sci.impl.evaluator.eval.call(null,G__81132,G__81133,G__81134));
})()], null));
} else {
return null;
}
}),null,catches);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__81135 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81135,(0),null);
var r = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81135,(1),null);
return r;
} else {
return sci.impl.utils.rethrow_with_location_of_node.cljs$core$IFn$_invoke$arity$4(ctx,bindings,e,body);
}
} else {
throw e81118;

}
}finally {(sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,finally$) : sci.impl.evaluator.eval.call(null,ctx,bindings,finally$));
}});
sci.impl.evaluator.eval_static_method_invocation = (function sci$impl$evaluator$eval_static_method_invocation(ctx,bindings,expr){
return sci.impl.interop.invoke_static_method(cljs.core.first(expr),cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__81151_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__81151_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__81151_SHARP_));
}),cljs.core.rest(expr)));
});
sci.impl.evaluator.eval_instance_method_invocation = (function sci$impl$evaluator$eval_instance_method_invocation(ctx,bindings,instance_expr,method_str,args){
var instance_meta = cljs.core.meta(instance_expr);
var tag_class = new cljs.core.Keyword(null,"tag-class","tag-class",714967874).cljs$core$IFn$_invoke$arity$1(instance_meta);
var instance_expr_STAR_ = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,instance_expr) : sci.impl.evaluator.eval.call(null,ctx,bindings,instance_expr));
if(cljs.core.truth_((function (){var and__4221__auto__ = cljs.core.map_QMARK_(instance_expr_STAR_);
if(and__4221__auto__){
return new cljs.core.Keyword("sci.impl","record","sci.impl/record",-1939193950).cljs$core$IFn$_invoke$arity$1(cljs.core.meta(instance_expr_STAR_));
} else {
return and__4221__auto__;
}
})())){
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(instance_expr_STAR_,cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(method_str,(1))));
} else {
var instance_class = (function (){var or__4223__auto__ = tag_class;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.type(instance_expr_STAR_);
}
})();
var instance_class_name = instance_class.name;
var instance_class_symbol = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(instance_class_name);
var class__GT_opts = new cljs.core.Keyword(null,"class->opts","class->opts",2061906477).cljs$core$IFn$_invoke$arity$1(ctx);
var allowed_QMARK_ = (function (){var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(class__GT_opts,new cljs.core.Keyword(null,"allow","allow",-1857325745));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(class__GT_opts,instance_class_symbol);
}
})();
var target_class = (cljs.core.truth_(allowed_QMARK_)?instance_class:(function (){var temp__5753__auto__ = new cljs.core.Keyword(null,"public-class","public-class",1127293019).cljs$core$IFn$_invoke$arity$1(ctx);
if(cljs.core.truth_(temp__5753__auto__)){
var f = temp__5753__auto__;
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(instance_expr_STAR_) : f.call(null,instance_expr_STAR_));
} else {
return null;
}
})());
if(cljs.core.truth_(target_class)){
} else {
sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2(["Method ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(method_str)," on ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(instance_class)," not allowed!"].join(''),instance_expr);
}

var args__$1 = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__81153_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__81153_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__81153_SHARP_));
}),args);
return sci.impl.interop.invoke_instance_method(instance_expr_STAR_,target_class,method_str,args__$1);
}
});
sci.impl.evaluator.eval_resolve = (function sci$impl$evaluator$eval_resolve(var_args){
var G__81160 = arguments.length;
switch (G__81160) {
case 3:
return sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$3 = (function (ctx,bindings,sym){
var sym__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,sym) : sci.impl.evaluator.eval.call(null,ctx,bindings,sym));
return cljs.core.second((function (){var fexpr__81170 = cljs.core.deref(sci.impl.utils.lookup);
return (fexpr__81170.cljs$core$IFn$_invoke$arity$3 ? fexpr__81170.cljs$core$IFn$_invoke$arity$3(ctx,sym__$1,false) : fexpr__81170.call(null,ctx,sym__$1,false));
})());
}));

(sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$4 = (function (ctx,bindings,env,sym){
if(cljs.core.contains_QMARK_(env,sym)){
return null;
} else {
var sym__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,sym) : sci.impl.evaluator.eval.call(null,ctx,bindings,sym));
return cljs.core.second((function (){var fexpr__81171 = cljs.core.deref(sci.impl.utils.lookup);
return (fexpr__81171.cljs$core$IFn$_invoke$arity$3 ? fexpr__81171.cljs$core$IFn$_invoke$arity$3(ctx,sym__$1,false) : fexpr__81171.call(null,ctx,sym__$1,false));
})());
}
}));

(sci.impl.evaluator.eval_resolve.cljs$lang$maxFixedArity = 4);

cljs.core.vreset_BANG_(sci.impl.utils.eval_resolve_state,sci.impl.evaluator.eval_resolve);
sci.impl.evaluator.eval_import = (function sci$impl$evaluator$eval_import(var_args){
var args__4835__auto__ = [];
var len__4829__auto___82145 = arguments.length;
var i__4830__auto___82146 = (0);
while(true){
if((i__4830__auto___82146 < len__4829__auto___82145)){
args__4835__auto__.push((arguments[i__4830__auto___82146]));

var G__82147 = (i__4830__auto___82146 + (1));
i__4830__auto___82146 = G__82147;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((1) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((1)),(0),null)):null);
return sci.impl.evaluator.eval_import.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4836__auto__);
});

(sci.impl.evaluator.eval_import.cljs$core$IFn$_invoke$arity$variadic = (function (ctx,import_symbols_or_lists){
var specs = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__81172_SHARP_){
if(((cljs.core.seq_QMARK_(p1__81172_SHARP_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.first(p1__81172_SHARP_))))){
return cljs.core.second(p1__81172_SHARP_);
} else {
return p1__81172_SHARP_;
}
}),import_symbols_or_lists);
var env = new cljs.core.Keyword(null,"env","env",-1815813235).cljs$core$IFn$_invoke$arity$1(ctx);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (_,spec){
var vec__81176 = (((spec instanceof cljs.core.Symbol))?(function (){var s = cljs.core.str.cljs$core$IFn$_invoke$arity$1(spec);
var last_dot = clojure.string.last_index_of.cljs$core$IFn$_invoke$arity$2(s,".");
var package_PLUS_class_name = (cljs.core.truth_(last_dot)?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$3(s,(0),last_dot)),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$3(s,(last_dot + (1)),((s).length)))], null)], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec], null)], null));
return package_PLUS_class_name;
})():(function (){var p = cljs.core.first(spec);
var cs = cljs.core.rest(spec);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cs], null);
})());
var package$ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81176,(0),null);
var classes = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__81176,(1),null);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (___$1,class$){
var fq_class_name = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1((cljs.core.truth_(package$)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(package$),".",cljs.core.str.cljs$core$IFn$_invoke$arity$1(class$)].join(''):class$));
var temp__5751__auto__ = sci.impl.interop.resolve_class(ctx,fq_class_name);
if(cljs.core.truth_(temp__5751__auto__)){
var clazz = temp__5751__auto__;
var cnn = sci.impl.vars.current_ns_name();
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(env,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn,new cljs.core.Keyword(null,"imports","imports",-1249933394),class$], null),fq_class_name);

return clazz;
} else {
var temp__5751__auto____$1 = sci.impl.records.resolve_record_or_protocol_class.cljs$core$IFn$_invoke$arity$3(ctx,package$,class$);
if(cljs.core.truth_(temp__5751__auto____$1)){
var rec = temp__5751__auto____$1;
var cnn = sci.impl.vars.current_ns_name();
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(env,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn,class$], null),rec);

return rec;
} else {
throw (new Error(["Unable to resolve classname: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fq_class_name)].join('')));
}
}
}),null,classes);
}),null,specs);
}));

(sci.impl.evaluator.eval_import.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(sci.impl.evaluator.eval_import.cljs$lang$applyTo = (function (seq81173){
var G__81174 = cljs.core.first(seq81173);
var seq81173__$1 = cljs.core.next(seq81173);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__81174,seq81173__$1);
}));

/**
 * Note: various arities of do have already been unrolled in the analyzer.
 */
sci.impl.evaluator.eval_do = (function sci$impl$evaluator$eval_do(ctx,bindings,exprs){
var exprs__$1 = cljs.core.seq(exprs);
var exprs__$2 = exprs__$1;
while(true){
if(exprs__$2){
var ret = (function (){var G__81187 = ctx;
var G__81188 = bindings;
var G__81189 = cljs.core.first(exprs__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81187,G__81188,G__81189) : sci.impl.evaluator.eval.call(null,G__81187,G__81188,G__81189));
})();
var temp__5751__auto__ = cljs.core.next(exprs__$2);
if(temp__5751__auto__){
var exprs__$3 = temp__5751__auto__;
var G__82155 = exprs__$3;
exprs__$2 = G__82155;
continue;
} else {
return ret;
}
} else {
return null;
}
break;
}
});
cljs.core.vreset_BANG_(sci.impl.utils.eval_do_STAR_,sci.impl.evaluator.eval_do);
sci.impl.evaluator.fn_call = (function sci$impl$evaluator$fn_call(ctx,bindings,f,args){
var G__81388 = cljs.core.count(args);
switch (G__81388) {
case (0):
return (f.cljs$core$IFn$_invoke$arity$0 ? f.cljs$core$IFn$_invoke$arity$0() : f.call(null));

break;
case (1):
var arg81198 = (function (){var G__81389 = ctx;
var G__81390 = bindings;
var G__81391 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81389,G__81390,G__81391) : sci.impl.evaluator.eval.call(null,G__81389,G__81390,G__81391));
})();
var args__$1 = cljs.core.rest(args);
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(arg81198) : f.call(null,arg81198));

break;
case (2):
var arg81199 = (function (){var G__81392 = ctx;
var G__81393 = bindings;
var G__81394 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81392,G__81393,G__81394) : sci.impl.evaluator.eval.call(null,G__81392,G__81393,G__81394));
})();
var args__$1 = cljs.core.rest(args);
var arg81200 = (function (){var G__81395 = ctx;
var G__81396 = bindings;
var G__81397 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81395,G__81396,G__81397) : sci.impl.evaluator.eval.call(null,G__81395,G__81396,G__81397));
})();
var args__$2 = cljs.core.rest(args__$1);
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(arg81199,arg81200) : f.call(null,arg81199,arg81200));

break;
case (3):
var arg81201 = (function (){var G__81398 = ctx;
var G__81399 = bindings;
var G__81400 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81398,G__81399,G__81400) : sci.impl.evaluator.eval.call(null,G__81398,G__81399,G__81400));
})();
var args__$1 = cljs.core.rest(args);
var arg81202 = (function (){var G__81401 = ctx;
var G__81402 = bindings;
var G__81403 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81401,G__81402,G__81403) : sci.impl.evaluator.eval.call(null,G__81401,G__81402,G__81403));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81203 = (function (){var G__81404 = ctx;
var G__81405 = bindings;
var G__81406 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81404,G__81405,G__81406) : sci.impl.evaluator.eval.call(null,G__81404,G__81405,G__81406));
})();
var args__$3 = cljs.core.rest(args__$2);
return (f.cljs$core$IFn$_invoke$arity$3 ? f.cljs$core$IFn$_invoke$arity$3(arg81201,arg81202,arg81203) : f.call(null,arg81201,arg81202,arg81203));

break;
case (4):
var arg81204 = (function (){var G__81407 = ctx;
var G__81408 = bindings;
var G__81409 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81407,G__81408,G__81409) : sci.impl.evaluator.eval.call(null,G__81407,G__81408,G__81409));
})();
var args__$1 = cljs.core.rest(args);
var arg81205 = (function (){var G__81410 = ctx;
var G__81411 = bindings;
var G__81412 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81410,G__81411,G__81412) : sci.impl.evaluator.eval.call(null,G__81410,G__81411,G__81412));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81206 = (function (){var G__81413 = ctx;
var G__81414 = bindings;
var G__81415 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81413,G__81414,G__81415) : sci.impl.evaluator.eval.call(null,G__81413,G__81414,G__81415));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81207 = (function (){var G__81416 = ctx;
var G__81417 = bindings;
var G__81418 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81416,G__81417,G__81418) : sci.impl.evaluator.eval.call(null,G__81416,G__81417,G__81418));
})();
var args__$4 = cljs.core.rest(args__$3);
return (f.cljs$core$IFn$_invoke$arity$4 ? f.cljs$core$IFn$_invoke$arity$4(arg81204,arg81205,arg81206,arg81207) : f.call(null,arg81204,arg81205,arg81206,arg81207));

break;
case (5):
var arg81208 = (function (){var G__81423 = ctx;
var G__81424 = bindings;
var G__81425 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81423,G__81424,G__81425) : sci.impl.evaluator.eval.call(null,G__81423,G__81424,G__81425));
})();
var args__$1 = cljs.core.rest(args);
var arg81209 = (function (){var G__81426 = ctx;
var G__81427 = bindings;
var G__81428 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81426,G__81427,G__81428) : sci.impl.evaluator.eval.call(null,G__81426,G__81427,G__81428));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81210 = (function (){var G__81429 = ctx;
var G__81430 = bindings;
var G__81431 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81429,G__81430,G__81431) : sci.impl.evaluator.eval.call(null,G__81429,G__81430,G__81431));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81211 = (function (){var G__81435 = ctx;
var G__81436 = bindings;
var G__81437 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81435,G__81436,G__81437) : sci.impl.evaluator.eval.call(null,G__81435,G__81436,G__81437));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81212 = (function (){var G__81442 = ctx;
var G__81443 = bindings;
var G__81444 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81442,G__81443,G__81444) : sci.impl.evaluator.eval.call(null,G__81442,G__81443,G__81444));
})();
var args__$5 = cljs.core.rest(args__$4);
return (f.cljs$core$IFn$_invoke$arity$5 ? f.cljs$core$IFn$_invoke$arity$5(arg81208,arg81209,arg81210,arg81211,arg81212) : f.call(null,arg81208,arg81209,arg81210,arg81211,arg81212));

break;
case (6):
var arg81213 = (function (){var G__81445 = ctx;
var G__81446 = bindings;
var G__81447 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81445,G__81446,G__81447) : sci.impl.evaluator.eval.call(null,G__81445,G__81446,G__81447));
})();
var args__$1 = cljs.core.rest(args);
var arg81214 = (function (){var G__81448 = ctx;
var G__81449 = bindings;
var G__81450 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81448,G__81449,G__81450) : sci.impl.evaluator.eval.call(null,G__81448,G__81449,G__81450));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81215 = (function (){var G__81451 = ctx;
var G__81452 = bindings;
var G__81453 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81451,G__81452,G__81453) : sci.impl.evaluator.eval.call(null,G__81451,G__81452,G__81453));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81216 = (function (){var G__81454 = ctx;
var G__81455 = bindings;
var G__81456 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81454,G__81455,G__81456) : sci.impl.evaluator.eval.call(null,G__81454,G__81455,G__81456));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81217 = (function (){var G__81457 = ctx;
var G__81458 = bindings;
var G__81459 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81457,G__81458,G__81459) : sci.impl.evaluator.eval.call(null,G__81457,G__81458,G__81459));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81218 = (function (){var G__81460 = ctx;
var G__81461 = bindings;
var G__81462 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81460,G__81461,G__81462) : sci.impl.evaluator.eval.call(null,G__81460,G__81461,G__81462));
})();
var args__$6 = cljs.core.rest(args__$5);
return (f.cljs$core$IFn$_invoke$arity$6 ? f.cljs$core$IFn$_invoke$arity$6(arg81213,arg81214,arg81215,arg81216,arg81217,arg81218) : f.call(null,arg81213,arg81214,arg81215,arg81216,arg81217,arg81218));

break;
case (7):
var arg81219 = (function (){var G__81463 = ctx;
var G__81464 = bindings;
var G__81465 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81463,G__81464,G__81465) : sci.impl.evaluator.eval.call(null,G__81463,G__81464,G__81465));
})();
var args__$1 = cljs.core.rest(args);
var arg81220 = (function (){var G__81466 = ctx;
var G__81467 = bindings;
var G__81468 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81466,G__81467,G__81468) : sci.impl.evaluator.eval.call(null,G__81466,G__81467,G__81468));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81221 = (function (){var G__81469 = ctx;
var G__81470 = bindings;
var G__81471 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81469,G__81470,G__81471) : sci.impl.evaluator.eval.call(null,G__81469,G__81470,G__81471));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81222 = (function (){var G__81472 = ctx;
var G__81473 = bindings;
var G__81474 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81472,G__81473,G__81474) : sci.impl.evaluator.eval.call(null,G__81472,G__81473,G__81474));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81223 = (function (){var G__81478 = ctx;
var G__81479 = bindings;
var G__81480 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81478,G__81479,G__81480) : sci.impl.evaluator.eval.call(null,G__81478,G__81479,G__81480));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81224 = (function (){var G__81481 = ctx;
var G__81482 = bindings;
var G__81483 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81481,G__81482,G__81483) : sci.impl.evaluator.eval.call(null,G__81481,G__81482,G__81483));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81225 = (function (){var G__81488 = ctx;
var G__81489 = bindings;
var G__81490 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81488,G__81489,G__81490) : sci.impl.evaluator.eval.call(null,G__81488,G__81489,G__81490));
})();
var args__$7 = cljs.core.rest(args__$6);
return (f.cljs$core$IFn$_invoke$arity$7 ? f.cljs$core$IFn$_invoke$arity$7(arg81219,arg81220,arg81221,arg81222,arg81223,arg81224,arg81225) : f.call(null,arg81219,arg81220,arg81221,arg81222,arg81223,arg81224,arg81225));

break;
case (8):
var arg81226 = (function (){var G__81491 = ctx;
var G__81492 = bindings;
var G__81493 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81491,G__81492,G__81493) : sci.impl.evaluator.eval.call(null,G__81491,G__81492,G__81493));
})();
var args__$1 = cljs.core.rest(args);
var arg81227 = (function (){var G__81494 = ctx;
var G__81495 = bindings;
var G__81496 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81494,G__81495,G__81496) : sci.impl.evaluator.eval.call(null,G__81494,G__81495,G__81496));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81228 = (function (){var G__81497 = ctx;
var G__81498 = bindings;
var G__81499 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81497,G__81498,G__81499) : sci.impl.evaluator.eval.call(null,G__81497,G__81498,G__81499));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81229 = (function (){var G__81500 = ctx;
var G__81501 = bindings;
var G__81502 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81500,G__81501,G__81502) : sci.impl.evaluator.eval.call(null,G__81500,G__81501,G__81502));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81230 = (function (){var G__81503 = ctx;
var G__81504 = bindings;
var G__81505 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81503,G__81504,G__81505) : sci.impl.evaluator.eval.call(null,G__81503,G__81504,G__81505));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81231 = (function (){var G__81506 = ctx;
var G__81507 = bindings;
var G__81508 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81506,G__81507,G__81508) : sci.impl.evaluator.eval.call(null,G__81506,G__81507,G__81508));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81232 = (function (){var G__81509 = ctx;
var G__81510 = bindings;
var G__81511 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81509,G__81510,G__81511) : sci.impl.evaluator.eval.call(null,G__81509,G__81510,G__81511));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81233 = (function (){var G__81512 = ctx;
var G__81513 = bindings;
var G__81514 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81512,G__81513,G__81514) : sci.impl.evaluator.eval.call(null,G__81512,G__81513,G__81514));
})();
var args__$8 = cljs.core.rest(args__$7);
return (f.cljs$core$IFn$_invoke$arity$8 ? f.cljs$core$IFn$_invoke$arity$8(arg81226,arg81227,arg81228,arg81229,arg81230,arg81231,arg81232,arg81233) : f.call(null,arg81226,arg81227,arg81228,arg81229,arg81230,arg81231,arg81232,arg81233));

break;
case (9):
var arg81234 = (function (){var G__81515 = ctx;
var G__81516 = bindings;
var G__81517 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81515,G__81516,G__81517) : sci.impl.evaluator.eval.call(null,G__81515,G__81516,G__81517));
})();
var args__$1 = cljs.core.rest(args);
var arg81235 = (function (){var G__81521 = ctx;
var G__81522 = bindings;
var G__81523 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81521,G__81522,G__81523) : sci.impl.evaluator.eval.call(null,G__81521,G__81522,G__81523));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81236 = (function (){var G__81528 = ctx;
var G__81529 = bindings;
var G__81530 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81528,G__81529,G__81530) : sci.impl.evaluator.eval.call(null,G__81528,G__81529,G__81530));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81237 = (function (){var G__81531 = ctx;
var G__81532 = bindings;
var G__81533 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81531,G__81532,G__81533) : sci.impl.evaluator.eval.call(null,G__81531,G__81532,G__81533));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81238 = (function (){var G__81534 = ctx;
var G__81535 = bindings;
var G__81536 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81534,G__81535,G__81536) : sci.impl.evaluator.eval.call(null,G__81534,G__81535,G__81536));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81239 = (function (){var G__81537 = ctx;
var G__81538 = bindings;
var G__81539 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81537,G__81538,G__81539) : sci.impl.evaluator.eval.call(null,G__81537,G__81538,G__81539));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81240 = (function (){var G__81540 = ctx;
var G__81541 = bindings;
var G__81542 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81540,G__81541,G__81542) : sci.impl.evaluator.eval.call(null,G__81540,G__81541,G__81542));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81241 = (function (){var G__81543 = ctx;
var G__81544 = bindings;
var G__81545 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81543,G__81544,G__81545) : sci.impl.evaluator.eval.call(null,G__81543,G__81544,G__81545));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81242 = (function (){var G__81546 = ctx;
var G__81547 = bindings;
var G__81548 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81546,G__81547,G__81548) : sci.impl.evaluator.eval.call(null,G__81546,G__81547,G__81548));
})();
var args__$9 = cljs.core.rest(args__$8);
return (f.cljs$core$IFn$_invoke$arity$9 ? f.cljs$core$IFn$_invoke$arity$9(arg81234,arg81235,arg81236,arg81237,arg81238,arg81239,arg81240,arg81241,arg81242) : f.call(null,arg81234,arg81235,arg81236,arg81237,arg81238,arg81239,arg81240,arg81241,arg81242));

break;
case (10):
var arg81243 = (function (){var G__81549 = ctx;
var G__81550 = bindings;
var G__81551 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81549,G__81550,G__81551) : sci.impl.evaluator.eval.call(null,G__81549,G__81550,G__81551));
})();
var args__$1 = cljs.core.rest(args);
var arg81244 = (function (){var G__81552 = ctx;
var G__81553 = bindings;
var G__81554 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81552,G__81553,G__81554) : sci.impl.evaluator.eval.call(null,G__81552,G__81553,G__81554));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81245 = (function (){var G__81555 = ctx;
var G__81556 = bindings;
var G__81557 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81555,G__81556,G__81557) : sci.impl.evaluator.eval.call(null,G__81555,G__81556,G__81557));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81246 = (function (){var G__81558 = ctx;
var G__81559 = bindings;
var G__81560 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81558,G__81559,G__81560) : sci.impl.evaluator.eval.call(null,G__81558,G__81559,G__81560));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81247 = (function (){var G__81561 = ctx;
var G__81562 = bindings;
var G__81563 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81561,G__81562,G__81563) : sci.impl.evaluator.eval.call(null,G__81561,G__81562,G__81563));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81248 = (function (){var G__81564 = ctx;
var G__81565 = bindings;
var G__81566 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81564,G__81565,G__81566) : sci.impl.evaluator.eval.call(null,G__81564,G__81565,G__81566));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81249 = (function (){var G__81570 = ctx;
var G__81571 = bindings;
var G__81572 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81570,G__81571,G__81572) : sci.impl.evaluator.eval.call(null,G__81570,G__81571,G__81572));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81250 = (function (){var G__81577 = ctx;
var G__81578 = bindings;
var G__81579 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81577,G__81578,G__81579) : sci.impl.evaluator.eval.call(null,G__81577,G__81578,G__81579));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81251 = (function (){var G__81580 = ctx;
var G__81581 = bindings;
var G__81582 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81580,G__81581,G__81582) : sci.impl.evaluator.eval.call(null,G__81580,G__81581,G__81582));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81252 = (function (){var G__81583 = ctx;
var G__81584 = bindings;
var G__81585 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81583,G__81584,G__81585) : sci.impl.evaluator.eval.call(null,G__81583,G__81584,G__81585));
})();
var args__$10 = cljs.core.rest(args__$9);
return (f.cljs$core$IFn$_invoke$arity$10 ? f.cljs$core$IFn$_invoke$arity$10(arg81243,arg81244,arg81245,arg81246,arg81247,arg81248,arg81249,arg81250,arg81251,arg81252) : f.call(null,arg81243,arg81244,arg81245,arg81246,arg81247,arg81248,arg81249,arg81250,arg81251,arg81252));

break;
case (11):
var arg81253 = (function (){var G__81586 = ctx;
var G__81587 = bindings;
var G__81588 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81586,G__81587,G__81588) : sci.impl.evaluator.eval.call(null,G__81586,G__81587,G__81588));
})();
var args__$1 = cljs.core.rest(args);
var arg81254 = (function (){var G__81589 = ctx;
var G__81590 = bindings;
var G__81591 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81589,G__81590,G__81591) : sci.impl.evaluator.eval.call(null,G__81589,G__81590,G__81591));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81255 = (function (){var G__81592 = ctx;
var G__81593 = bindings;
var G__81594 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81592,G__81593,G__81594) : sci.impl.evaluator.eval.call(null,G__81592,G__81593,G__81594));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81256 = (function (){var G__81595 = ctx;
var G__81596 = bindings;
var G__81597 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81595,G__81596,G__81597) : sci.impl.evaluator.eval.call(null,G__81595,G__81596,G__81597));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81257 = (function (){var G__81598 = ctx;
var G__81599 = bindings;
var G__81600 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81598,G__81599,G__81600) : sci.impl.evaluator.eval.call(null,G__81598,G__81599,G__81600));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81258 = (function (){var G__81601 = ctx;
var G__81602 = bindings;
var G__81603 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81601,G__81602,G__81603) : sci.impl.evaluator.eval.call(null,G__81601,G__81602,G__81603));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81259 = (function (){var G__81604 = ctx;
var G__81605 = bindings;
var G__81606 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81604,G__81605,G__81606) : sci.impl.evaluator.eval.call(null,G__81604,G__81605,G__81606));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81260 = (function (){var G__81607 = ctx;
var G__81608 = bindings;
var G__81609 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81607,G__81608,G__81609) : sci.impl.evaluator.eval.call(null,G__81607,G__81608,G__81609));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81261 = (function (){var G__81610 = ctx;
var G__81611 = bindings;
var G__81612 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81610,G__81611,G__81612) : sci.impl.evaluator.eval.call(null,G__81610,G__81611,G__81612));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81262 = (function (){var G__81613 = ctx;
var G__81614 = bindings;
var G__81615 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81613,G__81614,G__81615) : sci.impl.evaluator.eval.call(null,G__81613,G__81614,G__81615));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81263 = (function (){var G__81616 = ctx;
var G__81617 = bindings;
var G__81618 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81616,G__81617,G__81618) : sci.impl.evaluator.eval.call(null,G__81616,G__81617,G__81618));
})();
var args__$11 = cljs.core.rest(args__$10);
return (f.cljs$core$IFn$_invoke$arity$11 ? f.cljs$core$IFn$_invoke$arity$11(arg81253,arg81254,arg81255,arg81256,arg81257,arg81258,arg81259,arg81260,arg81261,arg81262,arg81263) : f.call(null,arg81253,arg81254,arg81255,arg81256,arg81257,arg81258,arg81259,arg81260,arg81261,arg81262,arg81263));

break;
case (12):
var arg81264 = (function (){var G__81621 = ctx;
var G__81622 = bindings;
var G__81623 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81621,G__81622,G__81623) : sci.impl.evaluator.eval.call(null,G__81621,G__81622,G__81623));
})();
var args__$1 = cljs.core.rest(args);
var arg81265 = (function (){var G__81624 = ctx;
var G__81625 = bindings;
var G__81626 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81624,G__81625,G__81626) : sci.impl.evaluator.eval.call(null,G__81624,G__81625,G__81626));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81266 = (function (){var G__81627 = ctx;
var G__81628 = bindings;
var G__81629 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81627,G__81628,G__81629) : sci.impl.evaluator.eval.call(null,G__81627,G__81628,G__81629));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81267 = (function (){var G__81630 = ctx;
var G__81631 = bindings;
var G__81632 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81630,G__81631,G__81632) : sci.impl.evaluator.eval.call(null,G__81630,G__81631,G__81632));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81268 = (function (){var G__81633 = ctx;
var G__81634 = bindings;
var G__81635 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81633,G__81634,G__81635) : sci.impl.evaluator.eval.call(null,G__81633,G__81634,G__81635));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81269 = (function (){var G__81636 = ctx;
var G__81637 = bindings;
var G__81638 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81636,G__81637,G__81638) : sci.impl.evaluator.eval.call(null,G__81636,G__81637,G__81638));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81270 = (function (){var G__81639 = ctx;
var G__81640 = bindings;
var G__81641 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81639,G__81640,G__81641) : sci.impl.evaluator.eval.call(null,G__81639,G__81640,G__81641));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81271 = (function (){var G__81642 = ctx;
var G__81643 = bindings;
var G__81644 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81642,G__81643,G__81644) : sci.impl.evaluator.eval.call(null,G__81642,G__81643,G__81644));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81272 = (function (){var G__81645 = ctx;
var G__81646 = bindings;
var G__81647 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81645,G__81646,G__81647) : sci.impl.evaluator.eval.call(null,G__81645,G__81646,G__81647));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81273 = (function (){var G__81648 = ctx;
var G__81649 = bindings;
var G__81650 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81648,G__81649,G__81650) : sci.impl.evaluator.eval.call(null,G__81648,G__81649,G__81650));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81274 = (function (){var G__81651 = ctx;
var G__81652 = bindings;
var G__81653 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81651,G__81652,G__81653) : sci.impl.evaluator.eval.call(null,G__81651,G__81652,G__81653));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81275 = (function (){var G__81656 = ctx;
var G__81657 = bindings;
var G__81658 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81656,G__81657,G__81658) : sci.impl.evaluator.eval.call(null,G__81656,G__81657,G__81658));
})();
var args__$12 = cljs.core.rest(args__$11);
return (f.cljs$core$IFn$_invoke$arity$12 ? f.cljs$core$IFn$_invoke$arity$12(arg81264,arg81265,arg81266,arg81267,arg81268,arg81269,arg81270,arg81271,arg81272,arg81273,arg81274,arg81275) : f.call(null,arg81264,arg81265,arg81266,arg81267,arg81268,arg81269,arg81270,arg81271,arg81272,arg81273,arg81274,arg81275));

break;
case (13):
var arg81276 = (function (){var G__81659 = ctx;
var G__81660 = bindings;
var G__81661 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81659,G__81660,G__81661) : sci.impl.evaluator.eval.call(null,G__81659,G__81660,G__81661));
})();
var args__$1 = cljs.core.rest(args);
var arg81277 = (function (){var G__81662 = ctx;
var G__81663 = bindings;
var G__81664 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81662,G__81663,G__81664) : sci.impl.evaluator.eval.call(null,G__81662,G__81663,G__81664));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81278 = (function (){var G__81665 = ctx;
var G__81666 = bindings;
var G__81667 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81665,G__81666,G__81667) : sci.impl.evaluator.eval.call(null,G__81665,G__81666,G__81667));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81279 = (function (){var G__81668 = ctx;
var G__81669 = bindings;
var G__81670 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81668,G__81669,G__81670) : sci.impl.evaluator.eval.call(null,G__81668,G__81669,G__81670));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81280 = (function (){var G__81671 = ctx;
var G__81672 = bindings;
var G__81673 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81671,G__81672,G__81673) : sci.impl.evaluator.eval.call(null,G__81671,G__81672,G__81673));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81281 = (function (){var G__81674 = ctx;
var G__81675 = bindings;
var G__81676 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81674,G__81675,G__81676) : sci.impl.evaluator.eval.call(null,G__81674,G__81675,G__81676));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81282 = (function (){var G__81677 = ctx;
var G__81678 = bindings;
var G__81679 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81677,G__81678,G__81679) : sci.impl.evaluator.eval.call(null,G__81677,G__81678,G__81679));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81283 = (function (){var G__81680 = ctx;
var G__81681 = bindings;
var G__81682 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81680,G__81681,G__81682) : sci.impl.evaluator.eval.call(null,G__81680,G__81681,G__81682));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81284 = (function (){var G__81683 = ctx;
var G__81684 = bindings;
var G__81685 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81683,G__81684,G__81685) : sci.impl.evaluator.eval.call(null,G__81683,G__81684,G__81685));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81285 = (function (){var G__81686 = ctx;
var G__81687 = bindings;
var G__81688 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81686,G__81687,G__81688) : sci.impl.evaluator.eval.call(null,G__81686,G__81687,G__81688));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81286 = (function (){var G__81689 = ctx;
var G__81690 = bindings;
var G__81691 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81689,G__81690,G__81691) : sci.impl.evaluator.eval.call(null,G__81689,G__81690,G__81691));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81287 = (function (){var G__81695 = ctx;
var G__81696 = bindings;
var G__81697 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81695,G__81696,G__81697) : sci.impl.evaluator.eval.call(null,G__81695,G__81696,G__81697));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81288 = (function (){var G__81699 = ctx;
var G__81700 = bindings;
var G__81701 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81699,G__81700,G__81701) : sci.impl.evaluator.eval.call(null,G__81699,G__81700,G__81701));
})();
var args__$13 = cljs.core.rest(args__$12);
return (f.cljs$core$IFn$_invoke$arity$13 ? f.cljs$core$IFn$_invoke$arity$13(arg81276,arg81277,arg81278,arg81279,arg81280,arg81281,arg81282,arg81283,arg81284,arg81285,arg81286,arg81287,arg81288) : f.call(null,arg81276,arg81277,arg81278,arg81279,arg81280,arg81281,arg81282,arg81283,arg81284,arg81285,arg81286,arg81287,arg81288));

break;
case (14):
var arg81289 = (function (){var G__81702 = ctx;
var G__81703 = bindings;
var G__81704 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81702,G__81703,G__81704) : sci.impl.evaluator.eval.call(null,G__81702,G__81703,G__81704));
})();
var args__$1 = cljs.core.rest(args);
var arg81290 = (function (){var G__81705 = ctx;
var G__81706 = bindings;
var G__81707 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81705,G__81706,G__81707) : sci.impl.evaluator.eval.call(null,G__81705,G__81706,G__81707));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81291 = (function (){var G__81708 = ctx;
var G__81709 = bindings;
var G__81710 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81708,G__81709,G__81710) : sci.impl.evaluator.eval.call(null,G__81708,G__81709,G__81710));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81292 = (function (){var G__81711 = ctx;
var G__81712 = bindings;
var G__81713 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81711,G__81712,G__81713) : sci.impl.evaluator.eval.call(null,G__81711,G__81712,G__81713));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81293 = (function (){var G__81714 = ctx;
var G__81715 = bindings;
var G__81716 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81714,G__81715,G__81716) : sci.impl.evaluator.eval.call(null,G__81714,G__81715,G__81716));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81294 = (function (){var G__81717 = ctx;
var G__81718 = bindings;
var G__81719 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81717,G__81718,G__81719) : sci.impl.evaluator.eval.call(null,G__81717,G__81718,G__81719));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81295 = (function (){var G__81720 = ctx;
var G__81721 = bindings;
var G__81722 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81720,G__81721,G__81722) : sci.impl.evaluator.eval.call(null,G__81720,G__81721,G__81722));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81296 = (function (){var G__81723 = ctx;
var G__81724 = bindings;
var G__81725 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81723,G__81724,G__81725) : sci.impl.evaluator.eval.call(null,G__81723,G__81724,G__81725));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81297 = (function (){var G__81726 = ctx;
var G__81727 = bindings;
var G__81728 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81726,G__81727,G__81728) : sci.impl.evaluator.eval.call(null,G__81726,G__81727,G__81728));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81298 = (function (){var G__81729 = ctx;
var G__81730 = bindings;
var G__81731 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81729,G__81730,G__81731) : sci.impl.evaluator.eval.call(null,G__81729,G__81730,G__81731));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81299 = (function (){var G__81736 = ctx;
var G__81737 = bindings;
var G__81738 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81736,G__81737,G__81738) : sci.impl.evaluator.eval.call(null,G__81736,G__81737,G__81738));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81300 = (function (){var G__81739 = ctx;
var G__81740 = bindings;
var G__81741 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81739,G__81740,G__81741) : sci.impl.evaluator.eval.call(null,G__81739,G__81740,G__81741));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81301 = (function (){var G__81742 = ctx;
var G__81743 = bindings;
var G__81744 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81742,G__81743,G__81744) : sci.impl.evaluator.eval.call(null,G__81742,G__81743,G__81744));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81302 = (function (){var G__81745 = ctx;
var G__81746 = bindings;
var G__81747 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81745,G__81746,G__81747) : sci.impl.evaluator.eval.call(null,G__81745,G__81746,G__81747));
})();
var args__$14 = cljs.core.rest(args__$13);
return (f.cljs$core$IFn$_invoke$arity$14 ? f.cljs$core$IFn$_invoke$arity$14(arg81289,arg81290,arg81291,arg81292,arg81293,arg81294,arg81295,arg81296,arg81297,arg81298,arg81299,arg81300,arg81301,arg81302) : f.call(null,arg81289,arg81290,arg81291,arg81292,arg81293,arg81294,arg81295,arg81296,arg81297,arg81298,arg81299,arg81300,arg81301,arg81302));

break;
case (15):
var arg81303 = (function (){var G__81748 = ctx;
var G__81749 = bindings;
var G__81750 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81748,G__81749,G__81750) : sci.impl.evaluator.eval.call(null,G__81748,G__81749,G__81750));
})();
var args__$1 = cljs.core.rest(args);
var arg81304 = (function (){var G__81751 = ctx;
var G__81752 = bindings;
var G__81753 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81751,G__81752,G__81753) : sci.impl.evaluator.eval.call(null,G__81751,G__81752,G__81753));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81305 = (function (){var G__81754 = ctx;
var G__81755 = bindings;
var G__81756 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81754,G__81755,G__81756) : sci.impl.evaluator.eval.call(null,G__81754,G__81755,G__81756));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81306 = (function (){var G__81757 = ctx;
var G__81758 = bindings;
var G__81759 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81757,G__81758,G__81759) : sci.impl.evaluator.eval.call(null,G__81757,G__81758,G__81759));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81307 = (function (){var G__81760 = ctx;
var G__81761 = bindings;
var G__81762 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81760,G__81761,G__81762) : sci.impl.evaluator.eval.call(null,G__81760,G__81761,G__81762));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81308 = (function (){var G__81763 = ctx;
var G__81764 = bindings;
var G__81765 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81763,G__81764,G__81765) : sci.impl.evaluator.eval.call(null,G__81763,G__81764,G__81765));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81309 = (function (){var G__81766 = ctx;
var G__81767 = bindings;
var G__81768 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81766,G__81767,G__81768) : sci.impl.evaluator.eval.call(null,G__81766,G__81767,G__81768));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81310 = (function (){var G__81769 = ctx;
var G__81770 = bindings;
var G__81771 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81769,G__81770,G__81771) : sci.impl.evaluator.eval.call(null,G__81769,G__81770,G__81771));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81311 = (function (){var G__81772 = ctx;
var G__81773 = bindings;
var G__81774 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81772,G__81773,G__81774) : sci.impl.evaluator.eval.call(null,G__81772,G__81773,G__81774));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81312 = (function (){var G__81775 = ctx;
var G__81776 = bindings;
var G__81777 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81775,G__81776,G__81777) : sci.impl.evaluator.eval.call(null,G__81775,G__81776,G__81777));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81313 = (function (){var G__81778 = ctx;
var G__81779 = bindings;
var G__81780 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81778,G__81779,G__81780) : sci.impl.evaluator.eval.call(null,G__81778,G__81779,G__81780));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81314 = (function (){var G__81781 = ctx;
var G__81782 = bindings;
var G__81783 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81781,G__81782,G__81783) : sci.impl.evaluator.eval.call(null,G__81781,G__81782,G__81783));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81315 = (function (){var G__81784 = ctx;
var G__81785 = bindings;
var G__81786 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81784,G__81785,G__81786) : sci.impl.evaluator.eval.call(null,G__81784,G__81785,G__81786));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81316 = (function (){var G__81787 = ctx;
var G__81788 = bindings;
var G__81789 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81787,G__81788,G__81789) : sci.impl.evaluator.eval.call(null,G__81787,G__81788,G__81789));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg81317 = (function (){var G__81790 = ctx;
var G__81791 = bindings;
var G__81792 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81790,G__81791,G__81792) : sci.impl.evaluator.eval.call(null,G__81790,G__81791,G__81792));
})();
var args__$15 = cljs.core.rest(args__$14);
return (f.cljs$core$IFn$_invoke$arity$15 ? f.cljs$core$IFn$_invoke$arity$15(arg81303,arg81304,arg81305,arg81306,arg81307,arg81308,arg81309,arg81310,arg81311,arg81312,arg81313,arg81314,arg81315,arg81316,arg81317) : f.call(null,arg81303,arg81304,arg81305,arg81306,arg81307,arg81308,arg81309,arg81310,arg81311,arg81312,arg81313,arg81314,arg81315,arg81316,arg81317));

break;
case (16):
var arg81318 = (function (){var G__81793 = ctx;
var G__81794 = bindings;
var G__81795 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81793,G__81794,G__81795) : sci.impl.evaluator.eval.call(null,G__81793,G__81794,G__81795));
})();
var args__$1 = cljs.core.rest(args);
var arg81319 = (function (){var G__81796 = ctx;
var G__81797 = bindings;
var G__81798 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81796,G__81797,G__81798) : sci.impl.evaluator.eval.call(null,G__81796,G__81797,G__81798));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81320 = (function (){var G__81799 = ctx;
var G__81800 = bindings;
var G__81801 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81799,G__81800,G__81801) : sci.impl.evaluator.eval.call(null,G__81799,G__81800,G__81801));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81321 = (function (){var G__81805 = ctx;
var G__81806 = bindings;
var G__81807 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81805,G__81806,G__81807) : sci.impl.evaluator.eval.call(null,G__81805,G__81806,G__81807));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81322 = (function (){var G__81808 = ctx;
var G__81809 = bindings;
var G__81810 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81808,G__81809,G__81810) : sci.impl.evaluator.eval.call(null,G__81808,G__81809,G__81810));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81323 = (function (){var G__81811 = ctx;
var G__81812 = bindings;
var G__81813 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81811,G__81812,G__81813) : sci.impl.evaluator.eval.call(null,G__81811,G__81812,G__81813));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81324 = (function (){var G__81814 = ctx;
var G__81815 = bindings;
var G__81816 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81814,G__81815,G__81816) : sci.impl.evaluator.eval.call(null,G__81814,G__81815,G__81816));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81325 = (function (){var G__81817 = ctx;
var G__81818 = bindings;
var G__81819 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81817,G__81818,G__81819) : sci.impl.evaluator.eval.call(null,G__81817,G__81818,G__81819));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81326 = (function (){var G__81820 = ctx;
var G__81821 = bindings;
var G__81822 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81820,G__81821,G__81822) : sci.impl.evaluator.eval.call(null,G__81820,G__81821,G__81822));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81327 = (function (){var G__81823 = ctx;
var G__81824 = bindings;
var G__81825 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81823,G__81824,G__81825) : sci.impl.evaluator.eval.call(null,G__81823,G__81824,G__81825));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81328 = (function (){var G__81826 = ctx;
var G__81827 = bindings;
var G__81828 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81826,G__81827,G__81828) : sci.impl.evaluator.eval.call(null,G__81826,G__81827,G__81828));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81329 = (function (){var G__81829 = ctx;
var G__81830 = bindings;
var G__81831 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81829,G__81830,G__81831) : sci.impl.evaluator.eval.call(null,G__81829,G__81830,G__81831));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81330 = (function (){var G__81832 = ctx;
var G__81833 = bindings;
var G__81834 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81832,G__81833,G__81834) : sci.impl.evaluator.eval.call(null,G__81832,G__81833,G__81834));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81331 = (function (){var G__81835 = ctx;
var G__81836 = bindings;
var G__81837 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81835,G__81836,G__81837) : sci.impl.evaluator.eval.call(null,G__81835,G__81836,G__81837));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg81332 = (function (){var G__81838 = ctx;
var G__81839 = bindings;
var G__81840 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81838,G__81839,G__81840) : sci.impl.evaluator.eval.call(null,G__81838,G__81839,G__81840));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg81333 = (function (){var G__81841 = ctx;
var G__81842 = bindings;
var G__81843 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81841,G__81842,G__81843) : sci.impl.evaluator.eval.call(null,G__81841,G__81842,G__81843));
})();
var args__$16 = cljs.core.rest(args__$15);
return (f.cljs$core$IFn$_invoke$arity$16 ? f.cljs$core$IFn$_invoke$arity$16(arg81318,arg81319,arg81320,arg81321,arg81322,arg81323,arg81324,arg81325,arg81326,arg81327,arg81328,arg81329,arg81330,arg81331,arg81332,arg81333) : f.call(null,arg81318,arg81319,arg81320,arg81321,arg81322,arg81323,arg81324,arg81325,arg81326,arg81327,arg81328,arg81329,arg81330,arg81331,arg81332,arg81333));

break;
case (17):
var arg81334 = (function (){var G__81844 = ctx;
var G__81845 = bindings;
var G__81846 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81844,G__81845,G__81846) : sci.impl.evaluator.eval.call(null,G__81844,G__81845,G__81846));
})();
var args__$1 = cljs.core.rest(args);
var arg81335 = (function (){var G__81847 = ctx;
var G__81848 = bindings;
var G__81849 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81847,G__81848,G__81849) : sci.impl.evaluator.eval.call(null,G__81847,G__81848,G__81849));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81336 = (function (){var G__81850 = ctx;
var G__81851 = bindings;
var G__81852 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81850,G__81851,G__81852) : sci.impl.evaluator.eval.call(null,G__81850,G__81851,G__81852));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81337 = (function (){var G__81853 = ctx;
var G__81854 = bindings;
var G__81855 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81853,G__81854,G__81855) : sci.impl.evaluator.eval.call(null,G__81853,G__81854,G__81855));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81338 = (function (){var G__81856 = ctx;
var G__81857 = bindings;
var G__81858 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81856,G__81857,G__81858) : sci.impl.evaluator.eval.call(null,G__81856,G__81857,G__81858));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81339 = (function (){var G__81859 = ctx;
var G__81860 = bindings;
var G__81861 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81859,G__81860,G__81861) : sci.impl.evaluator.eval.call(null,G__81859,G__81860,G__81861));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81340 = (function (){var G__81862 = ctx;
var G__81863 = bindings;
var G__81864 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81862,G__81863,G__81864) : sci.impl.evaluator.eval.call(null,G__81862,G__81863,G__81864));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81341 = (function (){var G__81865 = ctx;
var G__81866 = bindings;
var G__81867 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81865,G__81866,G__81867) : sci.impl.evaluator.eval.call(null,G__81865,G__81866,G__81867));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81342 = (function (){var G__81868 = ctx;
var G__81869 = bindings;
var G__81870 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81868,G__81869,G__81870) : sci.impl.evaluator.eval.call(null,G__81868,G__81869,G__81870));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81343 = (function (){var G__81871 = ctx;
var G__81872 = bindings;
var G__81873 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81871,G__81872,G__81873) : sci.impl.evaluator.eval.call(null,G__81871,G__81872,G__81873));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81344 = (function (){var G__81874 = ctx;
var G__81875 = bindings;
var G__81876 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81874,G__81875,G__81876) : sci.impl.evaluator.eval.call(null,G__81874,G__81875,G__81876));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81345 = (function (){var G__81877 = ctx;
var G__81878 = bindings;
var G__81879 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81877,G__81878,G__81879) : sci.impl.evaluator.eval.call(null,G__81877,G__81878,G__81879));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81346 = (function (){var G__81880 = ctx;
var G__81881 = bindings;
var G__81882 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81880,G__81881,G__81882) : sci.impl.evaluator.eval.call(null,G__81880,G__81881,G__81882));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81347 = (function (){var G__81883 = ctx;
var G__81884 = bindings;
var G__81885 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81883,G__81884,G__81885) : sci.impl.evaluator.eval.call(null,G__81883,G__81884,G__81885));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg81348 = (function (){var G__81886 = ctx;
var G__81887 = bindings;
var G__81888 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81886,G__81887,G__81888) : sci.impl.evaluator.eval.call(null,G__81886,G__81887,G__81888));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg81349 = (function (){var G__81889 = ctx;
var G__81890 = bindings;
var G__81891 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81889,G__81890,G__81891) : sci.impl.evaluator.eval.call(null,G__81889,G__81890,G__81891));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg81350 = (function (){var G__81892 = ctx;
var G__81893 = bindings;
var G__81894 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81892,G__81893,G__81894) : sci.impl.evaluator.eval.call(null,G__81892,G__81893,G__81894));
})();
var args__$17 = cljs.core.rest(args__$16);
return (f.cljs$core$IFn$_invoke$arity$17 ? f.cljs$core$IFn$_invoke$arity$17(arg81334,arg81335,arg81336,arg81337,arg81338,arg81339,arg81340,arg81341,arg81342,arg81343,arg81344,arg81345,arg81346,arg81347,arg81348,arg81349,arg81350) : f.call(null,arg81334,arg81335,arg81336,arg81337,arg81338,arg81339,arg81340,arg81341,arg81342,arg81343,arg81344,arg81345,arg81346,arg81347,arg81348,arg81349,arg81350));

break;
case (18):
var arg81351 = (function (){var G__81898 = ctx;
var G__81899 = bindings;
var G__81900 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81898,G__81899,G__81900) : sci.impl.evaluator.eval.call(null,G__81898,G__81899,G__81900));
})();
var args__$1 = cljs.core.rest(args);
var arg81352 = (function (){var G__81901 = ctx;
var G__81902 = bindings;
var G__81903 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81901,G__81902,G__81903) : sci.impl.evaluator.eval.call(null,G__81901,G__81902,G__81903));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81353 = (function (){var G__81904 = ctx;
var G__81905 = bindings;
var G__81906 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81904,G__81905,G__81906) : sci.impl.evaluator.eval.call(null,G__81904,G__81905,G__81906));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81354 = (function (){var G__81907 = ctx;
var G__81908 = bindings;
var G__81909 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81907,G__81908,G__81909) : sci.impl.evaluator.eval.call(null,G__81907,G__81908,G__81909));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81355 = (function (){var G__81910 = ctx;
var G__81912 = bindings;
var G__81913 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81910,G__81912,G__81913) : sci.impl.evaluator.eval.call(null,G__81910,G__81912,G__81913));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81356 = (function (){var G__81917 = ctx;
var G__81918 = bindings;
var G__81919 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81917,G__81918,G__81919) : sci.impl.evaluator.eval.call(null,G__81917,G__81918,G__81919));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81357 = (function (){var G__81921 = ctx;
var G__81922 = bindings;
var G__81923 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81921,G__81922,G__81923) : sci.impl.evaluator.eval.call(null,G__81921,G__81922,G__81923));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81358 = (function (){var G__81924 = ctx;
var G__81925 = bindings;
var G__81926 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81924,G__81925,G__81926) : sci.impl.evaluator.eval.call(null,G__81924,G__81925,G__81926));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81359 = (function (){var G__81930 = ctx;
var G__81931 = bindings;
var G__81932 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81930,G__81931,G__81932) : sci.impl.evaluator.eval.call(null,G__81930,G__81931,G__81932));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81360 = (function (){var G__81933 = ctx;
var G__81934 = bindings;
var G__81935 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81933,G__81934,G__81935) : sci.impl.evaluator.eval.call(null,G__81933,G__81934,G__81935));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81361 = (function (){var G__81936 = ctx;
var G__81937 = bindings;
var G__81938 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81936,G__81937,G__81938) : sci.impl.evaluator.eval.call(null,G__81936,G__81937,G__81938));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81362 = (function (){var G__81943 = ctx;
var G__81944 = bindings;
var G__81945 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81943,G__81944,G__81945) : sci.impl.evaluator.eval.call(null,G__81943,G__81944,G__81945));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81363 = (function (){var G__81947 = ctx;
var G__81948 = bindings;
var G__81949 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81947,G__81948,G__81949) : sci.impl.evaluator.eval.call(null,G__81947,G__81948,G__81949));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81364 = (function (){var G__81950 = ctx;
var G__81951 = bindings;
var G__81952 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81950,G__81951,G__81952) : sci.impl.evaluator.eval.call(null,G__81950,G__81951,G__81952));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg81365 = (function (){var G__81955 = ctx;
var G__81956 = bindings;
var G__81957 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81955,G__81956,G__81957) : sci.impl.evaluator.eval.call(null,G__81955,G__81956,G__81957));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg81366 = (function (){var G__81959 = ctx;
var G__81960 = bindings;
var G__81961 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81959,G__81960,G__81961) : sci.impl.evaluator.eval.call(null,G__81959,G__81960,G__81961));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg81367 = (function (){var G__81963 = ctx;
var G__81964 = bindings;
var G__81965 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81963,G__81964,G__81965) : sci.impl.evaluator.eval.call(null,G__81963,G__81964,G__81965));
})();
var args__$17 = cljs.core.rest(args__$16);
var arg81368 = (function (){var G__81966 = ctx;
var G__81967 = bindings;
var G__81968 = cljs.core.first(args__$17);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81966,G__81967,G__81968) : sci.impl.evaluator.eval.call(null,G__81966,G__81967,G__81968));
})();
var args__$18 = cljs.core.rest(args__$17);
return (f.cljs$core$IFn$_invoke$arity$18 ? f.cljs$core$IFn$_invoke$arity$18(arg81351,arg81352,arg81353,arg81354,arg81355,arg81356,arg81357,arg81358,arg81359,arg81360,arg81361,arg81362,arg81363,arg81364,arg81365,arg81366,arg81367,arg81368) : f.call(null,arg81351,arg81352,arg81353,arg81354,arg81355,arg81356,arg81357,arg81358,arg81359,arg81360,arg81361,arg81362,arg81363,arg81364,arg81365,arg81366,arg81367,arg81368));

break;
case (19):
var arg81369 = (function (){var G__81972 = ctx;
var G__81973 = bindings;
var G__81974 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81972,G__81973,G__81974) : sci.impl.evaluator.eval.call(null,G__81972,G__81973,G__81974));
})();
var args__$1 = cljs.core.rest(args);
var arg81370 = (function (){var G__81975 = ctx;
var G__81976 = bindings;
var G__81977 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81975,G__81976,G__81977) : sci.impl.evaluator.eval.call(null,G__81975,G__81976,G__81977));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg81371 = (function (){var G__81982 = ctx;
var G__81983 = bindings;
var G__81984 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81982,G__81983,G__81984) : sci.impl.evaluator.eval.call(null,G__81982,G__81983,G__81984));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg81372 = (function (){var G__81985 = ctx;
var G__81986 = bindings;
var G__81987 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81985,G__81986,G__81987) : sci.impl.evaluator.eval.call(null,G__81985,G__81986,G__81987));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg81373 = (function (){var G__81988 = ctx;
var G__81989 = bindings;
var G__81990 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81988,G__81989,G__81990) : sci.impl.evaluator.eval.call(null,G__81988,G__81989,G__81990));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg81374 = (function (){var G__81991 = ctx;
var G__81992 = bindings;
var G__81993 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81991,G__81992,G__81993) : sci.impl.evaluator.eval.call(null,G__81991,G__81992,G__81993));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg81375 = (function (){var G__81996 = ctx;
var G__81997 = bindings;
var G__81998 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81996,G__81997,G__81998) : sci.impl.evaluator.eval.call(null,G__81996,G__81997,G__81998));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg81376 = (function (){var G__81999 = ctx;
var G__82000 = bindings;
var G__82001 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__81999,G__82000,G__82001) : sci.impl.evaluator.eval.call(null,G__81999,G__82000,G__82001));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg81377 = (function (){var G__82002 = ctx;
var G__82003 = bindings;
var G__82004 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82002,G__82003,G__82004) : sci.impl.evaluator.eval.call(null,G__82002,G__82003,G__82004));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg81378 = (function (){var G__82005 = ctx;
var G__82006 = bindings;
var G__82007 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82005,G__82006,G__82007) : sci.impl.evaluator.eval.call(null,G__82005,G__82006,G__82007));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg81379 = (function (){var G__82014 = ctx;
var G__82015 = bindings;
var G__82016 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82014,G__82015,G__82016) : sci.impl.evaluator.eval.call(null,G__82014,G__82015,G__82016));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg81380 = (function (){var G__82021 = ctx;
var G__82022 = bindings;
var G__82023 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82021,G__82022,G__82023) : sci.impl.evaluator.eval.call(null,G__82021,G__82022,G__82023));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg81381 = (function (){var G__82026 = ctx;
var G__82027 = bindings;
var G__82028 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82026,G__82027,G__82028) : sci.impl.evaluator.eval.call(null,G__82026,G__82027,G__82028));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg81382 = (function (){var G__82036 = ctx;
var G__82037 = bindings;
var G__82038 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82036,G__82037,G__82038) : sci.impl.evaluator.eval.call(null,G__82036,G__82037,G__82038));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg81383 = (function (){var G__82045 = ctx;
var G__82046 = bindings;
var G__82047 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82045,G__82046,G__82047) : sci.impl.evaluator.eval.call(null,G__82045,G__82046,G__82047));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg81384 = (function (){var G__82056 = ctx;
var G__82057 = bindings;
var G__82058 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82056,G__82057,G__82058) : sci.impl.evaluator.eval.call(null,G__82056,G__82057,G__82058));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg81385 = (function (){var G__82063 = ctx;
var G__82064 = bindings;
var G__82065 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82063,G__82064,G__82065) : sci.impl.evaluator.eval.call(null,G__82063,G__82064,G__82065));
})();
var args__$17 = cljs.core.rest(args__$16);
var arg81386 = (function (){var G__82072 = ctx;
var G__82073 = bindings;
var G__82074 = cljs.core.first(args__$17);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82072,G__82073,G__82074) : sci.impl.evaluator.eval.call(null,G__82072,G__82073,G__82074));
})();
var args__$18 = cljs.core.rest(args__$17);
var arg81387 = (function (){var G__82079 = ctx;
var G__82080 = bindings;
var G__82081 = cljs.core.first(args__$18);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__82079,G__82080,G__82081) : sci.impl.evaluator.eval.call(null,G__82079,G__82080,G__82081));
})();
var args__$19 = cljs.core.rest(args__$18);
return (f.cljs$core$IFn$_invoke$arity$19 ? f.cljs$core$IFn$_invoke$arity$19(arg81369,arg81370,arg81371,arg81372,arg81373,arg81374,arg81375,arg81376,arg81377,arg81378,arg81379,arg81380,arg81381,arg81382,arg81383,arg81384,arg81385,arg81386,arg81387) : f.call(null,arg81369,arg81370,arg81371,arg81372,arg81373,arg81374,arg81375,arg81376,arg81377,arg81378,arg81379,arg81380,arg81381,arg81382,arg81383,arg81384,arg81385,arg81386,arg81387));

break;
default:
var args__$1 = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (p1__51583_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__51583_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__51583_SHARP_));
}),args);
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,args__$1);

}
});
sci.impl.evaluator.eval = (function sci$impl$evaluator$eval(ctx,bindings,expr){
try{if((expr instanceof sci.impl.types.EvalFn)){
var f = expr.f;
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(ctx,bindings) : f.call(null,ctx,bindings));
} else {
if((expr instanceof sci.impl.types.EvalVar)){
var v = expr.v;
return cljs.core._deref(v);
} else {
if((((expr == null))?false:(((!((expr == null))))?(((((expr.cljs$lang$protocol_mask$partition0$ & (1024))) || ((cljs.core.PROTOCOL_SENTINEL === expr.cljs$core$IMap$))))?true:(((!expr.cljs$lang$protocol_mask$partition0$))?cljs.core.native_satisfies_QMARK_(cljs.core.IMap,expr):false)):cljs.core.native_satisfies_QMARK_(cljs.core.IMap,expr)))){
return sci.impl.evaluator.eval_map(ctx,bindings,expr);
} else {
return expr;

}
}
}
}catch (e82109){if((e82109 instanceof Error)){
var e = e82109;
return sci.impl.utils.rethrow_with_location_of_node.cljs$core$IFn$_invoke$arity$4(ctx,bindings,e,expr);
} else {
throw e82109;

}
}});
cljs.core.vreset_BANG_(sci.impl.utils.eval_STAR_,sci.impl.evaluator.eval);

//# sourceMappingURL=sci.impl.evaluator.js.map
