import "./cljs_env.js";
goog.provide('sci.impl.fns');
sci.impl.fns.throw_arity = (function sci$impl$fns$throw_arity(ctx,nsm,fn_name,macro_QMARK_,args){
if(cljs.core.truth_(new cljs.core.Keyword(null,"disable-arity-checks","disable-arity-checks",1131364206).cljs$core$IFn$_invoke$arity$1(ctx))){
return null;
} else {
throw (new Error((function (){var actual_count = (cljs.core.truth_(macro_QMARK_)?(cljs.core.count(args) - (2)):cljs.core.count(args));
return ["Wrong number of args (",cljs.core.str.cljs$core$IFn$_invoke$arity$1(actual_count),") passed to: ",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(nsm),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_name)].join('')].join('');
})()));
}
});

/**
* @constructor
 * @implements {sci.impl.types.IBox}
*/
sci.impl.fns.Recur = (function (val){
this.val = val;
});
(sci.impl.fns.Recur.prototype.sci$impl$types$IBox$ = cljs.core.PROTOCOL_SENTINEL);

(sci.impl.fns.Recur.prototype.sci$impl$types$IBox$getVal$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.val;
}));

(sci.impl.fns.Recur.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"val","val",1769233139,null)], null);
}));

(sci.impl.fns.Recur.cljs$lang$type = true);

(sci.impl.fns.Recur.cljs$lang$ctorStr = "sci.impl.fns/Recur");

(sci.impl.fns.Recur.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"sci.impl.fns/Recur");
}));

/**
 * Positional factory function for sci.impl.fns/Recur.
 */
sci.impl.fns.__GT_Recur = (function sci$impl$fns$__GT_Recur(val){
return (new sci.impl.fns.Recur(val));
});

sci.impl.fns.fun = (function sci$impl$fns$fun(ctx,bindings,fn_body,fn_name,macro_QMARK_){
var bindings_fn = new cljs.core.Keyword(null,"bindings-fn","bindings-fn",300799951).cljs$core$IFn$_invoke$arity$1(fn_body);
var bindings__$1 = (bindings_fn.cljs$core$IFn$_invoke$arity$1 ? bindings_fn.cljs$core$IFn$_invoke$arity$1(bindings) : bindings_fn.call(null,bindings));
var fixed_arity = new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body);
var var_arg_name = new cljs.core.Keyword(null,"var-arg-name","var-arg-name",-1100024887).cljs$core$IFn$_invoke$arity$1(fn_body);
var params = new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(fn_body);
var body = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(fn_body);
var nsm = sci.impl.vars.current_ns_name();
var disable_arity_checks_QMARK_ = ctx.get(new cljs.core.Keyword(null,"disable-arity-checks","disable-arity-checks",1131364206));
var f = ((cljs.core.not(var_arg_name))?(function (){var G__82158 = (fixed_arity | (0));
switch (G__82158) {
case (0):
return (function sci$impl$fns$fun_$_arity_0(){
while(true){
var ret = sci.impl.evaluator.eval(ctx,bindings__$1,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
continue;
} else {
return ret;
}
break;
}
});

break;
case (1):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82162 = cljs.core._nth(params,(0));
return (function sci$impl$fns$fun_$_arity_1(G__82160){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82162,G__82160);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83335 = cljs.core._nth(recur_val,(0));
G__82160 = G__83335;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82165 = cljs.core._nth(params,(0));
return (function sci$impl$fns$fun_$_arity_1(G__82164){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((1),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82165,G__82164);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83336 = cljs.core._nth(recur_val,(0));
G__82164 = G__83336;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (2):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82169 = cljs.core._nth(params,(0));
var G__82170 = cljs.core._nth(params,(1));
return (function sci$impl$fns$fun_$_arity_2(G__82167,G__82168){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82169,G__82167);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82170,G__82168);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$3,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83337 = cljs.core._nth(recur_val,(0));
var G__83338 = cljs.core._nth(recur_val,(1));
G__82167 = G__83337;
G__82168 = G__83338;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82174 = cljs.core._nth(params,(0));
var G__82175 = cljs.core._nth(params,(1));
return (function sci$impl$fns$fun_$_arity_2(G__82172,G__82173){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82174,G__82172);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82175,G__82173);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$3,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83339 = cljs.core._nth(recur_val,(0));
var G__83340 = cljs.core._nth(recur_val,(1));
G__82172 = G__83339;
G__82173 = G__83340;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (3):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82182 = cljs.core._nth(params,(0));
var G__82183 = cljs.core._nth(params,(1));
var G__82184 = cljs.core._nth(params,(2));
return (function sci$impl$fns$fun_$_arity_3(G__82179,G__82180,G__82181){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82182,G__82179);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82183,G__82180);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82184,G__82181);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$4,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83341 = cljs.core._nth(recur_val,(0));
var G__83342 = cljs.core._nth(recur_val,(1));
var G__83343 = cljs.core._nth(recur_val,(2));
G__82179 = G__83341;
G__82180 = G__83342;
G__82181 = G__83343;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82189 = cljs.core._nth(params,(0));
var G__82190 = cljs.core._nth(params,(1));
var G__82191 = cljs.core._nth(params,(2));
return (function sci$impl$fns$fun_$_arity_3(G__82186,G__82187,G__82188){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82189,G__82186);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82190,G__82187);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82191,G__82188);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$4,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83344 = cljs.core._nth(recur_val,(0));
var G__83345 = cljs.core._nth(recur_val,(1));
var G__83346 = cljs.core._nth(recur_val,(2));
G__82186 = G__83344;
G__82187 = G__83345;
G__82188 = G__83346;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (4):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82197 = cljs.core._nth(params,(0));
var G__82198 = cljs.core._nth(params,(1));
var G__82199 = cljs.core._nth(params,(2));
var G__82200 = cljs.core._nth(params,(3));
return (function sci$impl$fns$fun_$_arity_4(G__82193,G__82194,G__82195,G__82196){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82197,G__82193);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82198,G__82194);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82199,G__82195);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82200,G__82196);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$5,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83351 = cljs.core._nth(recur_val,(0));
var G__83352 = cljs.core._nth(recur_val,(1));
var G__83353 = cljs.core._nth(recur_val,(2));
var G__83354 = cljs.core._nth(recur_val,(3));
G__82193 = G__83351;
G__82194 = G__83352;
G__82195 = G__83353;
G__82196 = G__83354;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82211 = cljs.core._nth(params,(0));
var G__82212 = cljs.core._nth(params,(1));
var G__82213 = cljs.core._nth(params,(2));
var G__82214 = cljs.core._nth(params,(3));
return (function sci$impl$fns$fun_$_arity_4(G__82207,G__82208,G__82209,G__82210){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((4),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82211,G__82207);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82212,G__82208);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82213,G__82209);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82214,G__82210);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$5,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83359 = cljs.core._nth(recur_val,(0));
var G__83360 = cljs.core._nth(recur_val,(1));
var G__83361 = cljs.core._nth(recur_val,(2));
var G__83362 = cljs.core._nth(recur_val,(3));
G__82207 = G__83359;
G__82208 = G__83360;
G__82209 = G__83361;
G__82210 = G__83362;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (5):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82223 = cljs.core._nth(params,(0));
var G__82224 = cljs.core._nth(params,(1));
var G__82225 = cljs.core._nth(params,(2));
var G__82226 = cljs.core._nth(params,(3));
var G__82227 = cljs.core._nth(params,(4));
return (function sci$impl$fns$fun_$_arity_5(G__82218,G__82219,G__82220,G__82221,G__82222){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82223,G__82218);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82224,G__82219);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82225,G__82220);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82226,G__82221);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82227,G__82222);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$6,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83367 = cljs.core._nth(recur_val,(0));
var G__83368 = cljs.core._nth(recur_val,(1));
var G__83369 = cljs.core._nth(recur_val,(2));
var G__83370 = cljs.core._nth(recur_val,(3));
var G__83371 = cljs.core._nth(recur_val,(4));
G__82218 = G__83367;
G__82219 = G__83368;
G__82220 = G__83369;
G__82221 = G__83370;
G__82222 = G__83371;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82235 = cljs.core._nth(params,(0));
var G__82236 = cljs.core._nth(params,(1));
var G__82237 = cljs.core._nth(params,(2));
var G__82238 = cljs.core._nth(params,(3));
var G__82239 = cljs.core._nth(params,(4));
return (function sci$impl$fns$fun_$_arity_5(G__82230,G__82231,G__82232,G__82233,G__82234){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((5),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82235,G__82230);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82236,G__82231);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82237,G__82232);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82238,G__82233);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82239,G__82234);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$6,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83378 = cljs.core._nth(recur_val,(0));
var G__83379 = cljs.core._nth(recur_val,(1));
var G__83380 = cljs.core._nth(recur_val,(2));
var G__83381 = cljs.core._nth(recur_val,(3));
var G__83382 = cljs.core._nth(recur_val,(4));
G__82230 = G__83378;
G__82231 = G__83379;
G__82232 = G__83380;
G__82233 = G__83381;
G__82234 = G__83382;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (6):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82247 = cljs.core._nth(params,(0));
var G__82248 = cljs.core._nth(params,(1));
var G__82250 = cljs.core._nth(params,(2));
var G__82251 = cljs.core._nth(params,(3));
var G__82252 = cljs.core._nth(params,(4));
var G__82253 = cljs.core._nth(params,(5));
return (function sci$impl$fns$fun_$_arity_6(G__82241,G__82242,G__82243,G__82244,G__82245,G__82246){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82247,G__82241);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82248,G__82242);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82250,G__82243);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82251,G__82244);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82252,G__82245);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82253,G__82246);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$7,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83387 = cljs.core._nth(recur_val,(0));
var G__83388 = cljs.core._nth(recur_val,(1));
var G__83389 = cljs.core._nth(recur_val,(2));
var G__83390 = cljs.core._nth(recur_val,(3));
var G__83391 = cljs.core._nth(recur_val,(4));
var G__83392 = cljs.core._nth(recur_val,(5));
G__82241 = G__83387;
G__82242 = G__83388;
G__82243 = G__83389;
G__82244 = G__83390;
G__82245 = G__83391;
G__82246 = G__83392;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82262 = cljs.core._nth(params,(0));
var G__82263 = cljs.core._nth(params,(1));
var G__82264 = cljs.core._nth(params,(2));
var G__82265 = cljs.core._nth(params,(3));
var G__82266 = cljs.core._nth(params,(4));
var G__82267 = cljs.core._nth(params,(5));
return (function sci$impl$fns$fun_$_arity_6(G__82256,G__82257,G__82258,G__82259,G__82260,G__82261){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((6),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82262,G__82256);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82263,G__82257);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82264,G__82258);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82265,G__82259);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82266,G__82260);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82267,G__82261);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$7,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83399 = cljs.core._nth(recur_val,(0));
var G__83400 = cljs.core._nth(recur_val,(1));
var G__83401 = cljs.core._nth(recur_val,(2));
var G__83402 = cljs.core._nth(recur_val,(3));
var G__83403 = cljs.core._nth(recur_val,(4));
var G__83404 = cljs.core._nth(recur_val,(5));
G__82256 = G__83399;
G__82257 = G__83400;
G__82258 = G__83401;
G__82259 = G__83402;
G__82260 = G__83403;
G__82261 = G__83404;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (7):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82275 = cljs.core._nth(params,(0));
var G__82276 = cljs.core._nth(params,(1));
var G__82277 = cljs.core._nth(params,(2));
var G__82278 = cljs.core._nth(params,(3));
var G__82279 = cljs.core._nth(params,(4));
var G__82280 = cljs.core._nth(params,(5));
var G__82281 = cljs.core._nth(params,(6));
return (function sci$impl$fns$fun_$_arity_7(G__82268,G__82269,G__82270,G__82271,G__82272,G__82273,G__82274){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82275,G__82268);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82276,G__82269);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82277,G__82270);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82278,G__82271);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82279,G__82272);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82280,G__82273);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82281,G__82274);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$8,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83405 = cljs.core._nth(recur_val,(0));
var G__83406 = cljs.core._nth(recur_val,(1));
var G__83407 = cljs.core._nth(recur_val,(2));
var G__83408 = cljs.core._nth(recur_val,(3));
var G__83409 = cljs.core._nth(recur_val,(4));
var G__83410 = cljs.core._nth(recur_val,(5));
var G__83411 = cljs.core._nth(recur_val,(6));
G__82268 = G__83405;
G__82269 = G__83406;
G__82270 = G__83407;
G__82271 = G__83408;
G__82272 = G__83409;
G__82273 = G__83410;
G__82274 = G__83411;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82290 = cljs.core._nth(params,(0));
var G__82291 = cljs.core._nth(params,(1));
var G__82292 = cljs.core._nth(params,(2));
var G__82293 = cljs.core._nth(params,(3));
var G__82294 = cljs.core._nth(params,(4));
var G__82295 = cljs.core._nth(params,(5));
var G__82296 = cljs.core._nth(params,(6));
return (function sci$impl$fns$fun_$_arity_7(G__82283,G__82284,G__82285,G__82286,G__82287,G__82288,G__82289){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((7),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82290,G__82283);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82291,G__82284);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82292,G__82285);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82293,G__82286);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82294,G__82287);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82295,G__82288);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82296,G__82289);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$8,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83412 = cljs.core._nth(recur_val,(0));
var G__83413 = cljs.core._nth(recur_val,(1));
var G__83414 = cljs.core._nth(recur_val,(2));
var G__83415 = cljs.core._nth(recur_val,(3));
var G__83416 = cljs.core._nth(recur_val,(4));
var G__83417 = cljs.core._nth(recur_val,(5));
var G__83418 = cljs.core._nth(recur_val,(6));
G__82283 = G__83412;
G__82284 = G__83413;
G__82285 = G__83414;
G__82286 = G__83415;
G__82287 = G__83416;
G__82288 = G__83417;
G__82289 = G__83418;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (8):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82308 = cljs.core._nth(params,(0));
var G__82309 = cljs.core._nth(params,(1));
var G__82310 = cljs.core._nth(params,(2));
var G__82311 = cljs.core._nth(params,(3));
var G__82312 = cljs.core._nth(params,(4));
var G__82313 = cljs.core._nth(params,(5));
var G__82314 = cljs.core._nth(params,(6));
var G__82315 = cljs.core._nth(params,(7));
return (function sci$impl$fns$fun_$_arity_8(G__82300,G__82301,G__82302,G__82303,G__82304,G__82305,G__82306,G__82307){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82308,G__82300);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82309,G__82301);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82310,G__82302);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82311,G__82303);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82312,G__82304);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82313,G__82305);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82314,G__82306);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82315,G__82307);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$9,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83423 = cljs.core._nth(recur_val,(0));
var G__83424 = cljs.core._nth(recur_val,(1));
var G__83425 = cljs.core._nth(recur_val,(2));
var G__83426 = cljs.core._nth(recur_val,(3));
var G__83427 = cljs.core._nth(recur_val,(4));
var G__83428 = cljs.core._nth(recur_val,(5));
var G__83429 = cljs.core._nth(recur_val,(6));
var G__83430 = cljs.core._nth(recur_val,(7));
G__82300 = G__83423;
G__82301 = G__83424;
G__82302 = G__83425;
G__82303 = G__83426;
G__82304 = G__83427;
G__82305 = G__83428;
G__82306 = G__83429;
G__82307 = G__83430;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82328 = cljs.core._nth(params,(0));
var G__82329 = cljs.core._nth(params,(1));
var G__82330 = cljs.core._nth(params,(2));
var G__82331 = cljs.core._nth(params,(3));
var G__82332 = cljs.core._nth(params,(4));
var G__82333 = cljs.core._nth(params,(5));
var G__82334 = cljs.core._nth(params,(6));
var G__82335 = cljs.core._nth(params,(7));
return (function sci$impl$fns$fun_$_arity_8(G__82320,G__82321,G__82322,G__82323,G__82324,G__82325,G__82326,G__82327){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((8),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82328,G__82320);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82329,G__82321);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82330,G__82322);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82331,G__82323);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82332,G__82324);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82333,G__82325);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82334,G__82326);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82335,G__82327);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$9,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83431 = cljs.core._nth(recur_val,(0));
var G__83432 = cljs.core._nth(recur_val,(1));
var G__83433 = cljs.core._nth(recur_val,(2));
var G__83434 = cljs.core._nth(recur_val,(3));
var G__83435 = cljs.core._nth(recur_val,(4));
var G__83436 = cljs.core._nth(recur_val,(5));
var G__83437 = cljs.core._nth(recur_val,(6));
var G__83438 = cljs.core._nth(recur_val,(7));
G__82320 = G__83431;
G__82321 = G__83432;
G__82322 = G__83433;
G__82323 = G__83434;
G__82324 = G__83435;
G__82325 = G__83436;
G__82326 = G__83437;
G__82327 = G__83438;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (9):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82355 = cljs.core._nth(params,(0));
var G__82356 = cljs.core._nth(params,(1));
var G__82357 = cljs.core._nth(params,(2));
var G__82358 = cljs.core._nth(params,(3));
var G__82359 = cljs.core._nth(params,(4));
var G__82360 = cljs.core._nth(params,(5));
var G__82361 = cljs.core._nth(params,(6));
var G__82362 = cljs.core._nth(params,(7));
var G__82363 = cljs.core._nth(params,(8));
return (function sci$impl$fns$fun_$_arity_9(G__82346,G__82347,G__82348,G__82349,G__82350,G__82351,G__82352,G__82353,G__82354){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82355,G__82346);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82356,G__82347);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82357,G__82348);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82358,G__82349);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82359,G__82350);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82360,G__82351);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82361,G__82352);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82362,G__82353);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82363,G__82354);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$10,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83439 = cljs.core._nth(recur_val,(0));
var G__83440 = cljs.core._nth(recur_val,(1));
var G__83441 = cljs.core._nth(recur_val,(2));
var G__83442 = cljs.core._nth(recur_val,(3));
var G__83443 = cljs.core._nth(recur_val,(4));
var G__83444 = cljs.core._nth(recur_val,(5));
var G__83445 = cljs.core._nth(recur_val,(6));
var G__83446 = cljs.core._nth(recur_val,(7));
var G__83447 = cljs.core._nth(recur_val,(8));
G__82346 = G__83439;
G__82347 = G__83440;
G__82348 = G__83441;
G__82349 = G__83442;
G__82350 = G__83443;
G__82351 = G__83444;
G__82352 = G__83445;
G__82353 = G__83446;
G__82354 = G__83447;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82373 = cljs.core._nth(params,(0));
var G__82374 = cljs.core._nth(params,(1));
var G__82375 = cljs.core._nth(params,(2));
var G__82376 = cljs.core._nth(params,(3));
var G__82377 = cljs.core._nth(params,(4));
var G__82378 = cljs.core._nth(params,(5));
var G__82379 = cljs.core._nth(params,(6));
var G__82380 = cljs.core._nth(params,(7));
var G__82381 = cljs.core._nth(params,(8));
return (function sci$impl$fns$fun_$_arity_9(G__82364,G__82365,G__82366,G__82367,G__82368,G__82369,G__82370,G__82371,G__82372){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((9),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82373,G__82364);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82374,G__82365);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82375,G__82366);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82376,G__82367);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82377,G__82368);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82378,G__82369);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82379,G__82370);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82380,G__82371);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82381,G__82372);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$10,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83452 = cljs.core._nth(recur_val,(0));
var G__83453 = cljs.core._nth(recur_val,(1));
var G__83454 = cljs.core._nth(recur_val,(2));
var G__83455 = cljs.core._nth(recur_val,(3));
var G__83456 = cljs.core._nth(recur_val,(4));
var G__83457 = cljs.core._nth(recur_val,(5));
var G__83458 = cljs.core._nth(recur_val,(6));
var G__83459 = cljs.core._nth(recur_val,(7));
var G__83460 = cljs.core._nth(recur_val,(8));
G__82364 = G__83452;
G__82365 = G__83453;
G__82366 = G__83454;
G__82367 = G__83455;
G__82368 = G__83456;
G__82369 = G__83457;
G__82370 = G__83458;
G__82371 = G__83459;
G__82372 = G__83460;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (10):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82398 = cljs.core._nth(params,(0));
var G__82399 = cljs.core._nth(params,(1));
var G__82400 = cljs.core._nth(params,(2));
var G__82401 = cljs.core._nth(params,(3));
var G__82402 = cljs.core._nth(params,(4));
var G__82403 = cljs.core._nth(params,(5));
var G__82404 = cljs.core._nth(params,(6));
var G__82405 = cljs.core._nth(params,(7));
var G__82406 = cljs.core._nth(params,(8));
var G__82407 = cljs.core._nth(params,(9));
return (function sci$impl$fns$fun_$_arity_10(G__82388,G__82389,G__82390,G__82391,G__82392,G__82393,G__82394,G__82395,G__82396,G__82397){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82398,G__82388);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82399,G__82389);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82400,G__82390);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82401,G__82391);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82402,G__82392);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82403,G__82393);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82404,G__82394);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82405,G__82395);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82406,G__82396);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82407,G__82397);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$11,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83464 = cljs.core._nth(recur_val,(0));
var G__83465 = cljs.core._nth(recur_val,(1));
var G__83466 = cljs.core._nth(recur_val,(2));
var G__83467 = cljs.core._nth(recur_val,(3));
var G__83468 = cljs.core._nth(recur_val,(4));
var G__83469 = cljs.core._nth(recur_val,(5));
var G__83470 = cljs.core._nth(recur_val,(6));
var G__83471 = cljs.core._nth(recur_val,(7));
var G__83472 = cljs.core._nth(recur_val,(8));
var G__83473 = cljs.core._nth(recur_val,(9));
G__82388 = G__83464;
G__82389 = G__83465;
G__82390 = G__83466;
G__82391 = G__83467;
G__82392 = G__83468;
G__82393 = G__83469;
G__82394 = G__83470;
G__82395 = G__83471;
G__82396 = G__83472;
G__82397 = G__83473;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82419 = cljs.core._nth(params,(0));
var G__82420 = cljs.core._nth(params,(1));
var G__82421 = cljs.core._nth(params,(2));
var G__82422 = cljs.core._nth(params,(3));
var G__82423 = cljs.core._nth(params,(4));
var G__82424 = cljs.core._nth(params,(5));
var G__82425 = cljs.core._nth(params,(6));
var G__82426 = cljs.core._nth(params,(7));
var G__82427 = cljs.core._nth(params,(8));
var G__82428 = cljs.core._nth(params,(9));
return (function sci$impl$fns$fun_$_arity_10(G__82409,G__82410,G__82411,G__82412,G__82413,G__82414,G__82415,G__82416,G__82417,G__82418){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((10),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82419,G__82409);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82420,G__82410);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82421,G__82411);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82422,G__82412);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82423,G__82413);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82424,G__82414);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82425,G__82415);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82426,G__82416);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82427,G__82417);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82428,G__82418);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$11,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83475 = cljs.core._nth(recur_val,(0));
var G__83476 = cljs.core._nth(recur_val,(1));
var G__83477 = cljs.core._nth(recur_val,(2));
var G__83478 = cljs.core._nth(recur_val,(3));
var G__83479 = cljs.core._nth(recur_val,(4));
var G__83480 = cljs.core._nth(recur_val,(5));
var G__83481 = cljs.core._nth(recur_val,(6));
var G__83482 = cljs.core._nth(recur_val,(7));
var G__83483 = cljs.core._nth(recur_val,(8));
var G__83484 = cljs.core._nth(recur_val,(9));
G__82409 = G__83475;
G__82410 = G__83476;
G__82411 = G__83477;
G__82412 = G__83478;
G__82413 = G__83479;
G__82414 = G__83480;
G__82415 = G__83481;
G__82416 = G__83482;
G__82417 = G__83483;
G__82418 = G__83484;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (11):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82443 = cljs.core._nth(params,(0));
var G__82444 = cljs.core._nth(params,(1));
var G__82445 = cljs.core._nth(params,(2));
var G__82446 = cljs.core._nth(params,(3));
var G__82447 = cljs.core._nth(params,(4));
var G__82448 = cljs.core._nth(params,(5));
var G__82449 = cljs.core._nth(params,(6));
var G__82450 = cljs.core._nth(params,(7));
var G__82451 = cljs.core._nth(params,(8));
var G__82452 = cljs.core._nth(params,(9));
var G__82453 = cljs.core._nth(params,(10));
return (function sci$impl$fns$fun_$_arity_11(G__82432,G__82433,G__82434,G__82435,G__82436,G__82437,G__82438,G__82439,G__82440,G__82441,G__82442){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82443,G__82432);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82444,G__82433);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82445,G__82434);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82446,G__82435);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82447,G__82436);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82448,G__82437);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82449,G__82438);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82450,G__82439);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82451,G__82440);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82452,G__82441);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82453,G__82442);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$12,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83486 = cljs.core._nth(recur_val,(0));
var G__83487 = cljs.core._nth(recur_val,(1));
var G__83488 = cljs.core._nth(recur_val,(2));
var G__83489 = cljs.core._nth(recur_val,(3));
var G__83490 = cljs.core._nth(recur_val,(4));
var G__83491 = cljs.core._nth(recur_val,(5));
var G__83492 = cljs.core._nth(recur_val,(6));
var G__83493 = cljs.core._nth(recur_val,(7));
var G__83494 = cljs.core._nth(recur_val,(8));
var G__83495 = cljs.core._nth(recur_val,(9));
var G__83496 = cljs.core._nth(recur_val,(10));
G__82432 = G__83486;
G__82433 = G__83487;
G__82434 = G__83488;
G__82435 = G__83489;
G__82436 = G__83490;
G__82437 = G__83491;
G__82438 = G__83492;
G__82439 = G__83493;
G__82440 = G__83494;
G__82441 = G__83495;
G__82442 = G__83496;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82465 = cljs.core._nth(params,(0));
var G__82467 = cljs.core._nth(params,(1));
var G__82468 = cljs.core._nth(params,(2));
var G__82469 = cljs.core._nth(params,(3));
var G__82473 = cljs.core._nth(params,(4));
var G__82474 = cljs.core._nth(params,(5));
var G__82475 = cljs.core._nth(params,(6));
var G__82476 = cljs.core._nth(params,(7));
var G__82477 = cljs.core._nth(params,(8));
var G__82478 = cljs.core._nth(params,(9));
var G__82479 = cljs.core._nth(params,(10));
return (function sci$impl$fns$fun_$_arity_11(G__82454,G__82455,G__82456,G__82457,G__82458,G__82459,G__82460,G__82461,G__82462,G__82463,G__82464){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((11),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82465,G__82454);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82467,G__82455);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82468,G__82456);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82469,G__82457);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82473,G__82458);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82474,G__82459);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82475,G__82460);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82476,G__82461);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82477,G__82462);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82478,G__82463);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82479,G__82464);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$12,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83497 = cljs.core._nth(recur_val,(0));
var G__83498 = cljs.core._nth(recur_val,(1));
var G__83499 = cljs.core._nth(recur_val,(2));
var G__83500 = cljs.core._nth(recur_val,(3));
var G__83501 = cljs.core._nth(recur_val,(4));
var G__83502 = cljs.core._nth(recur_val,(5));
var G__83503 = cljs.core._nth(recur_val,(6));
var G__83504 = cljs.core._nth(recur_val,(7));
var G__83505 = cljs.core._nth(recur_val,(8));
var G__83506 = cljs.core._nth(recur_val,(9));
var G__83507 = cljs.core._nth(recur_val,(10));
G__82454 = G__83497;
G__82455 = G__83498;
G__82456 = G__83499;
G__82457 = G__83500;
G__82458 = G__83501;
G__82459 = G__83502;
G__82460 = G__83503;
G__82461 = G__83504;
G__82462 = G__83505;
G__82463 = G__83506;
G__82464 = G__83507;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (12):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82503 = cljs.core._nth(params,(0));
var G__82504 = cljs.core._nth(params,(1));
var G__82505 = cljs.core._nth(params,(2));
var G__82506 = cljs.core._nth(params,(3));
var G__82507 = cljs.core._nth(params,(4));
var G__82508 = cljs.core._nth(params,(5));
var G__82509 = cljs.core._nth(params,(6));
var G__82510 = cljs.core._nth(params,(7));
var G__82511 = cljs.core._nth(params,(8));
var G__82512 = cljs.core._nth(params,(9));
var G__82513 = cljs.core._nth(params,(10));
var G__82514 = cljs.core._nth(params,(11));
return (function sci$impl$fns$fun_$_arity_12(G__82491,G__82492,G__82493,G__82494,G__82495,G__82496,G__82497,G__82498,G__82499,G__82500,G__82501,G__82502){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82503,G__82491);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82504,G__82492);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82505,G__82493);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82506,G__82494);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82507,G__82495);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82508,G__82496);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82509,G__82497);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82510,G__82498);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82511,G__82499);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82512,G__82500);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82513,G__82501);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82514,G__82502);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$13,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83511 = cljs.core._nth(recur_val,(0));
var G__83512 = cljs.core._nth(recur_val,(1));
var G__83513 = cljs.core._nth(recur_val,(2));
var G__83514 = cljs.core._nth(recur_val,(3));
var G__83515 = cljs.core._nth(recur_val,(4));
var G__83516 = cljs.core._nth(recur_val,(5));
var G__83517 = cljs.core._nth(recur_val,(6));
var G__83518 = cljs.core._nth(recur_val,(7));
var G__83519 = cljs.core._nth(recur_val,(8));
var G__83520 = cljs.core._nth(recur_val,(9));
var G__83521 = cljs.core._nth(recur_val,(10));
var G__83522 = cljs.core._nth(recur_val,(11));
G__82491 = G__83511;
G__82492 = G__83512;
G__82493 = G__83513;
G__82494 = G__83514;
G__82495 = G__83515;
G__82496 = G__83516;
G__82497 = G__83517;
G__82498 = G__83518;
G__82499 = G__83519;
G__82500 = G__83520;
G__82501 = G__83521;
G__82502 = G__83522;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82539 = cljs.core._nth(params,(0));
var G__82540 = cljs.core._nth(params,(1));
var G__82541 = cljs.core._nth(params,(2));
var G__82542 = cljs.core._nth(params,(3));
var G__82543 = cljs.core._nth(params,(4));
var G__82544 = cljs.core._nth(params,(5));
var G__82545 = cljs.core._nth(params,(6));
var G__82546 = cljs.core._nth(params,(7));
var G__82547 = cljs.core._nth(params,(8));
var G__82548 = cljs.core._nth(params,(9));
var G__82549 = cljs.core._nth(params,(10));
var G__82550 = cljs.core._nth(params,(11));
return (function sci$impl$fns$fun_$_arity_12(G__82527,G__82528,G__82529,G__82530,G__82531,G__82532,G__82533,G__82534,G__82535,G__82536,G__82537,G__82538){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((12),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82539,G__82527);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82540,G__82528);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82541,G__82529);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82542,G__82530);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82543,G__82531);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82544,G__82532);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82545,G__82533);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82546,G__82534);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82547,G__82535);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82548,G__82536);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82549,G__82537);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82550,G__82538);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$13,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83528 = cljs.core._nth(recur_val,(0));
var G__83529 = cljs.core._nth(recur_val,(1));
var G__83530 = cljs.core._nth(recur_val,(2));
var G__83531 = cljs.core._nth(recur_val,(3));
var G__83532 = cljs.core._nth(recur_val,(4));
var G__83533 = cljs.core._nth(recur_val,(5));
var G__83534 = cljs.core._nth(recur_val,(6));
var G__83535 = cljs.core._nth(recur_val,(7));
var G__83536 = cljs.core._nth(recur_val,(8));
var G__83537 = cljs.core._nth(recur_val,(9));
var G__83538 = cljs.core._nth(recur_val,(10));
var G__83539 = cljs.core._nth(recur_val,(11));
G__82527 = G__83528;
G__82528 = G__83529;
G__82529 = G__83530;
G__82530 = G__83531;
G__82531 = G__83532;
G__82532 = G__83533;
G__82533 = G__83534;
G__82534 = G__83535;
G__82535 = G__83536;
G__82536 = G__83537;
G__82537 = G__83538;
G__82538 = G__83539;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (13):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82569 = cljs.core._nth(params,(0));
var G__82570 = cljs.core._nth(params,(1));
var G__82571 = cljs.core._nth(params,(2));
var G__82572 = cljs.core._nth(params,(3));
var G__82573 = cljs.core._nth(params,(4));
var G__82574 = cljs.core._nth(params,(5));
var G__82575 = cljs.core._nth(params,(6));
var G__82576 = cljs.core._nth(params,(7));
var G__82577 = cljs.core._nth(params,(8));
var G__82578 = cljs.core._nth(params,(9));
var G__82579 = cljs.core._nth(params,(10));
var G__82580 = cljs.core._nth(params,(11));
var G__82581 = cljs.core._nth(params,(12));
return (function sci$impl$fns$fun_$_arity_13(G__82556,G__82557,G__82558,G__82559,G__82560,G__82561,G__82562,G__82563,G__82564,G__82565,G__82566,G__82567,G__82568){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82569,G__82556);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82570,G__82557);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82571,G__82558);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82572,G__82559);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82573,G__82560);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82574,G__82561);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82575,G__82562);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82576,G__82563);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82577,G__82564);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82578,G__82565);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82579,G__82566);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82580,G__82567);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82581,G__82568);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$14,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83546 = cljs.core._nth(recur_val,(0));
var G__83547 = cljs.core._nth(recur_val,(1));
var G__83548 = cljs.core._nth(recur_val,(2));
var G__83549 = cljs.core._nth(recur_val,(3));
var G__83550 = cljs.core._nth(recur_val,(4));
var G__83551 = cljs.core._nth(recur_val,(5));
var G__83552 = cljs.core._nth(recur_val,(6));
var G__83553 = cljs.core._nth(recur_val,(7));
var G__83554 = cljs.core._nth(recur_val,(8));
var G__83555 = cljs.core._nth(recur_val,(9));
var G__83556 = cljs.core._nth(recur_val,(10));
var G__83557 = cljs.core._nth(recur_val,(11));
var G__83558 = cljs.core._nth(recur_val,(12));
G__82556 = G__83546;
G__82557 = G__83547;
G__82558 = G__83548;
G__82559 = G__83549;
G__82560 = G__83550;
G__82561 = G__83551;
G__82562 = G__83552;
G__82563 = G__83553;
G__82564 = G__83554;
G__82565 = G__83555;
G__82566 = G__83556;
G__82567 = G__83557;
G__82568 = G__83558;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82600 = cljs.core._nth(params,(0));
var G__82601 = cljs.core._nth(params,(1));
var G__82602 = cljs.core._nth(params,(2));
var G__82603 = cljs.core._nth(params,(3));
var G__82604 = cljs.core._nth(params,(4));
var G__82605 = cljs.core._nth(params,(5));
var G__82606 = cljs.core._nth(params,(6));
var G__82607 = cljs.core._nth(params,(7));
var G__82608 = cljs.core._nth(params,(8));
var G__82609 = cljs.core._nth(params,(9));
var G__82610 = cljs.core._nth(params,(10));
var G__82611 = cljs.core._nth(params,(11));
var G__82612 = cljs.core._nth(params,(12));
return (function sci$impl$fns$fun_$_arity_13(G__82587,G__82588,G__82589,G__82590,G__82591,G__82592,G__82593,G__82594,G__82595,G__82596,G__82597,G__82598,G__82599){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((13),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82600,G__82587);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82601,G__82588);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82602,G__82589);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82603,G__82590);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82604,G__82591);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82605,G__82592);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82606,G__82593);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82607,G__82594);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82608,G__82595);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82609,G__82596);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82610,G__82597);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82611,G__82598);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82612,G__82599);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$14,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83564 = cljs.core._nth(recur_val,(0));
var G__83565 = cljs.core._nth(recur_val,(1));
var G__83566 = cljs.core._nth(recur_val,(2));
var G__83567 = cljs.core._nth(recur_val,(3));
var G__83568 = cljs.core._nth(recur_val,(4));
var G__83569 = cljs.core._nth(recur_val,(5));
var G__83570 = cljs.core._nth(recur_val,(6));
var G__83571 = cljs.core._nth(recur_val,(7));
var G__83572 = cljs.core._nth(recur_val,(8));
var G__83573 = cljs.core._nth(recur_val,(9));
var G__83574 = cljs.core._nth(recur_val,(10));
var G__83575 = cljs.core._nth(recur_val,(11));
var G__83576 = cljs.core._nth(recur_val,(12));
G__82587 = G__83564;
G__82588 = G__83565;
G__82589 = G__83566;
G__82590 = G__83567;
G__82591 = G__83568;
G__82592 = G__83569;
G__82593 = G__83570;
G__82594 = G__83571;
G__82595 = G__83572;
G__82596 = G__83573;
G__82597 = G__83574;
G__82598 = G__83575;
G__82599 = G__83576;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (14):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82630 = cljs.core._nth(params,(0));
var G__82631 = cljs.core._nth(params,(1));
var G__82632 = cljs.core._nth(params,(2));
var G__82633 = cljs.core._nth(params,(3));
var G__82634 = cljs.core._nth(params,(4));
var G__82635 = cljs.core._nth(params,(5));
var G__82636 = cljs.core._nth(params,(6));
var G__82637 = cljs.core._nth(params,(7));
var G__82638 = cljs.core._nth(params,(8));
var G__82639 = cljs.core._nth(params,(9));
var G__82640 = cljs.core._nth(params,(10));
var G__82641 = cljs.core._nth(params,(11));
var G__82642 = cljs.core._nth(params,(12));
var G__82643 = cljs.core._nth(params,(13));
var G__82644 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__82615,G__82616,G__82617,G__82618,G__82619,G__82620,G__82621,G__82622,G__82623,G__82624,G__82625,G__82626,G__82627,G__82628,G__82629){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82630,G__82615);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82631,G__82616);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82632,G__82617);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82633,G__82618);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82634,G__82619);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82635,G__82620);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82636,G__82621);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82637,G__82622);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82638,G__82623);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82639,G__82624);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82640,G__82625);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82641,G__82626);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82642,G__82627);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82643,G__82628);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82644,G__82629);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83580 = cljs.core._nth(recur_val,(0));
var G__83581 = cljs.core._nth(recur_val,(1));
var G__83582 = cljs.core._nth(recur_val,(2));
var G__83583 = cljs.core._nth(recur_val,(3));
var G__83584 = cljs.core._nth(recur_val,(4));
var G__83585 = cljs.core._nth(recur_val,(5));
var G__83586 = cljs.core._nth(recur_val,(6));
var G__83587 = cljs.core._nth(recur_val,(7));
var G__83588 = cljs.core._nth(recur_val,(8));
var G__83589 = cljs.core._nth(recur_val,(9));
var G__83590 = cljs.core._nth(recur_val,(10));
var G__83591 = cljs.core._nth(recur_val,(11));
var G__83592 = cljs.core._nth(recur_val,(12));
var G__83593 = cljs.core._nth(recur_val,(13));
var G__83594 = cljs.core._nth(recur_val,(14));
G__82615 = G__83580;
G__82616 = G__83581;
G__82617 = G__83582;
G__82618 = G__83583;
G__82619 = G__83584;
G__82620 = G__83585;
G__82621 = G__83586;
G__82622 = G__83587;
G__82623 = G__83588;
G__82624 = G__83589;
G__82625 = G__83590;
G__82626 = G__83591;
G__82627 = G__83592;
G__82628 = G__83593;
G__82629 = G__83594;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82666 = cljs.core._nth(params,(0));
var G__82667 = cljs.core._nth(params,(1));
var G__82668 = cljs.core._nth(params,(2));
var G__82669 = cljs.core._nth(params,(3));
var G__82670 = cljs.core._nth(params,(4));
var G__82671 = cljs.core._nth(params,(5));
var G__82672 = cljs.core._nth(params,(6));
var G__82673 = cljs.core._nth(params,(7));
var G__82674 = cljs.core._nth(params,(8));
var G__82675 = cljs.core._nth(params,(9));
var G__82676 = cljs.core._nth(params,(10));
var G__82677 = cljs.core._nth(params,(11));
var G__82678 = cljs.core._nth(params,(12));
var G__82679 = cljs.core._nth(params,(13));
var G__82680 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__82651,G__82652,G__82653,G__82654,G__82655,G__82656,G__82657,G__82658,G__82659,G__82660,G__82661,G__82662,G__82663,G__82664,G__82665){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((15),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82666,G__82651);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82667,G__82652);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82668,G__82653);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82669,G__82654);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82670,G__82655);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82671,G__82656);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82672,G__82657);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82673,G__82658);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82674,G__82659);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82675,G__82660);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82676,G__82661);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82677,G__82662);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82678,G__82663);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82679,G__82664);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82680,G__82665);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83613 = cljs.core._nth(recur_val,(0));
var G__83614 = cljs.core._nth(recur_val,(1));
var G__83615 = cljs.core._nth(recur_val,(2));
var G__83616 = cljs.core._nth(recur_val,(3));
var G__83617 = cljs.core._nth(recur_val,(4));
var G__83618 = cljs.core._nth(recur_val,(5));
var G__83619 = cljs.core._nth(recur_val,(6));
var G__83620 = cljs.core._nth(recur_val,(7));
var G__83621 = cljs.core._nth(recur_val,(8));
var G__83622 = cljs.core._nth(recur_val,(9));
var G__83623 = cljs.core._nth(recur_val,(10));
var G__83624 = cljs.core._nth(recur_val,(11));
var G__83625 = cljs.core._nth(recur_val,(12));
var G__83626 = cljs.core._nth(recur_val,(13));
var G__83627 = cljs.core._nth(recur_val,(14));
G__82651 = G__83613;
G__82652 = G__83614;
G__82653 = G__83615;
G__82654 = G__83616;
G__82655 = G__83617;
G__82656 = G__83618;
G__82657 = G__83619;
G__82658 = G__83620;
G__82659 = G__83621;
G__82660 = G__83622;
G__82661 = G__83623;
G__82662 = G__83624;
G__82663 = G__83625;
G__82664 = G__83626;
G__82665 = G__83627;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (15):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82703 = cljs.core._nth(params,(0));
var G__82704 = cljs.core._nth(params,(1));
var G__82705 = cljs.core._nth(params,(2));
var G__82706 = cljs.core._nth(params,(3));
var G__82707 = cljs.core._nth(params,(4));
var G__82708 = cljs.core._nth(params,(5));
var G__82709 = cljs.core._nth(params,(6));
var G__82710 = cljs.core._nth(params,(7));
var G__82711 = cljs.core._nth(params,(8));
var G__82712 = cljs.core._nth(params,(9));
var G__82713 = cljs.core._nth(params,(10));
var G__82714 = cljs.core._nth(params,(11));
var G__82715 = cljs.core._nth(params,(12));
var G__82716 = cljs.core._nth(params,(13));
var G__82717 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__82688,G__82689,G__82690,G__82691,G__82692,G__82693,G__82694,G__82695,G__82696,G__82697,G__82698,G__82699,G__82700,G__82701,G__82702){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82703,G__82688);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82704,G__82689);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82705,G__82690);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82706,G__82691);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82707,G__82692);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82708,G__82693);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82709,G__82694);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82710,G__82695);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82711,G__82696);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82712,G__82697);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82713,G__82698);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82714,G__82699);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82715,G__82700);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82716,G__82701);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82717,G__82702);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83639 = cljs.core._nth(recur_val,(0));
var G__83640 = cljs.core._nth(recur_val,(1));
var G__83641 = cljs.core._nth(recur_val,(2));
var G__83642 = cljs.core._nth(recur_val,(3));
var G__83643 = cljs.core._nth(recur_val,(4));
var G__83644 = cljs.core._nth(recur_val,(5));
var G__83645 = cljs.core._nth(recur_val,(6));
var G__83646 = cljs.core._nth(recur_val,(7));
var G__83647 = cljs.core._nth(recur_val,(8));
var G__83648 = cljs.core._nth(recur_val,(9));
var G__83649 = cljs.core._nth(recur_val,(10));
var G__83650 = cljs.core._nth(recur_val,(11));
var G__83651 = cljs.core._nth(recur_val,(12));
var G__83652 = cljs.core._nth(recur_val,(13));
var G__83653 = cljs.core._nth(recur_val,(14));
G__82688 = G__83639;
G__82689 = G__83640;
G__82690 = G__83641;
G__82691 = G__83642;
G__82692 = G__83643;
G__82693 = G__83644;
G__82694 = G__83645;
G__82695 = G__83646;
G__82696 = G__83647;
G__82697 = G__83648;
G__82698 = G__83649;
G__82699 = G__83650;
G__82700 = G__83651;
G__82701 = G__83652;
G__82702 = G__83653;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82783 = cljs.core._nth(params,(0));
var G__82784 = cljs.core._nth(params,(1));
var G__82785 = cljs.core._nth(params,(2));
var G__82786 = cljs.core._nth(params,(3));
var G__82787 = cljs.core._nth(params,(4));
var G__82788 = cljs.core._nth(params,(5));
var G__82789 = cljs.core._nth(params,(6));
var G__82790 = cljs.core._nth(params,(7));
var G__82791 = cljs.core._nth(params,(8));
var G__82792 = cljs.core._nth(params,(9));
var G__82793 = cljs.core._nth(params,(10));
var G__82794 = cljs.core._nth(params,(11));
var G__82795 = cljs.core._nth(params,(12));
var G__82796 = cljs.core._nth(params,(13));
var G__82797 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__82768,G__82769,G__82770,G__82771,G__82772,G__82773,G__82774,G__82775,G__82776,G__82777,G__82778,G__82779,G__82780,G__82781,G__82782){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((15),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82783,G__82768);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82784,G__82769);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82785,G__82770);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82786,G__82771);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82787,G__82772);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82788,G__82773);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82789,G__82774);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82790,G__82775);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82791,G__82776);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82792,G__82777);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82793,G__82778);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82794,G__82779);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82795,G__82780);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82796,G__82781);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82797,G__82782);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83658 = cljs.core._nth(recur_val,(0));
var G__83659 = cljs.core._nth(recur_val,(1));
var G__83660 = cljs.core._nth(recur_val,(2));
var G__83661 = cljs.core._nth(recur_val,(3));
var G__83662 = cljs.core._nth(recur_val,(4));
var G__83663 = cljs.core._nth(recur_val,(5));
var G__83664 = cljs.core._nth(recur_val,(6));
var G__83665 = cljs.core._nth(recur_val,(7));
var G__83666 = cljs.core._nth(recur_val,(8));
var G__83667 = cljs.core._nth(recur_val,(9));
var G__83668 = cljs.core._nth(recur_val,(10));
var G__83669 = cljs.core._nth(recur_val,(11));
var G__83670 = cljs.core._nth(recur_val,(12));
var G__83671 = cljs.core._nth(recur_val,(13));
var G__83672 = cljs.core._nth(recur_val,(14));
G__82768 = G__83658;
G__82769 = G__83659;
G__82770 = G__83660;
G__82771 = G__83661;
G__82772 = G__83662;
G__82773 = G__83663;
G__82774 = G__83664;
G__82775 = G__83665;
G__82776 = G__83666;
G__82777 = G__83667;
G__82778 = G__83668;
G__82779 = G__83669;
G__82780 = G__83670;
G__82781 = G__83671;
G__82782 = G__83672;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (16):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82818 = cljs.core._nth(params,(0));
var G__82819 = cljs.core._nth(params,(1));
var G__82820 = cljs.core._nth(params,(2));
var G__82821 = cljs.core._nth(params,(3));
var G__82822 = cljs.core._nth(params,(4));
var G__82823 = cljs.core._nth(params,(5));
var G__82824 = cljs.core._nth(params,(6));
var G__82825 = cljs.core._nth(params,(7));
var G__82826 = cljs.core._nth(params,(8));
var G__82827 = cljs.core._nth(params,(9));
var G__82828 = cljs.core._nth(params,(10));
var G__82829 = cljs.core._nth(params,(11));
var G__82830 = cljs.core._nth(params,(12));
var G__82831 = cljs.core._nth(params,(13));
var G__82832 = cljs.core._nth(params,(14));
var G__82833 = cljs.core._nth(params,(15));
return (function sci$impl$fns$fun_$_arity_16(G__82802,G__82803,G__82804,G__82805,G__82806,G__82807,G__82808,G__82809,G__82810,G__82811,G__82812,G__82813,G__82814,G__82815,G__82816,G__82817){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82818,G__82802);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82819,G__82803);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82820,G__82804);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82821,G__82805);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82822,G__82806);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82823,G__82807);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82824,G__82808);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82825,G__82809);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82826,G__82810);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82827,G__82811);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82828,G__82812);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82829,G__82813);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82830,G__82814);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82831,G__82815);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82832,G__82816);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__82833,G__82817);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$17,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83687 = cljs.core._nth(recur_val,(0));
var G__83688 = cljs.core._nth(recur_val,(1));
var G__83689 = cljs.core._nth(recur_val,(2));
var G__83690 = cljs.core._nth(recur_val,(3));
var G__83691 = cljs.core._nth(recur_val,(4));
var G__83692 = cljs.core._nth(recur_val,(5));
var G__83693 = cljs.core._nth(recur_val,(6));
var G__83694 = cljs.core._nth(recur_val,(7));
var G__83695 = cljs.core._nth(recur_val,(8));
var G__83696 = cljs.core._nth(recur_val,(9));
var G__83697 = cljs.core._nth(recur_val,(10));
var G__83698 = cljs.core._nth(recur_val,(11));
var G__83699 = cljs.core._nth(recur_val,(12));
var G__83700 = cljs.core._nth(recur_val,(13));
var G__83701 = cljs.core._nth(recur_val,(14));
var G__83702 = cljs.core._nth(recur_val,(15));
G__82802 = G__83687;
G__82803 = G__83688;
G__82804 = G__83689;
G__82805 = G__83690;
G__82806 = G__83691;
G__82807 = G__83692;
G__82808 = G__83693;
G__82809 = G__83694;
G__82810 = G__83695;
G__82811 = G__83696;
G__82812 = G__83697;
G__82813 = G__83698;
G__82814 = G__83699;
G__82815 = G__83700;
G__82816 = G__83701;
G__82817 = G__83702;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82878 = cljs.core._nth(params,(0));
var G__82879 = cljs.core._nth(params,(1));
var G__82880 = cljs.core._nth(params,(2));
var G__82881 = cljs.core._nth(params,(3));
var G__82882 = cljs.core._nth(params,(4));
var G__82883 = cljs.core._nth(params,(5));
var G__82884 = cljs.core._nth(params,(6));
var G__82885 = cljs.core._nth(params,(7));
var G__82886 = cljs.core._nth(params,(8));
var G__82887 = cljs.core._nth(params,(9));
var G__82888 = cljs.core._nth(params,(10));
var G__82889 = cljs.core._nth(params,(11));
var G__82890 = cljs.core._nth(params,(12));
var G__82891 = cljs.core._nth(params,(13));
var G__82892 = cljs.core._nth(params,(14));
var G__82893 = cljs.core._nth(params,(15));
return (function sci$impl$fns$fun_$_arity_16(G__82862,G__82863,G__82864,G__82865,G__82866,G__82867,G__82868,G__82869,G__82870,G__82871,G__82872,G__82873,G__82874,G__82875,G__82876,G__82877){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((16),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82878,G__82862);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82879,G__82863);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82880,G__82864);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82881,G__82865);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82882,G__82866);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82883,G__82867);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82884,G__82868);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82885,G__82869);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82886,G__82870);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82887,G__82871);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82888,G__82872);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82889,G__82873);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82890,G__82874);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82891,G__82875);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82892,G__82876);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__82893,G__82877);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$17,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83709 = cljs.core._nth(recur_val,(0));
var G__83710 = cljs.core._nth(recur_val,(1));
var G__83711 = cljs.core._nth(recur_val,(2));
var G__83712 = cljs.core._nth(recur_val,(3));
var G__83713 = cljs.core._nth(recur_val,(4));
var G__83714 = cljs.core._nth(recur_val,(5));
var G__83715 = cljs.core._nth(recur_val,(6));
var G__83716 = cljs.core._nth(recur_val,(7));
var G__83717 = cljs.core._nth(recur_val,(8));
var G__83718 = cljs.core._nth(recur_val,(9));
var G__83719 = cljs.core._nth(recur_val,(10));
var G__83720 = cljs.core._nth(recur_val,(11));
var G__83721 = cljs.core._nth(recur_val,(12));
var G__83722 = cljs.core._nth(recur_val,(13));
var G__83723 = cljs.core._nth(recur_val,(14));
var G__83724 = cljs.core._nth(recur_val,(15));
G__82862 = G__83709;
G__82863 = G__83710;
G__82864 = G__83711;
G__82865 = G__83712;
G__82866 = G__83713;
G__82867 = G__83714;
G__82868 = G__83715;
G__82869 = G__83716;
G__82870 = G__83717;
G__82871 = G__83718;
G__82872 = G__83719;
G__82873 = G__83720;
G__82874 = G__83721;
G__82875 = G__83722;
G__82876 = G__83723;
G__82877 = G__83724;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (17):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__82922 = cljs.core._nth(params,(0));
var G__82923 = cljs.core._nth(params,(1));
var G__82924 = cljs.core._nth(params,(2));
var G__82925 = cljs.core._nth(params,(3));
var G__82926 = cljs.core._nth(params,(4));
var G__82927 = cljs.core._nth(params,(5));
var G__82928 = cljs.core._nth(params,(6));
var G__82929 = cljs.core._nth(params,(7));
var G__82930 = cljs.core._nth(params,(8));
var G__82931 = cljs.core._nth(params,(9));
var G__82932 = cljs.core._nth(params,(10));
var G__82933 = cljs.core._nth(params,(11));
var G__82934 = cljs.core._nth(params,(12));
var G__82935 = cljs.core._nth(params,(13));
var G__82936 = cljs.core._nth(params,(14));
var G__82937 = cljs.core._nth(params,(15));
var G__82938 = cljs.core._nth(params,(16));
return (function sci$impl$fns$fun_$_arity_17(G__82905,G__82906,G__82907,G__82908,G__82909,G__82910,G__82911,G__82912,G__82913,G__82914,G__82915,G__82916,G__82917,G__82918,G__82919,G__82920,G__82921){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__82922,G__82905);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82923,G__82906);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82924,G__82907);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82925,G__82908);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82926,G__82909);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82927,G__82910);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82928,G__82911);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82929,G__82912);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82930,G__82913);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82931,G__82914);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82932,G__82915);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82933,G__82916);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82934,G__82917);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82935,G__82918);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82936,G__82919);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__82937,G__82920);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__82938,G__82921);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$18,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83739 = cljs.core._nth(recur_val,(0));
var G__83740 = cljs.core._nth(recur_val,(1));
var G__83741 = cljs.core._nth(recur_val,(2));
var G__83742 = cljs.core._nth(recur_val,(3));
var G__83743 = cljs.core._nth(recur_val,(4));
var G__83744 = cljs.core._nth(recur_val,(5));
var G__83745 = cljs.core._nth(recur_val,(6));
var G__83746 = cljs.core._nth(recur_val,(7));
var G__83747 = cljs.core._nth(recur_val,(8));
var G__83748 = cljs.core._nth(recur_val,(9));
var G__83749 = cljs.core._nth(recur_val,(10));
var G__83750 = cljs.core._nth(recur_val,(11));
var G__83751 = cljs.core._nth(recur_val,(12));
var G__83752 = cljs.core._nth(recur_val,(13));
var G__83753 = cljs.core._nth(recur_val,(14));
var G__83754 = cljs.core._nth(recur_val,(15));
var G__83755 = cljs.core._nth(recur_val,(16));
G__82905 = G__83739;
G__82906 = G__83740;
G__82907 = G__83741;
G__82908 = G__83742;
G__82909 = G__83743;
G__82910 = G__83744;
G__82911 = G__83745;
G__82912 = G__83746;
G__82913 = G__83747;
G__82914 = G__83748;
G__82915 = G__83749;
G__82916 = G__83750;
G__82917 = G__83751;
G__82918 = G__83752;
G__82919 = G__83753;
G__82920 = G__83754;
G__82921 = G__83755;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__82965 = cljs.core._nth(params,(0));
var G__82966 = cljs.core._nth(params,(1));
var G__82967 = cljs.core._nth(params,(2));
var G__82968 = cljs.core._nth(params,(3));
var G__82969 = cljs.core._nth(params,(4));
var G__82970 = cljs.core._nth(params,(5));
var G__82971 = cljs.core._nth(params,(6));
var G__82972 = cljs.core._nth(params,(7));
var G__82973 = cljs.core._nth(params,(8));
var G__82974 = cljs.core._nth(params,(9));
var G__82975 = cljs.core._nth(params,(10));
var G__82976 = cljs.core._nth(params,(11));
var G__82977 = cljs.core._nth(params,(12));
var G__82978 = cljs.core._nth(params,(13));
var G__82979 = cljs.core._nth(params,(14));
var G__82980 = cljs.core._nth(params,(15));
var G__82981 = cljs.core._nth(params,(16));
return (function sci$impl$fns$fun_$_arity_17(G__82948,G__82949,G__82950,G__82951,G__82952,G__82953,G__82954,G__82955,G__82956,G__82957,G__82958,G__82959,G__82960,G__82961,G__82962,G__82963,G__82964){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((17),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__82965,G__82948);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__82966,G__82949);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__82967,G__82950);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__82968,G__82951);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__82969,G__82952);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__82970,G__82953);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__82971,G__82954);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__82972,G__82955);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__82973,G__82956);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__82974,G__82957);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__82975,G__82958);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__82976,G__82959);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__82977,G__82960);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__82978,G__82961);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__82979,G__82962);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__82980,G__82963);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__82981,G__82964);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$18,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83772 = cljs.core._nth(recur_val,(0));
var G__83773 = cljs.core._nth(recur_val,(1));
var G__83774 = cljs.core._nth(recur_val,(2));
var G__83775 = cljs.core._nth(recur_val,(3));
var G__83776 = cljs.core._nth(recur_val,(4));
var G__83777 = cljs.core._nth(recur_val,(5));
var G__83778 = cljs.core._nth(recur_val,(6));
var G__83779 = cljs.core._nth(recur_val,(7));
var G__83780 = cljs.core._nth(recur_val,(8));
var G__83781 = cljs.core._nth(recur_val,(9));
var G__83782 = cljs.core._nth(recur_val,(10));
var G__83783 = cljs.core._nth(recur_val,(11));
var G__83784 = cljs.core._nth(recur_val,(12));
var G__83785 = cljs.core._nth(recur_val,(13));
var G__83786 = cljs.core._nth(recur_val,(14));
var G__83787 = cljs.core._nth(recur_val,(15));
var G__83788 = cljs.core._nth(recur_val,(16));
G__82948 = G__83772;
G__82949 = G__83773;
G__82950 = G__83774;
G__82951 = G__83775;
G__82952 = G__83776;
G__82953 = G__83777;
G__82954 = G__83778;
G__82955 = G__83779;
G__82956 = G__83780;
G__82957 = G__83781;
G__82958 = G__83782;
G__82959 = G__83783;
G__82960 = G__83784;
G__82961 = G__83785;
G__82962 = G__83786;
G__82963 = G__83787;
G__82964 = G__83788;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (18):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__83012 = cljs.core._nth(params,(0));
var G__83013 = cljs.core._nth(params,(1));
var G__83014 = cljs.core._nth(params,(2));
var G__83015 = cljs.core._nth(params,(3));
var G__83016 = cljs.core._nth(params,(4));
var G__83017 = cljs.core._nth(params,(5));
var G__83018 = cljs.core._nth(params,(6));
var G__83019 = cljs.core._nth(params,(7));
var G__83020 = cljs.core._nth(params,(8));
var G__83021 = cljs.core._nth(params,(9));
var G__83022 = cljs.core._nth(params,(10));
var G__83023 = cljs.core._nth(params,(11));
var G__83024 = cljs.core._nth(params,(12));
var G__83025 = cljs.core._nth(params,(13));
var G__83026 = cljs.core._nth(params,(14));
var G__83027 = cljs.core._nth(params,(15));
var G__83028 = cljs.core._nth(params,(16));
var G__83029 = cljs.core._nth(params,(17));
return (function sci$impl$fns$fun_$_arity_18(G__82994,G__82995,G__82996,G__82997,G__82998,G__82999,G__83000,G__83001,G__83002,G__83003,G__83004,G__83005,G__83006,G__83007,G__83008,G__83009,G__83010,G__83011){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__83012,G__82994);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83013,G__82995);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83014,G__82996);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83015,G__82997);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83016,G__82998);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83017,G__82999);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83018,G__83000);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83019,G__83001);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83020,G__83002);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83021,G__83003);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83022,G__83004);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83023,G__83005);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83024,G__83006);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83025,G__83007);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83026,G__83008);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83027,G__83009);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83028,G__83010);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83029,G__83011);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$19,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83801 = cljs.core._nth(recur_val,(0));
var G__83802 = cljs.core._nth(recur_val,(1));
var G__83803 = cljs.core._nth(recur_val,(2));
var G__83804 = cljs.core._nth(recur_val,(3));
var G__83805 = cljs.core._nth(recur_val,(4));
var G__83806 = cljs.core._nth(recur_val,(5));
var G__83807 = cljs.core._nth(recur_val,(6));
var G__83808 = cljs.core._nth(recur_val,(7));
var G__83809 = cljs.core._nth(recur_val,(8));
var G__83810 = cljs.core._nth(recur_val,(9));
var G__83811 = cljs.core._nth(recur_val,(10));
var G__83812 = cljs.core._nth(recur_val,(11));
var G__83813 = cljs.core._nth(recur_val,(12));
var G__83814 = cljs.core._nth(recur_val,(13));
var G__83815 = cljs.core._nth(recur_val,(14));
var G__83816 = cljs.core._nth(recur_val,(15));
var G__83817 = cljs.core._nth(recur_val,(16));
var G__83818 = cljs.core._nth(recur_val,(17));
G__82994 = G__83801;
G__82995 = G__83802;
G__82996 = G__83803;
G__82997 = G__83804;
G__82998 = G__83805;
G__82999 = G__83806;
G__83000 = G__83807;
G__83001 = G__83808;
G__83002 = G__83809;
G__83003 = G__83810;
G__83004 = G__83811;
G__83005 = G__83812;
G__83006 = G__83813;
G__83007 = G__83814;
G__83008 = G__83815;
G__83009 = G__83816;
G__83010 = G__83817;
G__83011 = G__83818;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__83059 = cljs.core._nth(params,(0));
var G__83060 = cljs.core._nth(params,(1));
var G__83061 = cljs.core._nth(params,(2));
var G__83062 = cljs.core._nth(params,(3));
var G__83063 = cljs.core._nth(params,(4));
var G__83064 = cljs.core._nth(params,(5));
var G__83065 = cljs.core._nth(params,(6));
var G__83066 = cljs.core._nth(params,(7));
var G__83067 = cljs.core._nth(params,(8));
var G__83068 = cljs.core._nth(params,(9));
var G__83069 = cljs.core._nth(params,(10));
var G__83070 = cljs.core._nth(params,(11));
var G__83071 = cljs.core._nth(params,(12));
var G__83072 = cljs.core._nth(params,(13));
var G__83073 = cljs.core._nth(params,(14));
var G__83074 = cljs.core._nth(params,(15));
var G__83075 = cljs.core._nth(params,(16));
var G__83076 = cljs.core._nth(params,(17));
return (function sci$impl$fns$fun_$_arity_18(G__83041,G__83042,G__83043,G__83044,G__83045,G__83046,G__83047,G__83048,G__83049,G__83050,G__83051,G__83052,G__83053,G__83054,G__83055,G__83056,G__83057,G__83058){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((18),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__83059,G__83041);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83060,G__83042);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83061,G__83043);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83062,G__83044);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83063,G__83045);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83064,G__83046);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83065,G__83047);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83066,G__83048);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83067,G__83049);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83068,G__83050);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83069,G__83051);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83070,G__83052);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83071,G__83053);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83072,G__83054);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83073,G__83055);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83074,G__83056);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83075,G__83057);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83076,G__83058);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$19,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83829 = cljs.core._nth(recur_val,(0));
var G__83830 = cljs.core._nth(recur_val,(1));
var G__83831 = cljs.core._nth(recur_val,(2));
var G__83832 = cljs.core._nth(recur_val,(3));
var G__83833 = cljs.core._nth(recur_val,(4));
var G__83834 = cljs.core._nth(recur_val,(5));
var G__83835 = cljs.core._nth(recur_val,(6));
var G__83836 = cljs.core._nth(recur_val,(7));
var G__83837 = cljs.core._nth(recur_val,(8));
var G__83838 = cljs.core._nth(recur_val,(9));
var G__83839 = cljs.core._nth(recur_val,(10));
var G__83840 = cljs.core._nth(recur_val,(11));
var G__83841 = cljs.core._nth(recur_val,(12));
var G__83842 = cljs.core._nth(recur_val,(13));
var G__83843 = cljs.core._nth(recur_val,(14));
var G__83844 = cljs.core._nth(recur_val,(15));
var G__83845 = cljs.core._nth(recur_val,(16));
var G__83846 = cljs.core._nth(recur_val,(17));
G__83041 = G__83829;
G__83042 = G__83830;
G__83043 = G__83831;
G__83044 = G__83832;
G__83045 = G__83833;
G__83046 = G__83834;
G__83047 = G__83835;
G__83048 = G__83836;
G__83049 = G__83837;
G__83050 = G__83838;
G__83051 = G__83839;
G__83052 = G__83840;
G__83053 = G__83841;
G__83054 = G__83842;
G__83055 = G__83843;
G__83056 = G__83844;
G__83057 = G__83845;
G__83058 = G__83846;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (19):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__83103 = cljs.core._nth(params,(0));
var G__83104 = cljs.core._nth(params,(1));
var G__83105 = cljs.core._nth(params,(2));
var G__83106 = cljs.core._nth(params,(3));
var G__83107 = cljs.core._nth(params,(4));
var G__83108 = cljs.core._nth(params,(5));
var G__83109 = cljs.core._nth(params,(6));
var G__83110 = cljs.core._nth(params,(7));
var G__83111 = cljs.core._nth(params,(8));
var G__83112 = cljs.core._nth(params,(9));
var G__83113 = cljs.core._nth(params,(10));
var G__83114 = cljs.core._nth(params,(11));
var G__83115 = cljs.core._nth(params,(12));
var G__83116 = cljs.core._nth(params,(13));
var G__83117 = cljs.core._nth(params,(14));
var G__83118 = cljs.core._nth(params,(15));
var G__83119 = cljs.core._nth(params,(16));
var G__83120 = cljs.core._nth(params,(17));
var G__83121 = cljs.core._nth(params,(18));
return (function sci$impl$fns$fun_$_arity_19(G__83084,G__83085,G__83086,G__83087,G__83088,G__83089,G__83090,G__83091,G__83092,G__83093,G__83094,G__83095,G__83096,G__83097,G__83098,G__83099,G__83100,G__83101,G__83102){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__83103,G__83084);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83104,G__83085);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83105,G__83086);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83106,G__83087);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83107,G__83088);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83108,G__83089);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83109,G__83090);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83110,G__83091);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83111,G__83092);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83112,G__83093);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83113,G__83094);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83114,G__83095);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83115,G__83096);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83116,G__83097);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83117,G__83098);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83118,G__83099);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83119,G__83100);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83120,G__83101);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__83121,G__83102);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$20,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83856 = cljs.core._nth(recur_val,(0));
var G__83857 = cljs.core._nth(recur_val,(1));
var G__83858 = cljs.core._nth(recur_val,(2));
var G__83859 = cljs.core._nth(recur_val,(3));
var G__83860 = cljs.core._nth(recur_val,(4));
var G__83861 = cljs.core._nth(recur_val,(5));
var G__83862 = cljs.core._nth(recur_val,(6));
var G__83863 = cljs.core._nth(recur_val,(7));
var G__83864 = cljs.core._nth(recur_val,(8));
var G__83865 = cljs.core._nth(recur_val,(9));
var G__83866 = cljs.core._nth(recur_val,(10));
var G__83867 = cljs.core._nth(recur_val,(11));
var G__83868 = cljs.core._nth(recur_val,(12));
var G__83869 = cljs.core._nth(recur_val,(13));
var G__83870 = cljs.core._nth(recur_val,(14));
var G__83871 = cljs.core._nth(recur_val,(15));
var G__83872 = cljs.core._nth(recur_val,(16));
var G__83873 = cljs.core._nth(recur_val,(17));
var G__83874 = cljs.core._nth(recur_val,(18));
G__83084 = G__83856;
G__83085 = G__83857;
G__83086 = G__83858;
G__83087 = G__83859;
G__83088 = G__83860;
G__83089 = G__83861;
G__83090 = G__83862;
G__83091 = G__83863;
G__83092 = G__83864;
G__83093 = G__83865;
G__83094 = G__83866;
G__83095 = G__83867;
G__83096 = G__83868;
G__83097 = G__83869;
G__83098 = G__83870;
G__83099 = G__83871;
G__83100 = G__83872;
G__83101 = G__83873;
G__83102 = G__83874;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__83175 = cljs.core._nth(params,(0));
var G__83176 = cljs.core._nth(params,(1));
var G__83177 = cljs.core._nth(params,(2));
var G__83178 = cljs.core._nth(params,(3));
var G__83179 = cljs.core._nth(params,(4));
var G__83180 = cljs.core._nth(params,(5));
var G__83181 = cljs.core._nth(params,(6));
var G__83182 = cljs.core._nth(params,(7));
var G__83183 = cljs.core._nth(params,(8));
var G__83184 = cljs.core._nth(params,(9));
var G__83185 = cljs.core._nth(params,(10));
var G__83186 = cljs.core._nth(params,(11));
var G__83187 = cljs.core._nth(params,(12));
var G__83188 = cljs.core._nth(params,(13));
var G__83189 = cljs.core._nth(params,(14));
var G__83190 = cljs.core._nth(params,(15));
var G__83191 = cljs.core._nth(params,(16));
var G__83192 = cljs.core._nth(params,(17));
var G__83193 = cljs.core._nth(params,(18));
return (function sci$impl$fns$fun_$_arity_19(G__83156,G__83157,G__83158,G__83159,G__83160,G__83161,G__83162,G__83163,G__83164,G__83165,G__83166,G__83167,G__83168,G__83169,G__83170,G__83171,G__83172,G__83173,G__83174){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((19),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__83175,G__83156);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83176,G__83157);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83177,G__83158);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83178,G__83159);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83179,G__83160);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83180,G__83161);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83181,G__83162);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83182,G__83163);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83183,G__83164);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83184,G__83165);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83185,G__83166);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83186,G__83167);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83187,G__83168);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83188,G__83169);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83189,G__83170);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83190,G__83171);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83191,G__83172);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83192,G__83173);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__83193,G__83174);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$20,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83883 = cljs.core._nth(recur_val,(0));
var G__83884 = cljs.core._nth(recur_val,(1));
var G__83885 = cljs.core._nth(recur_val,(2));
var G__83886 = cljs.core._nth(recur_val,(3));
var G__83887 = cljs.core._nth(recur_val,(4));
var G__83888 = cljs.core._nth(recur_val,(5));
var G__83889 = cljs.core._nth(recur_val,(6));
var G__83890 = cljs.core._nth(recur_val,(7));
var G__83891 = cljs.core._nth(recur_val,(8));
var G__83892 = cljs.core._nth(recur_val,(9));
var G__83893 = cljs.core._nth(recur_val,(10));
var G__83894 = cljs.core._nth(recur_val,(11));
var G__83895 = cljs.core._nth(recur_val,(12));
var G__83896 = cljs.core._nth(recur_val,(13));
var G__83897 = cljs.core._nth(recur_val,(14));
var G__83898 = cljs.core._nth(recur_val,(15));
var G__83899 = cljs.core._nth(recur_val,(16));
var G__83900 = cljs.core._nth(recur_val,(17));
var G__83901 = cljs.core._nth(recur_val,(18));
G__83156 = G__83883;
G__83157 = G__83884;
G__83158 = G__83885;
G__83159 = G__83886;
G__83160 = G__83887;
G__83161 = G__83888;
G__83162 = G__83889;
G__83163 = G__83890;
G__83164 = G__83891;
G__83165 = G__83892;
G__83166 = G__83893;
G__83167 = G__83894;
G__83168 = G__83895;
G__83169 = G__83896;
G__83170 = G__83897;
G__83171 = G__83898;
G__83172 = G__83899;
G__83173 = G__83900;
G__83174 = G__83901;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
case (20):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__83235 = cljs.core._nth(params,(0));
var G__83236 = cljs.core._nth(params,(1));
var G__83237 = cljs.core._nth(params,(2));
var G__83238 = cljs.core._nth(params,(3));
var G__83239 = cljs.core._nth(params,(4));
var G__83240 = cljs.core._nth(params,(5));
var G__83241 = cljs.core._nth(params,(6));
var G__83242 = cljs.core._nth(params,(7));
var G__83243 = cljs.core._nth(params,(8));
var G__83244 = cljs.core._nth(params,(9));
var G__83245 = cljs.core._nth(params,(10));
var G__83246 = cljs.core._nth(params,(11));
var G__83247 = cljs.core._nth(params,(12));
var G__83248 = cljs.core._nth(params,(13));
var G__83249 = cljs.core._nth(params,(14));
var G__83250 = cljs.core._nth(params,(15));
var G__83251 = cljs.core._nth(params,(16));
var G__83252 = cljs.core._nth(params,(17));
var G__83253 = cljs.core._nth(params,(18));
var G__83254 = cljs.core._nth(params,(19));
return (function sci$impl$fns$fun_$_arity_20(G__83215,G__83216,G__83217,G__83218,G__83219,G__83220,G__83221,G__83222,G__83223,G__83224,G__83225,G__83226,G__83227,G__83228,G__83229,G__83230,G__83231,G__83232,G__83233,G__83234){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__83235,G__83215);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83236,G__83216);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83237,G__83217);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83238,G__83218);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83239,G__83219);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83240,G__83220);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83241,G__83221);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83242,G__83222);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83243,G__83223);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83244,G__83224);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83245,G__83225);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83246,G__83226);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83247,G__83227);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83248,G__83228);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83249,G__83229);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83250,G__83230);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83251,G__83231);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83252,G__83232);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__83253,G__83233);
var bindings__$21 = cljs.core._assoc(bindings__$20,G__83254,G__83234);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$21,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83913 = cljs.core._nth(recur_val,(0));
var G__83914 = cljs.core._nth(recur_val,(1));
var G__83915 = cljs.core._nth(recur_val,(2));
var G__83916 = cljs.core._nth(recur_val,(3));
var G__83917 = cljs.core._nth(recur_val,(4));
var G__83918 = cljs.core._nth(recur_val,(5));
var G__83919 = cljs.core._nth(recur_val,(6));
var G__83920 = cljs.core._nth(recur_val,(7));
var G__83921 = cljs.core._nth(recur_val,(8));
var G__83922 = cljs.core._nth(recur_val,(9));
var G__83923 = cljs.core._nth(recur_val,(10));
var G__83924 = cljs.core._nth(recur_val,(11));
var G__83925 = cljs.core._nth(recur_val,(12));
var G__83926 = cljs.core._nth(recur_val,(13));
var G__83927 = cljs.core._nth(recur_val,(14));
var G__83928 = cljs.core._nth(recur_val,(15));
var G__83929 = cljs.core._nth(recur_val,(16));
var G__83930 = cljs.core._nth(recur_val,(17));
var G__83931 = cljs.core._nth(recur_val,(18));
var G__83932 = cljs.core._nth(recur_val,(19));
G__83215 = G__83913;
G__83216 = G__83914;
G__83217 = G__83915;
G__83218 = G__83916;
G__83219 = G__83917;
G__83220 = G__83918;
G__83221 = G__83919;
G__83222 = G__83920;
G__83223 = G__83921;
G__83224 = G__83922;
G__83225 = G__83923;
G__83226 = G__83924;
G__83227 = G__83925;
G__83228 = G__83926;
G__83229 = G__83927;
G__83230 = G__83928;
G__83231 = G__83929;
G__83232 = G__83930;
G__83233 = G__83931;
G__83234 = G__83932;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
} else {
var G__83293 = cljs.core._nth(params,(0));
var G__83294 = cljs.core._nth(params,(1));
var G__83295 = cljs.core._nth(params,(2));
var G__83296 = cljs.core._nth(params,(3));
var G__83297 = cljs.core._nth(params,(4));
var G__83298 = cljs.core._nth(params,(5));
var G__83299 = cljs.core._nth(params,(6));
var G__83300 = cljs.core._nth(params,(7));
var G__83301 = cljs.core._nth(params,(8));
var G__83302 = cljs.core._nth(params,(9));
var G__83303 = cljs.core._nth(params,(10));
var G__83304 = cljs.core._nth(params,(11));
var G__83305 = cljs.core._nth(params,(12));
var G__83306 = cljs.core._nth(params,(13));
var G__83307 = cljs.core._nth(params,(14));
var G__83308 = cljs.core._nth(params,(15));
var G__83309 = cljs.core._nth(params,(16));
var G__83310 = cljs.core._nth(params,(17));
var G__83311 = cljs.core._nth(params,(18));
var G__83312 = cljs.core._nth(params,(19));
return (function sci$impl$fns$fun_$_arity_20(G__83273,G__83274,G__83275,G__83276,G__83277,G__83278,G__83279,G__83280,G__83281,G__83282,G__83283,G__83284,G__83285,G__83286,G__83287,G__83288,G__83289,G__83290,G__83291,G__83292){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((20),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__83293,G__83273);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__83294,G__83274);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__83295,G__83275);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__83296,G__83276);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__83297,G__83277);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__83298,G__83278);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__83299,G__83279);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__83300,G__83280);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__83301,G__83281);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__83302,G__83282);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__83303,G__83283);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__83304,G__83284);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__83305,G__83285);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__83306,G__83286);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__83307,G__83287);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__83308,G__83288);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__83309,G__83289);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__83310,G__83290);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__83311,G__83291);
var bindings__$21 = cljs.core._assoc(bindings__$20,G__83312,G__83292);
var ret__52812__auto__ = sci.impl.evaluator.eval(ctx,bindings__$21,body);
var recur_QMARK___52813__auto__ = (ret__52812__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___52813__auto__){
var recur_val = sci.impl.types.getVal(ret__52812__auto__);
var G__83942 = cljs.core._nth(recur_val,(0));
var G__83943 = cljs.core._nth(recur_val,(1));
var G__83944 = cljs.core._nth(recur_val,(2));
var G__83945 = cljs.core._nth(recur_val,(3));
var G__83946 = cljs.core._nth(recur_val,(4));
var G__83947 = cljs.core._nth(recur_val,(5));
var G__83948 = cljs.core._nth(recur_val,(6));
var G__83949 = cljs.core._nth(recur_val,(7));
var G__83950 = cljs.core._nth(recur_val,(8));
var G__83951 = cljs.core._nth(recur_val,(9));
var G__83952 = cljs.core._nth(recur_val,(10));
var G__83953 = cljs.core._nth(recur_val,(11));
var G__83954 = cljs.core._nth(recur_val,(12));
var G__83955 = cljs.core._nth(recur_val,(13));
var G__83956 = cljs.core._nth(recur_val,(14));
var G__83957 = cljs.core._nth(recur_val,(15));
var G__83958 = cljs.core._nth(recur_val,(16));
var G__83959 = cljs.core._nth(recur_val,(17));
var G__83960 = cljs.core._nth(recur_val,(18));
var G__83961 = cljs.core._nth(recur_val,(19));
G__83273 = G__83942;
G__83274 = G__83943;
G__83275 = G__83944;
G__83276 = G__83945;
G__83277 = G__83946;
G__83278 = G__83947;
G__83279 = G__83948;
G__83280 = G__83949;
G__83281 = G__83950;
G__83282 = G__83951;
G__83283 = G__83952;
G__83284 = G__83953;
G__83285 = G__83954;
G__83286 = G__83955;
G__83287 = G__83956;
G__83288 = G__83957;
G__83289 = G__83958;
G__83290 = G__83959;
G__83291 = G__83960;
G__83292 = G__83961;
continue;
} else {
return ret__52812__auto__;
}
break;
}
});
}

break;
default:
return (function() { 
var sci$impl$fns$fun_$_varargs__delegate = function (args){
while(true){
var bindings__$2 = (function (){var args_STAR_ = cljs.core.seq(args);
var params__$1 = cljs.core.seq(params);
var ret = bindings__$1;
while(true){
if(params__$1){
var fp = cljs.core.first(params__$1);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"&","&",-2144855648,null),fp)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(ret,cljs.core.second(params__$1),args_STAR_);
} else {
if(args_STAR_){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
}

var G__83962 = cljs.core.next(args_STAR_);
var G__83963 = cljs.core.next(params__$1);
var G__83964 = cljs.core._assoc(ret,fp,cljs.core.first(args_STAR_));
args_STAR_ = G__83962;
params__$1 = G__83963;
ret = G__83964;
continue;
}
} else {
if(args_STAR_){
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
} else {
}

return ret;
}
break;
}
})();
var ret = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
var recur_val = sci.impl.types.getVal(ret);
var min_var_args_arity = (cljs.core.truth_(var_arg_name)?fixed_arity:null);
if(cljs.core.truth_(min_var_args_arity)){
var vec__83316 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(recur_val,(0),min_var_args_arity),cljs.core.subvec.cljs$core$IFn$_invoke$arity$2(recur_val,min_var_args_arity)], null);
var fixed_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83316,(0),null);
var vec__83319 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83316,(1),null);
var rest_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83319,(0),null);
var G__83965 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(fixed_args,rest_args);
args = G__83965;
continue;
} else {
var G__83966 = recur_val;
args = G__83966;
continue;
}
} else {
return ret;
}
break;
}
};
var sci$impl$fns$fun_$_varargs = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__83967__i = 0, G__83967__a = new Array(arguments.length -  0);
while (G__83967__i < G__83967__a.length) {G__83967__a[G__83967__i] = arguments[G__83967__i + 0]; ++G__83967__i;}
  args = new cljs.core.IndexedSeq(G__83967__a,0,null);
} 
return sci$impl$fns$fun_$_varargs__delegate.call(this,args);};
sci$impl$fns$fun_$_varargs.cljs$lang$maxFixedArity = 0;
sci$impl$fns$fun_$_varargs.cljs$lang$applyTo = (function (arglist__83968){
var args = cljs.core.seq(arglist__83968);
return sci$impl$fns$fun_$_varargs__delegate(args);
});
sci$impl$fns$fun_$_varargs.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$fun_$_varargs__delegate;
return sci$impl$fns$fun_$_varargs;
})()
;

}
})():(function() { 
var sci$impl$fns$fun_$_varargs__delegate = function (args){
while(true){
var bindings__$2 = (function (){var args_STAR_ = cljs.core.seq(args);
var params__$1 = cljs.core.seq(params);
var ret = bindings__$1;
while(true){
if(params__$1){
var fp = cljs.core.first(params__$1);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"&","&",-2144855648,null),fp)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(ret,cljs.core.second(params__$1),args_STAR_);
} else {
if(args_STAR_){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
}

var G__83969 = cljs.core.next(args_STAR_);
var G__83970 = cljs.core.next(params__$1);
var G__83971 = cljs.core._assoc(ret,fp,cljs.core.first(args_STAR_));
args_STAR_ = G__83969;
params__$1 = G__83970;
ret = G__83971;
continue;
}
} else {
if(args_STAR_){
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
} else {
}

return ret;
}
break;
}
})();
var ret = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
var recur_val = sci.impl.types.getVal(ret);
var min_var_args_arity = (cljs.core.truth_(var_arg_name)?fixed_arity:null);
if(cljs.core.truth_(min_var_args_arity)){
var vec__83322 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(recur_val,(0),min_var_args_arity),cljs.core.subvec.cljs$core$IFn$_invoke$arity$2(recur_val,min_var_args_arity)], null);
var fixed_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83322,(0),null);
var vec__83325 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83322,(1),null);
var rest_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__83325,(0),null);
var G__83976 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(fixed_args,rest_args);
args = G__83976;
continue;
} else {
var G__83977 = recur_val;
args = G__83977;
continue;
}
} else {
return ret;
}
break;
}
};
var sci$impl$fns$fun_$_varargs = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__83978__i = 0, G__83978__a = new Array(arguments.length -  0);
while (G__83978__i < G__83978__a.length) {G__83978__a[G__83978__i] = arguments[G__83978__i + 0]; ++G__83978__i;}
  args = new cljs.core.IndexedSeq(G__83978__a,0,null);
} 
return sci$impl$fns$fun_$_varargs__delegate.call(this,args);};
sci$impl$fns$fun_$_varargs.cljs$lang$maxFixedArity = 0;
sci$impl$fns$fun_$_varargs.cljs$lang$applyTo = (function (arglist__83979){
var args = cljs.core.seq(arglist__83979);
return sci$impl$fns$fun_$_varargs__delegate(args);
});
sci$impl$fns$fun_$_varargs.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$fun_$_varargs__delegate;
return sci$impl$fns$fun_$_varargs;
})()
);
return f;
});
sci.impl.fns.lookup_by_arity = (function sci$impl$fns$lookup_by_arity(arities,arity){
var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(arities,arity);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(arities);
}
});
sci.impl.fns.fn_arity_map = (function sci$impl$fns$fn_arity_map(ctx,bindings,fn_name,macro_QMARK_,fn_bodies){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (arity_map,fn_body){
var f = sci.impl.fns.fun(ctx,bindings,fn_body,fn_name,macro_QMARK_);
var var_arg_QMARK_ = new cljs.core.Keyword(null,"var-arg-name","var-arg-name",-1100024887).cljs$core$IFn$_invoke$arity$1(fn_body);
var fixed_arity = new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body);
if(cljs.core.truth_(var_arg_QMARK_)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,new cljs.core.Keyword(null,"variadic","variadic",882626057),f);
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,fixed_arity,f);
}
}),cljs.core.PersistentArrayMap.EMPTY,fn_bodies);
});
sci.impl.fns.eval_fn = (function sci$impl$fns$eval_fn(ctx,bindings,fn_name,fn_bodies,macro_QMARK_,single_arity,self_ref_QMARK_){
var self_ref = (cljs.core.truth_(self_ref_QMARK_)?cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null):null);
var bindings__$1 = (cljs.core.truth_(self_ref_QMARK_)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(bindings,fn_name,(function() { 
var sci$impl$fns$eval_fn_$_call_self__delegate = function (args){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self_ref),args);
};
var sci$impl$fns$eval_fn_$_call_self = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__83981__i = 0, G__83981__a = new Array(arguments.length -  0);
while (G__83981__i < G__83981__a.length) {G__83981__a[G__83981__i] = arguments[G__83981__i + 0]; ++G__83981__i;}
  args = new cljs.core.IndexedSeq(G__83981__a,0,null);
} 
return sci$impl$fns$eval_fn_$_call_self__delegate.call(this,args);};
sci$impl$fns$eval_fn_$_call_self.cljs$lang$maxFixedArity = 0;
sci$impl$fns$eval_fn_$_call_self.cljs$lang$applyTo = (function (arglist__83982){
var args = cljs.core.seq(arglist__83982);
return sci$impl$fns$eval_fn_$_call_self__delegate(args);
});
sci$impl$fns$eval_fn_$_call_self.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$eval_fn_$_call_self__delegate;
return sci$impl$fns$eval_fn_$_call_self;
})()
):bindings);
var f = (cljs.core.truth_(single_arity)?sci.impl.fns.fun(ctx,bindings__$1,single_arity,fn_name,macro_QMARK_):(function (){var arities = sci.impl.fns.fn_arity_map(ctx,bindings__$1,fn_name,macro_QMARK_,fn_bodies);
return (function() { 
var G__83983__delegate = function (args){
var arg_count = cljs.core.count(args);
var temp__5751__auto__ = sci.impl.fns.lookup_by_arity(arities,arg_count);
if(cljs.core.truth_(temp__5751__auto__)){
var f = temp__5751__auto__;
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,args);
} else {
throw (new Error((function (){var actual_count = (cljs.core.truth_(macro_QMARK_)?(arg_count - (2)):arg_count);
return ["Cannot call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_name)," with ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(actual_count)," arguments"].join('');
})()));
}
};
var G__83983 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__83985__i = 0, G__83985__a = new Array(arguments.length -  0);
while (G__83985__i < G__83985__a.length) {G__83985__a[G__83985__i] = arguments[G__83985__i + 0]; ++G__83985__i;}
  args = new cljs.core.IndexedSeq(G__83985__a,0,null);
} 
return G__83983__delegate.call(this,args);};
G__83983.cljs$lang$maxFixedArity = 0;
G__83983.cljs$lang$applyTo = (function (arglist__83986){
var args = cljs.core.seq(arglist__83986);
return G__83983__delegate(args);
});
G__83983.cljs$core$IFn$_invoke$arity$variadic = G__83983__delegate;
return G__83983;
})()
;
})());
var f__$1 = (cljs.core.truth_(macro_QMARK_)?cljs.core.vary_meta.cljs$core$IFn$_invoke$arity$2(f,(function (p1__83329_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__83329_SHARP_,new cljs.core.Keyword("sci","macro","sci/macro",-868536151),macro_QMARK_);
})):f);
if(cljs.core.truth_(self_ref_QMARK_)){
cljs.core.reset_BANG_(self_ref,f__$1);
} else {
}

return f__$1;
});
cljs.core.vreset_BANG_(sci.impl.utils.eval_fn,sci.impl.fns.eval_fn);

//# sourceMappingURL=sci.impl.fns.js.map
