import "./cljs_env.js";
goog.provide('cljs.core.async');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__74350 = arguments.length;
switch (G__74350) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
}));

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async74368 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async74368 = (function (f,blockable,meta74369){
this.f = f;
this.blockable = blockable;
this.meta74369 = meta74369;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_74370,meta74369__$1){
var self__ = this;
var _74370__$1 = this;
return (new cljs.core.async.t_cljs$core$async74368(self__.f,self__.blockable,meta74369__$1));
}));

(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_74370){
var self__ = this;
var _74370__$1 = this;
return self__.meta74369;
}));

(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
}));

(cljs.core.async.t_cljs$core$async74368.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
}));

(cljs.core.async.t_cljs$core$async74368.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta74369","meta74369",2041565059,null)], null);
}));

(cljs.core.async.t_cljs$core$async74368.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async74368.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async74368");

(cljs.core.async.t_cljs$core$async74368.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async74368");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async74368.
 */
cljs.core.async.__GT_t_cljs$core$async74368 = (function cljs$core$async$__GT_t_cljs$core$async74368(f__$1,blockable__$1,meta74369){
return (new cljs.core.async.t_cljs$core$async74368(f__$1,blockable__$1,meta74369));
});

}

return (new cljs.core.async.t_cljs$core$async74368(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
}));

(cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2);

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__74398 = arguments.length;
switch (G__74398) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
}));

(cljs.core.async.chan.cljs$lang$maxFixedArity = 3);

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__74404 = arguments.length;
switch (G__74404) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
}));

(cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__74410 = arguments.length;
switch (G__74410) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
}));

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_76704 = cljs.core.deref(ret);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_76704) : fn1.call(null,val_76704));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_76704) : fn1.call(null,val_76704));
}));
}
} else {
}

return null;
}));

(cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3);

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__74417 = arguments.length;
switch (G__74417) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5751__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5751__auto__)){
var ret = temp__5751__auto__;
return cljs.core.deref(ret);
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5751__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__5751__auto__)){
var retb = temp__5751__auto__;
var ret = cljs.core.deref(retb);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
}));
}

return ret;
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4);

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4706__auto___76710 = n;
var x_76711 = (0);
while(true){
if((x_76711 < n__4706__auto___76710)){
(a[x_76711] = x_76711);

var G__76712 = (x_76711 + (1));
x_76711 = G__76712;
continue;
} else {
}
break;
}

goog.array.shuffle(a);

return a;
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true);
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async74450 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async74450 = (function (flag,meta74451){
this.flag = flag;
this.meta74451 = meta74451;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_74452,meta74451__$1){
var self__ = this;
var _74452__$1 = this;
return (new cljs.core.async.t_cljs$core$async74450(self__.flag,meta74451__$1));
}));

(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_74452){
var self__ = this;
var _74452__$1 = this;
return self__.meta74451;
}));

(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref(self__.flag);
}));

(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async74450.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.flag,null);

return true;
}));

(cljs.core.async.t_cljs$core$async74450.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta74451","meta74451",1357168702,null)], null);
}));

(cljs.core.async.t_cljs$core$async74450.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async74450.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async74450");

(cljs.core.async.t_cljs$core$async74450.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async74450");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async74450.
 */
cljs.core.async.__GT_t_cljs$core$async74450 = (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async74450(flag__$1,meta74451){
return (new cljs.core.async.t_cljs$core$async74450(flag__$1,meta74451));
});

}

return (new cljs.core.async.t_cljs$core$async74450(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async74486 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async74486 = (function (flag,cb,meta74487){
this.flag = flag;
this.cb = cb;
this.meta74487 = meta74487;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_74488,meta74487__$1){
var self__ = this;
var _74488__$1 = this;
return (new cljs.core.async.t_cljs$core$async74486(self__.flag,self__.cb,meta74487__$1));
}));

(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_74488){
var self__ = this;
var _74488__$1 = this;
return self__.meta74487;
}));

(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
}));

(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async74486.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
}));

(cljs.core.async.t_cljs$core$async74486.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta74487","meta74487",2039884698,null)], null);
}));

(cljs.core.async.t_cljs$core$async74486.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async74486.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async74486");

(cljs.core.async.t_cljs$core$async74486.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async74486");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async74486.
 */
cljs.core.async.__GT_t_cljs$core$async74486 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async74486(flag__$1,cb__$1,meta74487){
return (new cljs.core.async.t_cljs$core$async74486(flag__$1,cb__$1,meta74487));
});

}

return (new cljs.core.async.t_cljs$core$async74486(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
if((cljs.core.count(ports) > (0))){
} else {
throw (new Error(["Assert failed: ","alts must have at least one channel operation","\n","(pos? (count ports))"].join('')));
}

var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__74505_SHARP_){
var G__74537 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__74505_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__74537) : fret.call(null,G__74537));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__74506_SHARP_){
var G__74538 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__74506_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__74538) : fret.call(null,G__74538));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref(vbox),(function (){var or__4223__auto__ = wport;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return port;
}
})()], null));
} else {
var G__76713 = (i + (1));
i = G__76713;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4223__auto__ = ret;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5753__auto__ = (function (){var and__4221__auto__ = flag.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(cljs.core.truth_(and__4221__auto__)){
return flag.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__4221__auto__;
}
})();
if(cljs.core.truth_(temp__5753__auto__)){
var got = temp__5753__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4835__auto__ = [];
var len__4829__auto___76714 = arguments.length;
var i__4830__auto___76715 = (0);
while(true){
if((i__4830__auto___76715 < len__4829__auto___76714)){
args__4835__auto__.push((arguments[i__4830__auto___76715]));

var G__76716 = (i__4830__auto___76715 + (1));
i__4830__auto___76715 = G__76716;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((1) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4836__auto__);
});

(cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__74548){
var map__74553 = p__74548;
var map__74553__$1 = cljs.core.__destructure_map(map__74553);
var opts = map__74553__$1;
throw (new Error("alts! used not in (go ...) block"));
}));

(cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq74540){
var G__74541 = cljs.core.first(seq74540);
var seq74540__$1 = cljs.core.next(seq74540);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__74541,seq74540__$1);
}));

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__74576 = arguments.length;
switch (G__74576) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
}));

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__74231__auto___76722 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_74748){
var state_val_74749 = (state_74748[(1)]);
if((state_val_74749 === (7))){
var inst_74731 = (state_74748[(2)]);
var state_74748__$1 = state_74748;
var statearr_74807_76723 = state_74748__$1;
(statearr_74807_76723[(2)] = inst_74731);

(statearr_74807_76723[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (1))){
var state_74748__$1 = state_74748;
var statearr_74811_76724 = state_74748__$1;
(statearr_74811_76724[(2)] = null);

(statearr_74811_76724[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (4))){
var inst_74678 = (state_74748[(7)]);
var inst_74678__$1 = (state_74748[(2)]);
var inst_74691 = (inst_74678__$1 == null);
var state_74748__$1 = (function (){var statearr_74817 = state_74748;
(statearr_74817[(7)] = inst_74678__$1);

return statearr_74817;
})();
if(cljs.core.truth_(inst_74691)){
var statearr_74818_76725 = state_74748__$1;
(statearr_74818_76725[(1)] = (5));

} else {
var statearr_74821_76726 = state_74748__$1;
(statearr_74821_76726[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (13))){
var state_74748__$1 = state_74748;
var statearr_74823_76727 = state_74748__$1;
(statearr_74823_76727[(2)] = null);

(statearr_74823_76727[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (6))){
var inst_74678 = (state_74748[(7)]);
var state_74748__$1 = state_74748;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_74748__$1,(11),to,inst_74678);
} else {
if((state_val_74749 === (3))){
var inst_74733 = (state_74748[(2)]);
var state_74748__$1 = state_74748;
return cljs.core.async.impl.ioc_helpers.return_chan(state_74748__$1,inst_74733);
} else {
if((state_val_74749 === (12))){
var state_74748__$1 = state_74748;
var statearr_74833_76728 = state_74748__$1;
(statearr_74833_76728[(2)] = null);

(statearr_74833_76728[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (2))){
var state_74748__$1 = state_74748;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_74748__$1,(4),from);
} else {
if((state_val_74749 === (11))){
var inst_74710 = (state_74748[(2)]);
var state_74748__$1 = state_74748;
if(cljs.core.truth_(inst_74710)){
var statearr_74837_76729 = state_74748__$1;
(statearr_74837_76729[(1)] = (12));

} else {
var statearr_74839_76730 = state_74748__$1;
(statearr_74839_76730[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (9))){
var state_74748__$1 = state_74748;
var statearr_74840_76731 = state_74748__$1;
(statearr_74840_76731[(2)] = null);

(statearr_74840_76731[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (5))){
var state_74748__$1 = state_74748;
if(cljs.core.truth_(close_QMARK_)){
var statearr_74842_76732 = state_74748__$1;
(statearr_74842_76732[(1)] = (8));

} else {
var statearr_74843_76733 = state_74748__$1;
(statearr_74843_76733[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (14))){
var inst_74729 = (state_74748[(2)]);
var state_74748__$1 = state_74748;
var statearr_74846_76734 = state_74748__$1;
(statearr_74846_76734[(2)] = inst_74729);

(statearr_74846_76734[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (10))){
var inst_74706 = (state_74748[(2)]);
var state_74748__$1 = state_74748;
var statearr_74849_76736 = state_74748__$1;
(statearr_74849_76736[(2)] = inst_74706);

(statearr_74849_76736[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74749 === (8))){
var inst_74696 = cljs.core.async.close_BANG_(to);
var state_74748__$1 = state_74748;
var statearr_74855_76737 = state_74748__$1;
(statearr_74855_76737[(2)] = inst_74696);

(statearr_74855_76737[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_74869 = [null,null,null,null,null,null,null,null];
(statearr_74869[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_74869[(1)] = (1));

return statearr_74869;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_74748){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_74748);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e74877){var ex__74105__auto__ = e74877;
var statearr_74882_76739 = state_74748;
(statearr_74882_76739[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_74748[(4)]))){
var statearr_74883_76740 = state_74748;
(statearr_74883_76740[(1)] = cljs.core.first((state_74748[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76741 = state_74748;
state_74748 = G__76741;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_74748){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_74748);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_74889 = f__74232__auto__();
(statearr_74889[(6)] = c__74231__auto___76722);

return statearr_74889;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return to;
}));

(cljs.core.async.pipe.cljs$lang$maxFixedArity = 3);

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = (function (p__74905){
var vec__74906 = p__74905;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__74906,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__74906,(1),null);
var job = vec__74906;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__74231__auto___76749 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_74921){
var state_val_74922 = (state_74921[(1)]);
if((state_val_74922 === (1))){
var state_74921__$1 = state_74921;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_74921__$1,(2),res,v);
} else {
if((state_val_74922 === (2))){
var inst_74915 = (state_74921[(2)]);
var inst_74917 = cljs.core.async.close_BANG_(res);
var state_74921__$1 = (function (){var statearr_74927 = state_74921;
(statearr_74927[(7)] = inst_74915);

return statearr_74927;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_74921__$1,inst_74917);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_74929 = [null,null,null,null,null,null,null,null];
(statearr_74929[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__);

(statearr_74929[(1)] = (1));

return statearr_74929;
});
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1 = (function (state_74921){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_74921);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e74931){var ex__74105__auto__ = e74931;
var statearr_74932_76750 = state_74921;
(statearr_74932_76750[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_74921[(4)]))){
var statearr_74933_76751 = state_74921;
(statearr_74933_76751[(1)] = cljs.core.first((state_74921[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76752 = state_74921;
state_74921 = G__76752;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = function(state_74921){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1.call(this,state_74921);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_74934 = f__74232__auto__();
(statearr_74934[(6)] = c__74231__auto___76749);

return statearr_74934;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var async = (function (p__74939){
var vec__74940 = p__74939;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__74940,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__74940,(1),null);
var job = vec__74940;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var n__4706__auto___76756 = n;
var __76757 = (0);
while(true){
if((__76757 < n__4706__auto___76756)){
var G__74944_76758 = type;
var G__74944_76759__$1 = (((G__74944_76758 instanceof cljs.core.Keyword))?G__74944_76758.fqn:null);
switch (G__74944_76759__$1) {
case "compute":
var c__74231__auto___76761 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__76757,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = ((function (__76757,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function (state_74963){
var state_val_74966 = (state_74963[(1)]);
if((state_val_74966 === (1))){
var state_74963__$1 = state_74963;
var statearr_74982_76766 = state_74963__$1;
(statearr_74982_76766[(2)] = null);

(statearr_74982_76766[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74966 === (2))){
var state_74963__$1 = state_74963;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_74963__$1,(4),jobs);
} else {
if((state_val_74966 === (3))){
var inst_74961 = (state_74963[(2)]);
var state_74963__$1 = state_74963;
return cljs.core.async.impl.ioc_helpers.return_chan(state_74963__$1,inst_74961);
} else {
if((state_val_74966 === (4))){
var inst_74948 = (state_74963[(2)]);
var inst_74951 = process(inst_74948);
var state_74963__$1 = state_74963;
if(cljs.core.truth_(inst_74951)){
var statearr_74983_76767 = state_74963__$1;
(statearr_74983_76767[(1)] = (5));

} else {
var statearr_74984_76768 = state_74963__$1;
(statearr_74984_76768[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74966 === (5))){
var state_74963__$1 = state_74963;
var statearr_74986_76769 = state_74963__$1;
(statearr_74986_76769[(2)] = null);

(statearr_74986_76769[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74966 === (6))){
var state_74963__$1 = state_74963;
var statearr_74987_76770 = state_74963__$1;
(statearr_74987_76770[(2)] = null);

(statearr_74987_76770[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_74966 === (7))){
var inst_74959 = (state_74963[(2)]);
var state_74963__$1 = state_74963;
var statearr_74990_76774 = state_74963__$1;
(statearr_74990_76774[(2)] = inst_74959);

(statearr_74990_76774[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__76757,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
;
return ((function (__76757,switch__74101__auto__,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_74992 = [null,null,null,null,null,null,null];
(statearr_74992[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__);

(statearr_74992[(1)] = (1));

return statearr_74992;
});
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1 = (function (state_74963){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_74963);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e74993){var ex__74105__auto__ = e74993;
var statearr_74994_76777 = state_74963;
(statearr_74994_76777[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_74963[(4)]))){
var statearr_74995_76778 = state_74963;
(statearr_74995_76778[(1)] = cljs.core.first((state_74963[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76779 = state_74963;
state_74963 = G__76779;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = function(state_74963){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1.call(this,state_74963);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__;
})()
;})(__76757,switch__74101__auto__,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
})();
var state__74233__auto__ = (function (){var statearr_74996 = f__74232__auto__();
(statearr_74996[(6)] = c__74231__auto___76761);

return statearr_74996;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
});})(__76757,c__74231__auto___76761,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
);


break;
case "async":
var c__74231__auto___76780 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__76757,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = ((function (__76757,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function (state_75009){
var state_val_75010 = (state_75009[(1)]);
if((state_val_75010 === (1))){
var state_75009__$1 = state_75009;
var statearr_75012_76781 = state_75009__$1;
(statearr_75012_76781[(2)] = null);

(statearr_75012_76781[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75010 === (2))){
var state_75009__$1 = state_75009;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75009__$1,(4),jobs);
} else {
if((state_val_75010 === (3))){
var inst_75007 = (state_75009[(2)]);
var state_75009__$1 = state_75009;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75009__$1,inst_75007);
} else {
if((state_val_75010 === (4))){
var inst_74999 = (state_75009[(2)]);
var inst_75000 = async(inst_74999);
var state_75009__$1 = state_75009;
if(cljs.core.truth_(inst_75000)){
var statearr_75013_76782 = state_75009__$1;
(statearr_75013_76782[(1)] = (5));

} else {
var statearr_75014_76783 = state_75009__$1;
(statearr_75014_76783[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75010 === (5))){
var state_75009__$1 = state_75009;
var statearr_75015_76784 = state_75009__$1;
(statearr_75015_76784[(2)] = null);

(statearr_75015_76784[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75010 === (6))){
var state_75009__$1 = state_75009;
var statearr_75016_76786 = state_75009__$1;
(statearr_75016_76786[(2)] = null);

(statearr_75016_76786[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75010 === (7))){
var inst_75005 = (state_75009[(2)]);
var state_75009__$1 = state_75009;
var statearr_75021_76788 = state_75009__$1;
(statearr_75021_76788[(2)] = inst_75005);

(statearr_75021_76788[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__76757,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
;
return ((function (__76757,switch__74101__auto__,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_75030 = [null,null,null,null,null,null,null];
(statearr_75030[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__);

(statearr_75030[(1)] = (1));

return statearr_75030;
});
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1 = (function (state_75009){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75009);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75031){var ex__74105__auto__ = e75031;
var statearr_75032_76789 = state_75009;
(statearr_75032_76789[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75009[(4)]))){
var statearr_75039_76790 = state_75009;
(statearr_75039_76790[(1)] = cljs.core.first((state_75009[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76792 = state_75009;
state_75009 = G__76792;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = function(state_75009){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1.call(this,state_75009);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__;
})()
;})(__76757,switch__74101__auto__,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
})();
var state__74233__auto__ = (function (){var statearr_75040 = f__74232__auto__();
(statearr_75040[(6)] = c__74231__auto___76780);

return statearr_75040;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
});})(__76757,c__74231__auto___76780,G__74944_76758,G__74944_76759__$1,n__4706__auto___76756,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__74944_76759__$1)].join('')));

}

var G__76794 = (__76757 + (1));
__76757 = G__76794;
continue;
} else {
}
break;
}

var c__74231__auto___76795 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75062){
var state_val_75063 = (state_75062[(1)]);
if((state_val_75063 === (7))){
var inst_75058 = (state_75062[(2)]);
var state_75062__$1 = state_75062;
var statearr_75076_76796 = state_75062__$1;
(statearr_75076_76796[(2)] = inst_75058);

(statearr_75076_76796[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75063 === (1))){
var state_75062__$1 = state_75062;
var statearr_75079_76798 = state_75062__$1;
(statearr_75079_76798[(2)] = null);

(statearr_75079_76798[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75063 === (4))){
var inst_75043 = (state_75062[(7)]);
var inst_75043__$1 = (state_75062[(2)]);
var inst_75044 = (inst_75043__$1 == null);
var state_75062__$1 = (function (){var statearr_75080 = state_75062;
(statearr_75080[(7)] = inst_75043__$1);

return statearr_75080;
})();
if(cljs.core.truth_(inst_75044)){
var statearr_75081_76800 = state_75062__$1;
(statearr_75081_76800[(1)] = (5));

} else {
var statearr_75082_76801 = state_75062__$1;
(statearr_75082_76801[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75063 === (6))){
var inst_75043 = (state_75062[(7)]);
var inst_75048 = (state_75062[(8)]);
var inst_75048__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_75049 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_75050 = [inst_75043,inst_75048__$1];
var inst_75051 = (new cljs.core.PersistentVector(null,2,(5),inst_75049,inst_75050,null));
var state_75062__$1 = (function (){var statearr_75083 = state_75062;
(statearr_75083[(8)] = inst_75048__$1);

return statearr_75083;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75062__$1,(8),jobs,inst_75051);
} else {
if((state_val_75063 === (3))){
var inst_75060 = (state_75062[(2)]);
var state_75062__$1 = state_75062;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75062__$1,inst_75060);
} else {
if((state_val_75063 === (2))){
var state_75062__$1 = state_75062;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75062__$1,(4),from);
} else {
if((state_val_75063 === (9))){
var inst_75055 = (state_75062[(2)]);
var state_75062__$1 = (function (){var statearr_75084 = state_75062;
(statearr_75084[(9)] = inst_75055);

return statearr_75084;
})();
var statearr_75085_76805 = state_75062__$1;
(statearr_75085_76805[(2)] = null);

(statearr_75085_76805[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75063 === (5))){
var inst_75046 = cljs.core.async.close_BANG_(jobs);
var state_75062__$1 = state_75062;
var statearr_75086_76806 = state_75062__$1;
(statearr_75086_76806[(2)] = inst_75046);

(statearr_75086_76806[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75063 === (8))){
var inst_75048 = (state_75062[(8)]);
var inst_75053 = (state_75062[(2)]);
var state_75062__$1 = (function (){var statearr_75087 = state_75062;
(statearr_75087[(10)] = inst_75053);

return statearr_75087;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75062__$1,(9),results,inst_75048);
} else {
return null;
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_75088 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_75088[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__);

(statearr_75088[(1)] = (1));

return statearr_75088;
});
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1 = (function (state_75062){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75062);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75089){var ex__74105__auto__ = e75089;
var statearr_75090_76807 = state_75062;
(statearr_75090_76807[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75062[(4)]))){
var statearr_75091_76808 = state_75062;
(statearr_75091_76808[(1)] = cljs.core.first((state_75062[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76809 = state_75062;
state_75062 = G__76809;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = function(state_75062){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1.call(this,state_75062);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75092 = f__74232__auto__();
(statearr_75092[(6)] = c__74231__auto___76795);

return statearr_75092;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


var c__74231__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75142){
var state_val_75143 = (state_75142[(1)]);
if((state_val_75143 === (7))){
var inst_75134 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
var statearr_75148_76812 = state_75142__$1;
(statearr_75148_76812[(2)] = inst_75134);

(statearr_75148_76812[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (20))){
var state_75142__$1 = state_75142;
var statearr_75149_76813 = state_75142__$1;
(statearr_75149_76813[(2)] = null);

(statearr_75149_76813[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (1))){
var state_75142__$1 = state_75142;
var statearr_75150_76814 = state_75142__$1;
(statearr_75150_76814[(2)] = null);

(statearr_75150_76814[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (4))){
var inst_75100 = (state_75142[(7)]);
var inst_75100__$1 = (state_75142[(2)]);
var inst_75101 = (inst_75100__$1 == null);
var state_75142__$1 = (function (){var statearr_75151 = state_75142;
(statearr_75151[(7)] = inst_75100__$1);

return statearr_75151;
})();
if(cljs.core.truth_(inst_75101)){
var statearr_75152_76815 = state_75142__$1;
(statearr_75152_76815[(1)] = (5));

} else {
var statearr_75155_76816 = state_75142__$1;
(statearr_75155_76816[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (15))){
var inst_75116 = (state_75142[(8)]);
var state_75142__$1 = state_75142;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75142__$1,(18),to,inst_75116);
} else {
if((state_val_75143 === (21))){
var inst_75129 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
var statearr_75156_76817 = state_75142__$1;
(statearr_75156_76817[(2)] = inst_75129);

(statearr_75156_76817[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (13))){
var inst_75131 = (state_75142[(2)]);
var state_75142__$1 = (function (){var statearr_75157 = state_75142;
(statearr_75157[(9)] = inst_75131);

return statearr_75157;
})();
var statearr_75158_76818 = state_75142__$1;
(statearr_75158_76818[(2)] = null);

(statearr_75158_76818[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (6))){
var inst_75100 = (state_75142[(7)]);
var state_75142__$1 = state_75142;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75142__$1,(11),inst_75100);
} else {
if((state_val_75143 === (17))){
var inst_75124 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
if(cljs.core.truth_(inst_75124)){
var statearr_75159_76819 = state_75142__$1;
(statearr_75159_76819[(1)] = (19));

} else {
var statearr_75160_76820 = state_75142__$1;
(statearr_75160_76820[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (3))){
var inst_75136 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75142__$1,inst_75136);
} else {
if((state_val_75143 === (12))){
var inst_75113 = (state_75142[(10)]);
var state_75142__$1 = state_75142;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75142__$1,(14),inst_75113);
} else {
if((state_val_75143 === (2))){
var state_75142__$1 = state_75142;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75142__$1,(4),results);
} else {
if((state_val_75143 === (19))){
var state_75142__$1 = state_75142;
var statearr_75161_76821 = state_75142__$1;
(statearr_75161_76821[(2)] = null);

(statearr_75161_76821[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (11))){
var inst_75113 = (state_75142[(2)]);
var state_75142__$1 = (function (){var statearr_75164 = state_75142;
(statearr_75164[(10)] = inst_75113);

return statearr_75164;
})();
var statearr_75165_76823 = state_75142__$1;
(statearr_75165_76823[(2)] = null);

(statearr_75165_76823[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (9))){
var state_75142__$1 = state_75142;
var statearr_75166_76824 = state_75142__$1;
(statearr_75166_76824[(2)] = null);

(statearr_75166_76824[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (5))){
var state_75142__$1 = state_75142;
if(cljs.core.truth_(close_QMARK_)){
var statearr_75167_76826 = state_75142__$1;
(statearr_75167_76826[(1)] = (8));

} else {
var statearr_75168_76827 = state_75142__$1;
(statearr_75168_76827[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (14))){
var inst_75118 = (state_75142[(11)]);
var inst_75116 = (state_75142[(8)]);
var inst_75116__$1 = (state_75142[(2)]);
var inst_75117 = (inst_75116__$1 == null);
var inst_75118__$1 = cljs.core.not(inst_75117);
var state_75142__$1 = (function (){var statearr_75169 = state_75142;
(statearr_75169[(11)] = inst_75118__$1);

(statearr_75169[(8)] = inst_75116__$1);

return statearr_75169;
})();
if(inst_75118__$1){
var statearr_75170_76828 = state_75142__$1;
(statearr_75170_76828[(1)] = (15));

} else {
var statearr_75171_76829 = state_75142__$1;
(statearr_75171_76829[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (16))){
var inst_75118 = (state_75142[(11)]);
var state_75142__$1 = state_75142;
var statearr_75172_76830 = state_75142__$1;
(statearr_75172_76830[(2)] = inst_75118);

(statearr_75172_76830[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (10))){
var inst_75107 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
var statearr_75173_76831 = state_75142__$1;
(statearr_75173_76831[(2)] = inst_75107);

(statearr_75173_76831[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (18))){
var inst_75121 = (state_75142[(2)]);
var state_75142__$1 = state_75142;
var statearr_75174_76832 = state_75142__$1;
(statearr_75174_76832[(2)] = inst_75121);

(statearr_75174_76832[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75143 === (8))){
var inst_75104 = cljs.core.async.close_BANG_(to);
var state_75142__$1 = state_75142;
var statearr_75176_76833 = state_75142__$1;
(statearr_75176_76833[(2)] = inst_75104);

(statearr_75176_76833[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_75177 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_75177[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__);

(statearr_75177[(1)] = (1));

return statearr_75177;
});
var cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1 = (function (state_75142){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75142);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75178){var ex__74105__auto__ = e75178;
var statearr_75179_76834 = state_75142;
(statearr_75179_76834[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75142[(4)]))){
var statearr_75180_76835 = state_75142;
(statearr_75180_76835[(1)] = cljs.core.first((state_75142[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76836 = state_75142;
state_75142 = G__76836;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__ = function(state_75142){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1.call(this,state_75142);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75181 = f__74232__auto__();
(statearr_75181[(6)] = c__74231__auto__);

return statearr_75181;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));

return c__74231__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__75194 = arguments.length;
switch (G__75194) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
}));

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
}));

(cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5);

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__75241 = arguments.length;
switch (G__75241) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
}));

(cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6);

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__75248 = arguments.length;
switch (G__75248) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
}));

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__74231__auto___76842 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75277){
var state_val_75278 = (state_75277[(1)]);
if((state_val_75278 === (7))){
var inst_75273 = (state_75277[(2)]);
var state_75277__$1 = state_75277;
var statearr_75280_76843 = state_75277__$1;
(statearr_75280_76843[(2)] = inst_75273);

(statearr_75280_76843[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (1))){
var state_75277__$1 = state_75277;
var statearr_75281_76844 = state_75277__$1;
(statearr_75281_76844[(2)] = null);

(statearr_75281_76844[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (4))){
var inst_75254 = (state_75277[(7)]);
var inst_75254__$1 = (state_75277[(2)]);
var inst_75255 = (inst_75254__$1 == null);
var state_75277__$1 = (function (){var statearr_75282 = state_75277;
(statearr_75282[(7)] = inst_75254__$1);

return statearr_75282;
})();
if(cljs.core.truth_(inst_75255)){
var statearr_75283_76845 = state_75277__$1;
(statearr_75283_76845[(1)] = (5));

} else {
var statearr_75284_76846 = state_75277__$1;
(statearr_75284_76846[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (13))){
var state_75277__$1 = state_75277;
var statearr_75285_76847 = state_75277__$1;
(statearr_75285_76847[(2)] = null);

(statearr_75285_76847[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (6))){
var inst_75254 = (state_75277[(7)]);
var inst_75260 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_75254) : p.call(null,inst_75254));
var state_75277__$1 = state_75277;
if(cljs.core.truth_(inst_75260)){
var statearr_75289_76848 = state_75277__$1;
(statearr_75289_76848[(1)] = (9));

} else {
var statearr_75290_76849 = state_75277__$1;
(statearr_75290_76849[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (3))){
var inst_75275 = (state_75277[(2)]);
var state_75277__$1 = state_75277;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75277__$1,inst_75275);
} else {
if((state_val_75278 === (12))){
var state_75277__$1 = state_75277;
var statearr_75291_76851 = state_75277__$1;
(statearr_75291_76851[(2)] = null);

(statearr_75291_76851[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (2))){
var state_75277__$1 = state_75277;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75277__$1,(4),ch);
} else {
if((state_val_75278 === (11))){
var inst_75254 = (state_75277[(7)]);
var inst_75264 = (state_75277[(2)]);
var state_75277__$1 = state_75277;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75277__$1,(8),inst_75264,inst_75254);
} else {
if((state_val_75278 === (9))){
var state_75277__$1 = state_75277;
var statearr_75294_76852 = state_75277__$1;
(statearr_75294_76852[(2)] = tc);

(statearr_75294_76852[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (5))){
var inst_75257 = cljs.core.async.close_BANG_(tc);
var inst_75258 = cljs.core.async.close_BANG_(fc);
var state_75277__$1 = (function (){var statearr_75298 = state_75277;
(statearr_75298[(8)] = inst_75257);

return statearr_75298;
})();
var statearr_75299_76853 = state_75277__$1;
(statearr_75299_76853[(2)] = inst_75258);

(statearr_75299_76853[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (14))){
var inst_75271 = (state_75277[(2)]);
var state_75277__$1 = state_75277;
var statearr_75302_76854 = state_75277__$1;
(statearr_75302_76854[(2)] = inst_75271);

(statearr_75302_76854[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (10))){
var state_75277__$1 = state_75277;
var statearr_75303_76855 = state_75277__$1;
(statearr_75303_76855[(2)] = fc);

(statearr_75303_76855[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75278 === (8))){
var inst_75266 = (state_75277[(2)]);
var state_75277__$1 = state_75277;
if(cljs.core.truth_(inst_75266)){
var statearr_75304_76856 = state_75277__$1;
(statearr_75304_76856[(1)] = (12));

} else {
var statearr_75305_76857 = state_75277__$1;
(statearr_75305_76857[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_75309 = [null,null,null,null,null,null,null,null,null];
(statearr_75309[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_75309[(1)] = (1));

return statearr_75309;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_75277){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75277);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75310){var ex__74105__auto__ = e75310;
var statearr_75311_76858 = state_75277;
(statearr_75311_76858[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75277[(4)]))){
var statearr_75312_76859 = state_75277;
(statearr_75312_76859[(1)] = cljs.core.first((state_75277[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76860 = state_75277;
state_75277 = G__76860;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_75277){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_75277);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75313 = f__74232__auto__();
(statearr_75313[(6)] = c__74231__auto___76842);

return statearr_75313;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
}));

(cljs.core.async.split.cljs$lang$maxFixedArity = 4);

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__74231__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75343){
var state_val_75344 = (state_75343[(1)]);
if((state_val_75344 === (7))){
var inst_75339 = (state_75343[(2)]);
var state_75343__$1 = state_75343;
var statearr_75345_76865 = state_75343__$1;
(statearr_75345_76865[(2)] = inst_75339);

(statearr_75345_76865[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (1))){
var inst_75322 = init;
var inst_75323 = inst_75322;
var state_75343__$1 = (function (){var statearr_75346 = state_75343;
(statearr_75346[(7)] = inst_75323);

return statearr_75346;
})();
var statearr_75347_76866 = state_75343__$1;
(statearr_75347_76866[(2)] = null);

(statearr_75347_76866[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (4))){
var inst_75326 = (state_75343[(8)]);
var inst_75326__$1 = (state_75343[(2)]);
var inst_75327 = (inst_75326__$1 == null);
var state_75343__$1 = (function (){var statearr_75348 = state_75343;
(statearr_75348[(8)] = inst_75326__$1);

return statearr_75348;
})();
if(cljs.core.truth_(inst_75327)){
var statearr_75349_76867 = state_75343__$1;
(statearr_75349_76867[(1)] = (5));

} else {
var statearr_75350_76868 = state_75343__$1;
(statearr_75350_76868[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (6))){
var inst_75323 = (state_75343[(7)]);
var inst_75330 = (state_75343[(9)]);
var inst_75326 = (state_75343[(8)]);
var inst_75330__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_75323,inst_75326) : f.call(null,inst_75323,inst_75326));
var inst_75331 = cljs.core.reduced_QMARK_(inst_75330__$1);
var state_75343__$1 = (function (){var statearr_75351 = state_75343;
(statearr_75351[(9)] = inst_75330__$1);

return statearr_75351;
})();
if(inst_75331){
var statearr_75352_76869 = state_75343__$1;
(statearr_75352_76869[(1)] = (8));

} else {
var statearr_75353_76870 = state_75343__$1;
(statearr_75353_76870[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (3))){
var inst_75341 = (state_75343[(2)]);
var state_75343__$1 = state_75343;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75343__$1,inst_75341);
} else {
if((state_val_75344 === (2))){
var state_75343__$1 = state_75343;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75343__$1,(4),ch);
} else {
if((state_val_75344 === (9))){
var inst_75330 = (state_75343[(9)]);
var inst_75323 = inst_75330;
var state_75343__$1 = (function (){var statearr_75354 = state_75343;
(statearr_75354[(7)] = inst_75323);

return statearr_75354;
})();
var statearr_75355_76871 = state_75343__$1;
(statearr_75355_76871[(2)] = null);

(statearr_75355_76871[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (5))){
var inst_75323 = (state_75343[(7)]);
var state_75343__$1 = state_75343;
var statearr_75356_76872 = state_75343__$1;
(statearr_75356_76872[(2)] = inst_75323);

(statearr_75356_76872[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (10))){
var inst_75337 = (state_75343[(2)]);
var state_75343__$1 = state_75343;
var statearr_75357_76873 = state_75343__$1;
(statearr_75357_76873[(2)] = inst_75337);

(statearr_75357_76873[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75344 === (8))){
var inst_75330 = (state_75343[(9)]);
var inst_75333 = cljs.core.deref(inst_75330);
var state_75343__$1 = state_75343;
var statearr_75358_76874 = state_75343__$1;
(statearr_75358_76874[(2)] = inst_75333);

(statearr_75358_76874[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$reduce_$_state_machine__74102__auto__ = null;
var cljs$core$async$reduce_$_state_machine__74102__auto____0 = (function (){
var statearr_75359 = [null,null,null,null,null,null,null,null,null,null];
(statearr_75359[(0)] = cljs$core$async$reduce_$_state_machine__74102__auto__);

(statearr_75359[(1)] = (1));

return statearr_75359;
});
var cljs$core$async$reduce_$_state_machine__74102__auto____1 = (function (state_75343){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75343);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75360){var ex__74105__auto__ = e75360;
var statearr_75361_76876 = state_75343;
(statearr_75361_76876[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75343[(4)]))){
var statearr_75362_76877 = state_75343;
(statearr_75362_76877[(1)] = cljs.core.first((state_75343[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76878 = state_75343;
state_75343 = G__76878;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__74102__auto__ = function(state_75343){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__74102__auto____1.call(this,state_75343);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__74102__auto____0;
cljs$core$async$reduce_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__74102__auto____1;
return cljs$core$async$reduce_$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75363 = f__74232__auto__();
(statearr_75363[(6)] = c__74231__auto__);

return statearr_75363;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));

return c__74231__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = (xform.cljs$core$IFn$_invoke$arity$1 ? xform.cljs$core$IFn$_invoke$arity$1(f) : xform.call(null,f));
var c__74231__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75378){
var state_val_75379 = (state_75378[(1)]);
if((state_val_75379 === (1))){
var inst_75368 = cljs.core.async.reduce(f__$1,init,ch);
var state_75378__$1 = state_75378;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75378__$1,(2),inst_75368);
} else {
if((state_val_75379 === (2))){
var inst_75370 = (state_75378[(2)]);
var inst_75371 = (f__$1.cljs$core$IFn$_invoke$arity$1 ? f__$1.cljs$core$IFn$_invoke$arity$1(inst_75370) : f__$1.call(null,inst_75370));
var state_75378__$1 = state_75378;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75378__$1,inst_75371);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$transduce_$_state_machine__74102__auto__ = null;
var cljs$core$async$transduce_$_state_machine__74102__auto____0 = (function (){
var statearr_75384 = [null,null,null,null,null,null,null];
(statearr_75384[(0)] = cljs$core$async$transduce_$_state_machine__74102__auto__);

(statearr_75384[(1)] = (1));

return statearr_75384;
});
var cljs$core$async$transduce_$_state_machine__74102__auto____1 = (function (state_75378){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75378);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75385){var ex__74105__auto__ = e75385;
var statearr_75386_76880 = state_75378;
(statearr_75386_76880[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75378[(4)]))){
var statearr_75387_76882 = state_75378;
(statearr_75387_76882[(1)] = cljs.core.first((state_75378[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76883 = state_75378;
state_75378 = G__76883;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__74102__auto__ = function(state_75378){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__74102__auto____1.call(this,state_75378);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__74102__auto____0;
cljs$core$async$transduce_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__74102__auto____1;
return cljs$core$async$transduce_$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75388 = f__74232__auto__();
(statearr_75388[(6)] = c__74231__auto__);

return statearr_75388;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));

return c__74231__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan_BANG_ = (function cljs$core$async$onto_chan_BANG_(var_args){
var G__75390 = arguments.length;
switch (G__75390) {
case 2:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__74231__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75415){
var state_val_75416 = (state_75415[(1)]);
if((state_val_75416 === (7))){
var inst_75397 = (state_75415[(2)]);
var state_75415__$1 = state_75415;
var statearr_75417_76885 = state_75415__$1;
(statearr_75417_76885[(2)] = inst_75397);

(statearr_75417_76885[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (1))){
var inst_75391 = cljs.core.seq(coll);
var inst_75392 = inst_75391;
var state_75415__$1 = (function (){var statearr_75418 = state_75415;
(statearr_75418[(7)] = inst_75392);

return statearr_75418;
})();
var statearr_75419_76886 = state_75415__$1;
(statearr_75419_76886[(2)] = null);

(statearr_75419_76886[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (4))){
var inst_75392 = (state_75415[(7)]);
var inst_75395 = cljs.core.first(inst_75392);
var state_75415__$1 = state_75415;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75415__$1,(7),ch,inst_75395);
} else {
if((state_val_75416 === (13))){
var inst_75409 = (state_75415[(2)]);
var state_75415__$1 = state_75415;
var statearr_75420_76887 = state_75415__$1;
(statearr_75420_76887[(2)] = inst_75409);

(statearr_75420_76887[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (6))){
var inst_75400 = (state_75415[(2)]);
var state_75415__$1 = state_75415;
if(cljs.core.truth_(inst_75400)){
var statearr_75421_76888 = state_75415__$1;
(statearr_75421_76888[(1)] = (8));

} else {
var statearr_75422_76889 = state_75415__$1;
(statearr_75422_76889[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (3))){
var inst_75413 = (state_75415[(2)]);
var state_75415__$1 = state_75415;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75415__$1,inst_75413);
} else {
if((state_val_75416 === (12))){
var state_75415__$1 = state_75415;
var statearr_75423_76890 = state_75415__$1;
(statearr_75423_76890[(2)] = null);

(statearr_75423_76890[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (2))){
var inst_75392 = (state_75415[(7)]);
var state_75415__$1 = state_75415;
if(cljs.core.truth_(inst_75392)){
var statearr_75424_76891 = state_75415__$1;
(statearr_75424_76891[(1)] = (4));

} else {
var statearr_75425_76892 = state_75415__$1;
(statearr_75425_76892[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (11))){
var inst_75406 = cljs.core.async.close_BANG_(ch);
var state_75415__$1 = state_75415;
var statearr_75426_76897 = state_75415__$1;
(statearr_75426_76897[(2)] = inst_75406);

(statearr_75426_76897[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (9))){
var state_75415__$1 = state_75415;
if(cljs.core.truth_(close_QMARK_)){
var statearr_75429_76899 = state_75415__$1;
(statearr_75429_76899[(1)] = (11));

} else {
var statearr_75431_76901 = state_75415__$1;
(statearr_75431_76901[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (5))){
var inst_75392 = (state_75415[(7)]);
var state_75415__$1 = state_75415;
var statearr_75434_76910 = state_75415__$1;
(statearr_75434_76910[(2)] = inst_75392);

(statearr_75434_76910[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (10))){
var inst_75411 = (state_75415[(2)]);
var state_75415__$1 = state_75415;
var statearr_75437_76913 = state_75415__$1;
(statearr_75437_76913[(2)] = inst_75411);

(statearr_75437_76913[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75416 === (8))){
var inst_75392 = (state_75415[(7)]);
var inst_75402 = cljs.core.next(inst_75392);
var inst_75392__$1 = inst_75402;
var state_75415__$1 = (function (){var statearr_75441 = state_75415;
(statearr_75441[(7)] = inst_75392__$1);

return statearr_75441;
})();
var statearr_75442_76923 = state_75415__$1;
(statearr_75442_76923[(2)] = null);

(statearr_75442_76923[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_75443 = [null,null,null,null,null,null,null,null];
(statearr_75443[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_75443[(1)] = (1));

return statearr_75443;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_75415){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75415);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75444){var ex__74105__auto__ = e75444;
var statearr_75445_76929 = state_75415;
(statearr_75445_76929[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75415[(4)]))){
var statearr_75446_76933 = state_75415;
(statearr_75446_76933[(1)] = cljs.core.first((state_75415[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__76934 = state_75415;
state_75415 = G__76934;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_75415){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_75415);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75447 = f__74232__auto__();
(statearr_75447[(6)] = c__74231__auto__);

return statearr_75447;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));

return c__74231__auto__;
}));

(cljs.core.async.onto_chan_BANG_.cljs$lang$maxFixedArity = 3);

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan_BANG_ = (function cljs$core$async$to_chan_BANG_(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});
/**
 * Deprecated - use onto-chan!
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__75449 = arguments.length;
switch (G__75449) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,close_QMARK_);
}));

(cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - use to-chan!
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
return cljs.core.async.to_chan_BANG_(coll);
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

var cljs$core$async$Mux$muxch_STAR_$dyn_76939 = (function (_){
var x__4521__auto__ = (((_ == null))?null:_);
var m__4522__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4522__auto__.call(null,_));
} else {
var m__4519__auto__ = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4519__auto__.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
});
cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
return cljs$core$async$Mux$muxch_STAR_$dyn_76939(_);
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

var cljs$core$async$Mult$tap_STAR_$dyn_76944 = (function (m,ch,close_QMARK_){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4522__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__4519__auto__ = (cljs.core.async.tap_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4519__auto__.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
});
cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
return cljs$core$async$Mult$tap_STAR_$dyn_76944(m,ch,close_QMARK_);
}
});

var cljs$core$async$Mult$untap_STAR_$dyn_76951 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.untap_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
});
cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mult$untap_STAR_$dyn_76951(m,ch);
}
});

var cljs$core$async$Mult$untap_all_STAR_$dyn_76955 = (function (m){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4522__auto__.call(null,m));
} else {
var m__4519__auto__ = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4519__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
});
cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mult$untap_all_STAR_$dyn_76955(m);
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async75450 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async75450 = (function (ch,cs,meta75451){
this.ch = ch;
this.cs = cs;
this.meta75451 = meta75451;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_75452,meta75451__$1){
var self__ = this;
var _75452__$1 = this;
return (new cljs.core.async.t_cljs$core$async75450(self__.ch,self__.cs,meta75451__$1));
}));

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_75452){
var self__ = this;
var _75452__$1 = this;
return self__.meta75451;
}));

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
}));

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
}));

(cljs.core.async.t_cljs$core$async75450.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
}));

(cljs.core.async.t_cljs$core$async75450.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta75451","meta75451",1532449472,null)], null);
}));

(cljs.core.async.t_cljs$core$async75450.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async75450.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async75450");

(cljs.core.async.t_cljs$core$async75450.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async75450");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async75450.
 */
cljs.core.async.__GT_t_cljs$core$async75450 = (function cljs$core$async$mult_$___GT_t_cljs$core$async75450(ch__$1,cs__$1,meta75451){
return (new cljs.core.async.t_cljs$core$async75450(ch__$1,cs__$1,meta75451));
});

}

return (new cljs.core.async.t_cljs$core$async75450(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});
var c__74231__auto___76986 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75594){
var state_val_75597 = (state_75594[(1)]);
if((state_val_75597 === (7))){
var inst_75584 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75606_76987 = state_75594__$1;
(statearr_75606_76987[(2)] = inst_75584);

(statearr_75606_76987[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (20))){
var inst_75487 = (state_75594[(7)]);
var inst_75499 = cljs.core.first(inst_75487);
var inst_75500 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75499,(0),null);
var inst_75501 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75499,(1),null);
var state_75594__$1 = (function (){var statearr_75610 = state_75594;
(statearr_75610[(8)] = inst_75500);

return statearr_75610;
})();
if(cljs.core.truth_(inst_75501)){
var statearr_75611_76988 = state_75594__$1;
(statearr_75611_76988[(1)] = (22));

} else {
var statearr_75612_76989 = state_75594__$1;
(statearr_75612_76989[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (27))){
var inst_75536 = (state_75594[(9)]);
var inst_75456 = (state_75594[(10)]);
var inst_75531 = (state_75594[(11)]);
var inst_75529 = (state_75594[(12)]);
var inst_75536__$1 = cljs.core._nth(inst_75529,inst_75531);
var inst_75537 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_75536__$1,inst_75456,done);
var state_75594__$1 = (function (){var statearr_75617 = state_75594;
(statearr_75617[(9)] = inst_75536__$1);

return statearr_75617;
})();
if(cljs.core.truth_(inst_75537)){
var statearr_75620_76990 = state_75594__$1;
(statearr_75620_76990[(1)] = (30));

} else {
var statearr_75621_76995 = state_75594__$1;
(statearr_75621_76995[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (1))){
var state_75594__$1 = state_75594;
var statearr_75626_76997 = state_75594__$1;
(statearr_75626_76997[(2)] = null);

(statearr_75626_76997[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (24))){
var inst_75487 = (state_75594[(7)]);
var inst_75506 = (state_75594[(2)]);
var inst_75507 = cljs.core.next(inst_75487);
var inst_75465 = inst_75507;
var inst_75466 = null;
var inst_75467 = (0);
var inst_75468 = (0);
var state_75594__$1 = (function (){var statearr_75629 = state_75594;
(statearr_75629[(13)] = inst_75506);

(statearr_75629[(14)] = inst_75465);

(statearr_75629[(15)] = inst_75468);

(statearr_75629[(16)] = inst_75467);

(statearr_75629[(17)] = inst_75466);

return statearr_75629;
})();
var statearr_75630_77011 = state_75594__$1;
(statearr_75630_77011[(2)] = null);

(statearr_75630_77011[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (39))){
var state_75594__$1 = state_75594;
var statearr_75637_77016 = state_75594__$1;
(statearr_75637_77016[(2)] = null);

(statearr_75637_77016[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (4))){
var inst_75456 = (state_75594[(10)]);
var inst_75456__$1 = (state_75594[(2)]);
var inst_75457 = (inst_75456__$1 == null);
var state_75594__$1 = (function (){var statearr_75642 = state_75594;
(statearr_75642[(10)] = inst_75456__$1);

return statearr_75642;
})();
if(cljs.core.truth_(inst_75457)){
var statearr_75643_77017 = state_75594__$1;
(statearr_75643_77017[(1)] = (5));

} else {
var statearr_75644_77018 = state_75594__$1;
(statearr_75644_77018[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (15))){
var inst_75465 = (state_75594[(14)]);
var inst_75468 = (state_75594[(15)]);
var inst_75467 = (state_75594[(16)]);
var inst_75466 = (state_75594[(17)]);
var inst_75483 = (state_75594[(2)]);
var inst_75484 = (inst_75468 + (1));
var tmp75634 = inst_75465;
var tmp75635 = inst_75467;
var tmp75636 = inst_75466;
var inst_75465__$1 = tmp75634;
var inst_75466__$1 = tmp75636;
var inst_75467__$1 = tmp75635;
var inst_75468__$1 = inst_75484;
var state_75594__$1 = (function (){var statearr_75646 = state_75594;
(statearr_75646[(14)] = inst_75465__$1);

(statearr_75646[(15)] = inst_75468__$1);

(statearr_75646[(18)] = inst_75483);

(statearr_75646[(16)] = inst_75467__$1);

(statearr_75646[(17)] = inst_75466__$1);

return statearr_75646;
})();
var statearr_75649_77028 = state_75594__$1;
(statearr_75649_77028[(2)] = null);

(statearr_75649_77028[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (21))){
var inst_75510 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75653_77032 = state_75594__$1;
(statearr_75653_77032[(2)] = inst_75510);

(statearr_75653_77032[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (31))){
var inst_75536 = (state_75594[(9)]);
var inst_75542 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_75536);
var state_75594__$1 = state_75594;
var statearr_75654_77038 = state_75594__$1;
(statearr_75654_77038[(2)] = inst_75542);

(statearr_75654_77038[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (32))){
var inst_75528 = (state_75594[(19)]);
var inst_75531 = (state_75594[(11)]);
var inst_75529 = (state_75594[(12)]);
var inst_75530 = (state_75594[(20)]);
var inst_75544 = (state_75594[(2)]);
var inst_75545 = (inst_75531 + (1));
var tmp75650 = inst_75528;
var tmp75651 = inst_75529;
var tmp75652 = inst_75530;
var inst_75528__$1 = tmp75650;
var inst_75529__$1 = tmp75651;
var inst_75530__$1 = tmp75652;
var inst_75531__$1 = inst_75545;
var state_75594__$1 = (function (){var statearr_75655 = state_75594;
(statearr_75655[(19)] = inst_75528__$1);

(statearr_75655[(21)] = inst_75544);

(statearr_75655[(11)] = inst_75531__$1);

(statearr_75655[(12)] = inst_75529__$1);

(statearr_75655[(20)] = inst_75530__$1);

return statearr_75655;
})();
var statearr_75656_77043 = state_75594__$1;
(statearr_75656_77043[(2)] = null);

(statearr_75656_77043[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (40))){
var inst_75557 = (state_75594[(22)]);
var inst_75561 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_75557);
var state_75594__$1 = state_75594;
var statearr_75657_77044 = state_75594__$1;
(statearr_75657_77044[(2)] = inst_75561);

(statearr_75657_77044[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (33))){
var inst_75548 = (state_75594[(23)]);
var inst_75550 = cljs.core.chunked_seq_QMARK_(inst_75548);
var state_75594__$1 = state_75594;
if(inst_75550){
var statearr_75663_77045 = state_75594__$1;
(statearr_75663_77045[(1)] = (36));

} else {
var statearr_75666_77046 = state_75594__$1;
(statearr_75666_77046[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (13))){
var inst_75477 = (state_75594[(24)]);
var inst_75480 = cljs.core.async.close_BANG_(inst_75477);
var state_75594__$1 = state_75594;
var statearr_75669_77047 = state_75594__$1;
(statearr_75669_77047[(2)] = inst_75480);

(statearr_75669_77047[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (22))){
var inst_75500 = (state_75594[(8)]);
var inst_75503 = cljs.core.async.close_BANG_(inst_75500);
var state_75594__$1 = state_75594;
var statearr_75676_77048 = state_75594__$1;
(statearr_75676_77048[(2)] = inst_75503);

(statearr_75676_77048[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (36))){
var inst_75548 = (state_75594[(23)]);
var inst_75552 = cljs.core.chunk_first(inst_75548);
var inst_75553 = cljs.core.chunk_rest(inst_75548);
var inst_75554 = cljs.core.count(inst_75552);
var inst_75528 = inst_75553;
var inst_75529 = inst_75552;
var inst_75530 = inst_75554;
var inst_75531 = (0);
var state_75594__$1 = (function (){var statearr_75685 = state_75594;
(statearr_75685[(19)] = inst_75528);

(statearr_75685[(11)] = inst_75531);

(statearr_75685[(12)] = inst_75529);

(statearr_75685[(20)] = inst_75530);

return statearr_75685;
})();
var statearr_75686_77049 = state_75594__$1;
(statearr_75686_77049[(2)] = null);

(statearr_75686_77049[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (41))){
var inst_75548 = (state_75594[(23)]);
var inst_75563 = (state_75594[(2)]);
var inst_75564 = cljs.core.next(inst_75548);
var inst_75528 = inst_75564;
var inst_75529 = null;
var inst_75530 = (0);
var inst_75531 = (0);
var state_75594__$1 = (function (){var statearr_75690 = state_75594;
(statearr_75690[(19)] = inst_75528);

(statearr_75690[(25)] = inst_75563);

(statearr_75690[(11)] = inst_75531);

(statearr_75690[(12)] = inst_75529);

(statearr_75690[(20)] = inst_75530);

return statearr_75690;
})();
var statearr_75691_77051 = state_75594__$1;
(statearr_75691_77051[(2)] = null);

(statearr_75691_77051[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (43))){
var state_75594__$1 = state_75594;
var statearr_75695_77052 = state_75594__$1;
(statearr_75695_77052[(2)] = null);

(statearr_75695_77052[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (29))){
var inst_75572 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75697_77053 = state_75594__$1;
(statearr_75697_77053[(2)] = inst_75572);

(statearr_75697_77053[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (44))){
var inst_75581 = (state_75594[(2)]);
var state_75594__$1 = (function (){var statearr_75700 = state_75594;
(statearr_75700[(26)] = inst_75581);

return statearr_75700;
})();
var statearr_75701_77054 = state_75594__$1;
(statearr_75701_77054[(2)] = null);

(statearr_75701_77054[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (6))){
var inst_75520 = (state_75594[(27)]);
var inst_75519 = cljs.core.deref(cs);
var inst_75520__$1 = cljs.core.keys(inst_75519);
var inst_75521 = cljs.core.count(inst_75520__$1);
var inst_75522 = cljs.core.reset_BANG_(dctr,inst_75521);
var inst_75527 = cljs.core.seq(inst_75520__$1);
var inst_75528 = inst_75527;
var inst_75529 = null;
var inst_75530 = (0);
var inst_75531 = (0);
var state_75594__$1 = (function (){var statearr_75706 = state_75594;
(statearr_75706[(19)] = inst_75528);

(statearr_75706[(28)] = inst_75522);

(statearr_75706[(11)] = inst_75531);

(statearr_75706[(12)] = inst_75529);

(statearr_75706[(27)] = inst_75520__$1);

(statearr_75706[(20)] = inst_75530);

return statearr_75706;
})();
var statearr_75710_77055 = state_75594__$1;
(statearr_75710_77055[(2)] = null);

(statearr_75710_77055[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (28))){
var inst_75528 = (state_75594[(19)]);
var inst_75548 = (state_75594[(23)]);
var inst_75548__$1 = cljs.core.seq(inst_75528);
var state_75594__$1 = (function (){var statearr_75711 = state_75594;
(statearr_75711[(23)] = inst_75548__$1);

return statearr_75711;
})();
if(inst_75548__$1){
var statearr_75712_77056 = state_75594__$1;
(statearr_75712_77056[(1)] = (33));

} else {
var statearr_75713_77057 = state_75594__$1;
(statearr_75713_77057[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (25))){
var inst_75531 = (state_75594[(11)]);
var inst_75530 = (state_75594[(20)]);
var inst_75533 = (inst_75531 < inst_75530);
var inst_75534 = inst_75533;
var state_75594__$1 = state_75594;
if(cljs.core.truth_(inst_75534)){
var statearr_75718_77058 = state_75594__$1;
(statearr_75718_77058[(1)] = (27));

} else {
var statearr_75720_77059 = state_75594__$1;
(statearr_75720_77059[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (34))){
var state_75594__$1 = state_75594;
var statearr_75723_77060 = state_75594__$1;
(statearr_75723_77060[(2)] = null);

(statearr_75723_77060[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (17))){
var state_75594__$1 = state_75594;
var statearr_75727_77061 = state_75594__$1;
(statearr_75727_77061[(2)] = null);

(statearr_75727_77061[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (3))){
var inst_75586 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75594__$1,inst_75586);
} else {
if((state_val_75597 === (12))){
var inst_75515 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75735_77066 = state_75594__$1;
(statearr_75735_77066[(2)] = inst_75515);

(statearr_75735_77066[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (2))){
var state_75594__$1 = state_75594;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75594__$1,(4),ch);
} else {
if((state_val_75597 === (23))){
var state_75594__$1 = state_75594;
var statearr_75739_77071 = state_75594__$1;
(statearr_75739_77071[(2)] = null);

(statearr_75739_77071[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (35))){
var inst_75570 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75744_77074 = state_75594__$1;
(statearr_75744_77074[(2)] = inst_75570);

(statearr_75744_77074[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (19))){
var inst_75487 = (state_75594[(7)]);
var inst_75491 = cljs.core.chunk_first(inst_75487);
var inst_75492 = cljs.core.chunk_rest(inst_75487);
var inst_75493 = cljs.core.count(inst_75491);
var inst_75465 = inst_75492;
var inst_75466 = inst_75491;
var inst_75467 = inst_75493;
var inst_75468 = (0);
var state_75594__$1 = (function (){var statearr_75750 = state_75594;
(statearr_75750[(14)] = inst_75465);

(statearr_75750[(15)] = inst_75468);

(statearr_75750[(16)] = inst_75467);

(statearr_75750[(17)] = inst_75466);

return statearr_75750;
})();
var statearr_75754_77082 = state_75594__$1;
(statearr_75754_77082[(2)] = null);

(statearr_75754_77082[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (11))){
var inst_75465 = (state_75594[(14)]);
var inst_75487 = (state_75594[(7)]);
var inst_75487__$1 = cljs.core.seq(inst_75465);
var state_75594__$1 = (function (){var statearr_75755 = state_75594;
(statearr_75755[(7)] = inst_75487__$1);

return statearr_75755;
})();
if(inst_75487__$1){
var statearr_75760_77083 = state_75594__$1;
(statearr_75760_77083[(1)] = (16));

} else {
var statearr_75761_77085 = state_75594__$1;
(statearr_75761_77085[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (9))){
var inst_75517 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75765_77087 = state_75594__$1;
(statearr_75765_77087[(2)] = inst_75517);

(statearr_75765_77087[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (5))){
var inst_75463 = cljs.core.deref(cs);
var inst_75464 = cljs.core.seq(inst_75463);
var inst_75465 = inst_75464;
var inst_75466 = null;
var inst_75467 = (0);
var inst_75468 = (0);
var state_75594__$1 = (function (){var statearr_75772 = state_75594;
(statearr_75772[(14)] = inst_75465);

(statearr_75772[(15)] = inst_75468);

(statearr_75772[(16)] = inst_75467);

(statearr_75772[(17)] = inst_75466);

return statearr_75772;
})();
var statearr_75773_77088 = state_75594__$1;
(statearr_75773_77088[(2)] = null);

(statearr_75773_77088[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (14))){
var state_75594__$1 = state_75594;
var statearr_75784_77089 = state_75594__$1;
(statearr_75784_77089[(2)] = null);

(statearr_75784_77089[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (45))){
var inst_75578 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75785_77091 = state_75594__$1;
(statearr_75785_77091[(2)] = inst_75578);

(statearr_75785_77091[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (26))){
var inst_75520 = (state_75594[(27)]);
var inst_75574 = (state_75594[(2)]);
var inst_75575 = cljs.core.seq(inst_75520);
var state_75594__$1 = (function (){var statearr_75792 = state_75594;
(statearr_75792[(29)] = inst_75574);

return statearr_75792;
})();
if(inst_75575){
var statearr_75793_77093 = state_75594__$1;
(statearr_75793_77093[(1)] = (42));

} else {
var statearr_75794_77094 = state_75594__$1;
(statearr_75794_77094[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (16))){
var inst_75487 = (state_75594[(7)]);
var inst_75489 = cljs.core.chunked_seq_QMARK_(inst_75487);
var state_75594__$1 = state_75594;
if(inst_75489){
var statearr_75798_77095 = state_75594__$1;
(statearr_75798_77095[(1)] = (19));

} else {
var statearr_75800_77096 = state_75594__$1;
(statearr_75800_77096[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (38))){
var inst_75567 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75803_77097 = state_75594__$1;
(statearr_75803_77097[(2)] = inst_75567);

(statearr_75803_77097[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (30))){
var state_75594__$1 = state_75594;
var statearr_75807_77098 = state_75594__$1;
(statearr_75807_77098[(2)] = null);

(statearr_75807_77098[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (10))){
var inst_75468 = (state_75594[(15)]);
var inst_75466 = (state_75594[(17)]);
var inst_75476 = cljs.core._nth(inst_75466,inst_75468);
var inst_75477 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75476,(0),null);
var inst_75478 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75476,(1),null);
var state_75594__$1 = (function (){var statearr_75814 = state_75594;
(statearr_75814[(24)] = inst_75477);

return statearr_75814;
})();
if(cljs.core.truth_(inst_75478)){
var statearr_75819_77099 = state_75594__$1;
(statearr_75819_77099[(1)] = (13));

} else {
var statearr_75820_77100 = state_75594__$1;
(statearr_75820_77100[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (18))){
var inst_75513 = (state_75594[(2)]);
var state_75594__$1 = state_75594;
var statearr_75821_77101 = state_75594__$1;
(statearr_75821_77101[(2)] = inst_75513);

(statearr_75821_77101[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (42))){
var state_75594__$1 = state_75594;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_75594__$1,(45),dchan);
} else {
if((state_val_75597 === (37))){
var inst_75557 = (state_75594[(22)]);
var inst_75456 = (state_75594[(10)]);
var inst_75548 = (state_75594[(23)]);
var inst_75557__$1 = cljs.core.first(inst_75548);
var inst_75558 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_75557__$1,inst_75456,done);
var state_75594__$1 = (function (){var statearr_75828 = state_75594;
(statearr_75828[(22)] = inst_75557__$1);

return statearr_75828;
})();
if(cljs.core.truth_(inst_75558)){
var statearr_75830_77102 = state_75594__$1;
(statearr_75830_77102[(1)] = (39));

} else {
var statearr_75835_77103 = state_75594__$1;
(statearr_75835_77103[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75597 === (8))){
var inst_75468 = (state_75594[(15)]);
var inst_75467 = (state_75594[(16)]);
var inst_75470 = (inst_75468 < inst_75467);
var inst_75471 = inst_75470;
var state_75594__$1 = state_75594;
if(cljs.core.truth_(inst_75471)){
var statearr_75840_77104 = state_75594__$1;
(statearr_75840_77104[(1)] = (10));

} else {
var statearr_75841_77105 = state_75594__$1;
(statearr_75841_77105[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mult_$_state_machine__74102__auto__ = null;
var cljs$core$async$mult_$_state_machine__74102__auto____0 = (function (){
var statearr_75844 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_75844[(0)] = cljs$core$async$mult_$_state_machine__74102__auto__);

(statearr_75844[(1)] = (1));

return statearr_75844;
});
var cljs$core$async$mult_$_state_machine__74102__auto____1 = (function (state_75594){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75594);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75845){var ex__74105__auto__ = e75845;
var statearr_75846_77110 = state_75594;
(statearr_75846_77110[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75594[(4)]))){
var statearr_75850_77111 = state_75594;
(statearr_75850_77111[(1)] = cljs.core.first((state_75594[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77112 = state_75594;
state_75594 = G__77112;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__74102__auto__ = function(state_75594){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__74102__auto____1.call(this,state_75594);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__74102__auto____0;
cljs$core$async$mult_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__74102__auto____1;
return cljs$core$async$mult_$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_75857 = f__74232__auto__();
(statearr_75857[(6)] = c__74231__auto___76986);

return statearr_75857;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__75862 = arguments.length;
switch (G__75862) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
}));

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
}));

(cljs.core.async.tap.cljs$lang$maxFixedArity = 3);

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

var cljs$core$async$Mix$admix_STAR_$dyn_77118 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.admix_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
});
cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$admix_STAR_$dyn_77118(m,ch);
}
});

var cljs$core$async$Mix$unmix_STAR_$dyn_77122 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
});
cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$unmix_STAR_$dyn_77122(m,ch);
}
});

var cljs$core$async$Mix$unmix_all_STAR_$dyn_77129 = (function (m){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4522__auto__.call(null,m));
} else {
var m__4519__auto__ = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4519__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
});
cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mix$unmix_all_STAR_$dyn_77129(m);
}
});

var cljs$core$async$Mix$toggle_STAR_$dyn_77134 = (function (m,state_map){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4522__auto__.call(null,m,state_map));
} else {
var m__4519__auto__ = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4519__auto__.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
});
cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
return cljs$core$async$Mix$toggle_STAR_$dyn_77134(m,state_map);
}
});

var cljs$core$async$Mix$solo_mode_STAR_$dyn_77135 = (function (m,mode){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4522__auto__.call(null,m,mode));
} else {
var m__4519__auto__ = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4519__auto__.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
});
cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
return cljs$core$async$Mix$solo_mode_STAR_$dyn_77135(m,mode);
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4835__auto__ = [];
var len__4829__auto___77136 = arguments.length;
var i__4830__auto___77137 = (0);
while(true){
if((i__4830__auto___77137 < len__4829__auto___77136)){
args__4835__auto__.push((arguments[i__4830__auto___77137]));

var G__77138 = (i__4830__auto___77137 + (1));
i__4830__auto___77137 = G__77138;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((3) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4836__auto__);
});

(cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__75881){
var map__75882 = p__75881;
var map__75882__$1 = cljs.core.__destructure_map(map__75882);
var opts = map__75882__$1;
var statearr_75883_77139 = state;
(statearr_75883_77139[(1)] = cont_block);


var temp__5753__auto__ = cljs.core.async.do_alts((function (val){
var statearr_75884_77140 = state;
(statearr_75884_77140[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
}),ports,opts);
if(cljs.core.truth_(temp__5753__auto__)){
var cb = temp__5753__auto__;
var statearr_75885_77141 = state;
(statearr_75885_77141[(2)] = cljs.core.deref(cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}));

(cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq75877){
var G__75878 = cljs.core.first(seq75877);
var seq75877__$1 = cljs.core.next(seq75877);
var G__75879 = cljs.core.first(seq75877__$1);
var seq75877__$2 = cljs.core.next(seq75877__$1);
var G__75880 = cljs.core.first(seq75877__$2);
var seq75877__$3 = cljs.core.next(seq75877__$2);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__75878,G__75879,G__75880,seq75877__$3);
}));

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.async.sliding_buffer((1)));
var changed = (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});
var pick = (function (attr,chs){
return cljs.core.reduce_kv((function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
}),cljs.core.PersistentHashSet.EMPTY,chs);
});
var calc_state = (function (){
var chs = cljs.core.deref(cs);
var mode = cljs.core.deref(solo_mode);
var solos = pick(new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick(new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick(new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.cljs$core$IFn$_invoke$arity$2(((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && ((!(cljs.core.empty_QMARK_(solos))))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async75886 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async75886 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta75887){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta75887 = meta75887;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_75888,meta75887__$1){
var self__ = this;
var _75888__$1 = this;
return (new cljs.core.async.t_cljs$core$async75886(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta75887__$1));
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_75888){
var self__ = this;
var _75888__$1 = this;
return self__.meta75887;
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async75886.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error(["Assert failed: ",["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join(''),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_(self__.solo_mode,mode);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async75886.getBasis = (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta75887","meta75887",-672559865,null)], null);
}));

(cljs.core.async.t_cljs$core$async75886.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async75886.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async75886");

(cljs.core.async.t_cljs$core$async75886.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async75886");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async75886.
 */
cljs.core.async.__GT_t_cljs$core$async75886 = (function cljs$core$async$mix_$___GT_t_cljs$core$async75886(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta75887){
return (new cljs.core.async.t_cljs$core$async75886(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta75887));
});

}

return (new cljs.core.async.t_cljs$core$async75886(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__74231__auto___77148 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_75956){
var state_val_75957 = (state_75956[(1)]);
if((state_val_75957 === (7))){
var inst_75916 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
if(cljs.core.truth_(inst_75916)){
var statearr_75958_77149 = state_75956__$1;
(statearr_75958_77149[(1)] = (8));

} else {
var statearr_75959_77150 = state_75956__$1;
(statearr_75959_77150[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (20))){
var inst_75909 = (state_75956[(7)]);
var state_75956__$1 = state_75956;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_75956__$1,(23),out,inst_75909);
} else {
if((state_val_75957 === (1))){
var inst_75892 = calc_state();
var inst_75893 = cljs.core.__destructure_map(inst_75892);
var inst_75894 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75893,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_75895 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75893,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_75896 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75893,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_75897 = inst_75892;
var state_75956__$1 = (function (){var statearr_75960 = state_75956;
(statearr_75960[(8)] = inst_75897);

(statearr_75960[(9)] = inst_75896);

(statearr_75960[(10)] = inst_75895);

(statearr_75960[(11)] = inst_75894);

return statearr_75960;
})();
var statearr_75961_77157 = state_75956__$1;
(statearr_75961_77157[(2)] = null);

(statearr_75961_77157[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (24))){
var inst_75900 = (state_75956[(12)]);
var inst_75897 = inst_75900;
var state_75956__$1 = (function (){var statearr_75962 = state_75956;
(statearr_75962[(8)] = inst_75897);

return statearr_75962;
})();
var statearr_75963_77158 = state_75956__$1;
(statearr_75963_77158[(2)] = null);

(statearr_75963_77158[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (4))){
var inst_75911 = (state_75956[(13)]);
var inst_75909 = (state_75956[(7)]);
var inst_75908 = (state_75956[(2)]);
var inst_75909__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75908,(0),null);
var inst_75910 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_75908,(1),null);
var inst_75911__$1 = (inst_75909__$1 == null);
var state_75956__$1 = (function (){var statearr_75964 = state_75956;
(statearr_75964[(13)] = inst_75911__$1);

(statearr_75964[(14)] = inst_75910);

(statearr_75964[(7)] = inst_75909__$1);

return statearr_75964;
})();
if(cljs.core.truth_(inst_75911__$1)){
var statearr_75965_77159 = state_75956__$1;
(statearr_75965_77159[(1)] = (5));

} else {
var statearr_75966_77160 = state_75956__$1;
(statearr_75966_77160[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (15))){
var inst_75930 = (state_75956[(15)]);
var inst_75901 = (state_75956[(16)]);
var inst_75930__$1 = cljs.core.empty_QMARK_(inst_75901);
var state_75956__$1 = (function (){var statearr_75967 = state_75956;
(statearr_75967[(15)] = inst_75930__$1);

return statearr_75967;
})();
if(inst_75930__$1){
var statearr_75968_77161 = state_75956__$1;
(statearr_75968_77161[(1)] = (17));

} else {
var statearr_75969_77162 = state_75956__$1;
(statearr_75969_77162[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (21))){
var inst_75900 = (state_75956[(12)]);
var inst_75897 = inst_75900;
var state_75956__$1 = (function (){var statearr_75970 = state_75956;
(statearr_75970[(8)] = inst_75897);

return statearr_75970;
})();
var statearr_75971_77163 = state_75956__$1;
(statearr_75971_77163[(2)] = null);

(statearr_75971_77163[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (13))){
var inst_75923 = (state_75956[(2)]);
var inst_75924 = calc_state();
var inst_75897 = inst_75924;
var state_75956__$1 = (function (){var statearr_75972 = state_75956;
(statearr_75972[(8)] = inst_75897);

(statearr_75972[(17)] = inst_75923);

return statearr_75972;
})();
var statearr_75973_77164 = state_75956__$1;
(statearr_75973_77164[(2)] = null);

(statearr_75973_77164[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (22))){
var inst_75950 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
var statearr_75974_77165 = state_75956__$1;
(statearr_75974_77165[(2)] = inst_75950);

(statearr_75974_77165[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (6))){
var inst_75910 = (state_75956[(14)]);
var inst_75914 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_75910,change);
var state_75956__$1 = state_75956;
var statearr_75975_77166 = state_75956__$1;
(statearr_75975_77166[(2)] = inst_75914);

(statearr_75975_77166[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (25))){
var state_75956__$1 = state_75956;
var statearr_75976_77167 = state_75956__$1;
(statearr_75976_77167[(2)] = null);

(statearr_75976_77167[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (17))){
var inst_75902 = (state_75956[(18)]);
var inst_75910 = (state_75956[(14)]);
var inst_75932 = (inst_75902.cljs$core$IFn$_invoke$arity$1 ? inst_75902.cljs$core$IFn$_invoke$arity$1(inst_75910) : inst_75902.call(null,inst_75910));
var inst_75933 = cljs.core.not(inst_75932);
var state_75956__$1 = state_75956;
var statearr_75977_77168 = state_75956__$1;
(statearr_75977_77168[(2)] = inst_75933);

(statearr_75977_77168[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (3))){
var inst_75954 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
return cljs.core.async.impl.ioc_helpers.return_chan(state_75956__$1,inst_75954);
} else {
if((state_val_75957 === (12))){
var state_75956__$1 = state_75956;
var statearr_75978_77169 = state_75956__$1;
(statearr_75978_77169[(2)] = null);

(statearr_75978_77169[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (2))){
var inst_75897 = (state_75956[(8)]);
var inst_75900 = (state_75956[(12)]);
var inst_75900__$1 = cljs.core.__destructure_map(inst_75897);
var inst_75901 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75900__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_75902 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75900__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_75903 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_75900__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_75956__$1 = (function (){var statearr_75979 = state_75956;
(statearr_75979[(18)] = inst_75902);

(statearr_75979[(12)] = inst_75900__$1);

(statearr_75979[(16)] = inst_75901);

return statearr_75979;
})();
return cljs.core.async.ioc_alts_BANG_(state_75956__$1,(4),inst_75903);
} else {
if((state_val_75957 === (23))){
var inst_75941 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
if(cljs.core.truth_(inst_75941)){
var statearr_75980_77170 = state_75956__$1;
(statearr_75980_77170[(1)] = (24));

} else {
var statearr_75981_77171 = state_75956__$1;
(statearr_75981_77171[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (19))){
var inst_75936 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
var statearr_75982_77178 = state_75956__$1;
(statearr_75982_77178[(2)] = inst_75936);

(statearr_75982_77178[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (11))){
var inst_75910 = (state_75956[(14)]);
var inst_75920 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_75910);
var state_75956__$1 = state_75956;
var statearr_75983_77179 = state_75956__$1;
(statearr_75983_77179[(2)] = inst_75920);

(statearr_75983_77179[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (9))){
var inst_75927 = (state_75956[(19)]);
var inst_75910 = (state_75956[(14)]);
var inst_75901 = (state_75956[(16)]);
var inst_75927__$1 = (inst_75901.cljs$core$IFn$_invoke$arity$1 ? inst_75901.cljs$core$IFn$_invoke$arity$1(inst_75910) : inst_75901.call(null,inst_75910));
var state_75956__$1 = (function (){var statearr_75984 = state_75956;
(statearr_75984[(19)] = inst_75927__$1);

return statearr_75984;
})();
if(cljs.core.truth_(inst_75927__$1)){
var statearr_75985_77180 = state_75956__$1;
(statearr_75985_77180[(1)] = (14));

} else {
var statearr_75986_77181 = state_75956__$1;
(statearr_75986_77181[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (5))){
var inst_75911 = (state_75956[(13)]);
var state_75956__$1 = state_75956;
var statearr_75987_77182 = state_75956__$1;
(statearr_75987_77182[(2)] = inst_75911);

(statearr_75987_77182[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (14))){
var inst_75927 = (state_75956[(19)]);
var state_75956__$1 = state_75956;
var statearr_75988_77183 = state_75956__$1;
(statearr_75988_77183[(2)] = inst_75927);

(statearr_75988_77183[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (26))){
var inst_75946 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
var statearr_75989_77184 = state_75956__$1;
(statearr_75989_77184[(2)] = inst_75946);

(statearr_75989_77184[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (16))){
var inst_75938 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
if(cljs.core.truth_(inst_75938)){
var statearr_75990_77185 = state_75956__$1;
(statearr_75990_77185[(1)] = (20));

} else {
var statearr_75991_77186 = state_75956__$1;
(statearr_75991_77186[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (10))){
var inst_75952 = (state_75956[(2)]);
var state_75956__$1 = state_75956;
var statearr_75992_77187 = state_75956__$1;
(statearr_75992_77187[(2)] = inst_75952);

(statearr_75992_77187[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (18))){
var inst_75930 = (state_75956[(15)]);
var state_75956__$1 = state_75956;
var statearr_75993_77188 = state_75956__$1;
(statearr_75993_77188[(2)] = inst_75930);

(statearr_75993_77188[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_75957 === (8))){
var inst_75909 = (state_75956[(7)]);
var inst_75918 = (inst_75909 == null);
var state_75956__$1 = state_75956;
if(cljs.core.truth_(inst_75918)){
var statearr_75994_77189 = state_75956__$1;
(statearr_75994_77189[(1)] = (11));

} else {
var statearr_75995_77190 = state_75956__$1;
(statearr_75995_77190[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mix_$_state_machine__74102__auto__ = null;
var cljs$core$async$mix_$_state_machine__74102__auto____0 = (function (){
var statearr_75996 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_75996[(0)] = cljs$core$async$mix_$_state_machine__74102__auto__);

(statearr_75996[(1)] = (1));

return statearr_75996;
});
var cljs$core$async$mix_$_state_machine__74102__auto____1 = (function (state_75956){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_75956);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e75997){var ex__74105__auto__ = e75997;
var statearr_75998_77191 = state_75956;
(statearr_75998_77191[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_75956[(4)]))){
var statearr_75999_77192 = state_75956;
(statearr_75999_77192[(1)] = cljs.core.first((state_75956[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77193 = state_75956;
state_75956 = G__77193;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__74102__auto__ = function(state_75956){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__74102__auto____1.call(this,state_75956);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__74102__auto____0;
cljs$core$async$mix_$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__74102__auto____1;
return cljs$core$async$mix_$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76000 = f__74232__auto__();
(statearr_76000[(6)] = c__74231__auto___77148);

return statearr_76000;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

var cljs$core$async$Pub$sub_STAR_$dyn_77194 = (function (p,v,ch,close_QMARK_){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4522__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__4519__auto__ = (cljs.core.async.sub_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4519__auto__.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
});
cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
return cljs$core$async$Pub$sub_STAR_$dyn_77194(p,v,ch,close_QMARK_);
}
});

var cljs$core$async$Pub$unsub_STAR_$dyn_77195 = (function (p,v,ch){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4522__auto__.call(null,p,v,ch));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4519__auto__.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
});
cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
return cljs$core$async$Pub$unsub_STAR_$dyn_77195(p,v,ch);
}
});

var cljs$core$async$Pub$unsub_all_STAR_$dyn_77196 = (function() {
var G__77197 = null;
var G__77197__1 = (function (p){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4522__auto__.call(null,p));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4519__auto__.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
var G__77197__2 = (function (p,v){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4522__auto__.call(null,p,v));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4519__auto__.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
G__77197 = function(p,v){
switch(arguments.length){
case 1:
return G__77197__1.call(this,p);
case 2:
return G__77197__2.call(this,p,v);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__77197.cljs$core$IFn$_invoke$arity$1 = G__77197__1;
G__77197.cljs$core$IFn$_invoke$arity$2 = G__77197__2;
return G__77197;
})()
;
cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__76002 = arguments.length;
switch (G__76002) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_77196(p);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_77196(p,v);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2);


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__76005 = arguments.length;
switch (G__76005) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
}));

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = (function (topic){
var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(mults),topic);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,(function (p1__76003_SHARP_){
if(cljs.core.truth_((p1__76003_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__76003_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__76003_SHARP_.call(null,topic)))){
return p1__76003_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__76003_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
})),topic);
}
});
var p = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async76006 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async76006 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta76007){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta76007 = meta76007;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_76008,meta76007__$1){
var self__ = this;
var _76008__$1 = this;
return (new cljs.core.async.t_cljs$core$async76006(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta76007__$1));
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_76008){
var self__ = this;
var _76008__$1 = this;
return self__.meta76007;
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5753__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self__.mults),topic);
if(cljs.core.truth_(temp__5753__auto__)){
var m = temp__5753__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_(self__.mults,cljs.core.PersistentArrayMap.EMPTY);
}));

(cljs.core.async.t_cljs$core$async76006.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
}));

(cljs.core.async.t_cljs$core$async76006.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta76007","meta76007",-1144895019,null)], null);
}));

(cljs.core.async.t_cljs$core$async76006.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async76006.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async76006");

(cljs.core.async.t_cljs$core$async76006.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async76006");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async76006.
 */
cljs.core.async.__GT_t_cljs$core$async76006 = (function cljs$core$async$__GT_t_cljs$core$async76006(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta76007){
return (new cljs.core.async.t_cljs$core$async76006(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta76007));
});

}

return (new cljs.core.async.t_cljs$core$async76006(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__74231__auto___77205 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76080){
var state_val_76081 = (state_76080[(1)]);
if((state_val_76081 === (7))){
var inst_76076 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76082_77206 = state_76080__$1;
(statearr_76082_77206[(2)] = inst_76076);

(statearr_76082_77206[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (20))){
var state_76080__$1 = state_76080;
var statearr_76083_77207 = state_76080__$1;
(statearr_76083_77207[(2)] = null);

(statearr_76083_77207[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (1))){
var state_76080__$1 = state_76080;
var statearr_76084_77208 = state_76080__$1;
(statearr_76084_77208[(2)] = null);

(statearr_76084_77208[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (24))){
var inst_76059 = (state_76080[(7)]);
var inst_76068 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_76059);
var state_76080__$1 = state_76080;
var statearr_76085_77209 = state_76080__$1;
(statearr_76085_77209[(2)] = inst_76068);

(statearr_76085_77209[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (4))){
var inst_76011 = (state_76080[(8)]);
var inst_76011__$1 = (state_76080[(2)]);
var inst_76012 = (inst_76011__$1 == null);
var state_76080__$1 = (function (){var statearr_76086 = state_76080;
(statearr_76086[(8)] = inst_76011__$1);

return statearr_76086;
})();
if(cljs.core.truth_(inst_76012)){
var statearr_76087_77210 = state_76080__$1;
(statearr_76087_77210[(1)] = (5));

} else {
var statearr_76088_77211 = state_76080__$1;
(statearr_76088_77211[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (15))){
var inst_76053 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76089_77213 = state_76080__$1;
(statearr_76089_77213[(2)] = inst_76053);

(statearr_76089_77213[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (21))){
var inst_76073 = (state_76080[(2)]);
var state_76080__$1 = (function (){var statearr_76090 = state_76080;
(statearr_76090[(9)] = inst_76073);

return statearr_76090;
})();
var statearr_76091_77215 = state_76080__$1;
(statearr_76091_77215[(2)] = null);

(statearr_76091_77215[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (13))){
var inst_76035 = (state_76080[(10)]);
var inst_76037 = cljs.core.chunked_seq_QMARK_(inst_76035);
var state_76080__$1 = state_76080;
if(inst_76037){
var statearr_76092_77216 = state_76080__$1;
(statearr_76092_77216[(1)] = (16));

} else {
var statearr_76093_77217 = state_76080__$1;
(statearr_76093_77217[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (22))){
var inst_76065 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
if(cljs.core.truth_(inst_76065)){
var statearr_76094_77218 = state_76080__$1;
(statearr_76094_77218[(1)] = (23));

} else {
var statearr_76095_77219 = state_76080__$1;
(statearr_76095_77219[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (6))){
var inst_76061 = (state_76080[(11)]);
var inst_76011 = (state_76080[(8)]);
var inst_76059 = (state_76080[(7)]);
var inst_76059__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_76011) : topic_fn.call(null,inst_76011));
var inst_76060 = cljs.core.deref(mults);
var inst_76061__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_76060,inst_76059__$1);
var state_76080__$1 = (function (){var statearr_76096 = state_76080;
(statearr_76096[(11)] = inst_76061__$1);

(statearr_76096[(7)] = inst_76059__$1);

return statearr_76096;
})();
if(cljs.core.truth_(inst_76061__$1)){
var statearr_76097_77220 = state_76080__$1;
(statearr_76097_77220[(1)] = (19));

} else {
var statearr_76098_77221 = state_76080__$1;
(statearr_76098_77221[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (25))){
var inst_76070 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76099_77222 = state_76080__$1;
(statearr_76099_77222[(2)] = inst_76070);

(statearr_76099_77222[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (17))){
var inst_76035 = (state_76080[(10)]);
var inst_76044 = cljs.core.first(inst_76035);
var inst_76045 = cljs.core.async.muxch_STAR_(inst_76044);
var inst_76046 = cljs.core.async.close_BANG_(inst_76045);
var inst_76047 = cljs.core.next(inst_76035);
var inst_76021 = inst_76047;
var inst_76022 = null;
var inst_76023 = (0);
var inst_76024 = (0);
var state_76080__$1 = (function (){var statearr_76100 = state_76080;
(statearr_76100[(12)] = inst_76022);

(statearr_76100[(13)] = inst_76023);

(statearr_76100[(14)] = inst_76024);

(statearr_76100[(15)] = inst_76046);

(statearr_76100[(16)] = inst_76021);

return statearr_76100;
})();
var statearr_76101_77224 = state_76080__$1;
(statearr_76101_77224[(2)] = null);

(statearr_76101_77224[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (3))){
var inst_76078 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76080__$1,inst_76078);
} else {
if((state_val_76081 === (12))){
var inst_76055 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76102_77226 = state_76080__$1;
(statearr_76102_77226[(2)] = inst_76055);

(statearr_76102_77226[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (2))){
var state_76080__$1 = state_76080;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76080__$1,(4),ch);
} else {
if((state_val_76081 === (23))){
var state_76080__$1 = state_76080;
var statearr_76103_77227 = state_76080__$1;
(statearr_76103_77227[(2)] = null);

(statearr_76103_77227[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (19))){
var inst_76061 = (state_76080[(11)]);
var inst_76011 = (state_76080[(8)]);
var inst_76063 = cljs.core.async.muxch_STAR_(inst_76061);
var state_76080__$1 = state_76080;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76080__$1,(22),inst_76063,inst_76011);
} else {
if((state_val_76081 === (11))){
var inst_76035 = (state_76080[(10)]);
var inst_76021 = (state_76080[(16)]);
var inst_76035__$1 = cljs.core.seq(inst_76021);
var state_76080__$1 = (function (){var statearr_76104 = state_76080;
(statearr_76104[(10)] = inst_76035__$1);

return statearr_76104;
})();
if(inst_76035__$1){
var statearr_76105_77228 = state_76080__$1;
(statearr_76105_77228[(1)] = (13));

} else {
var statearr_76106_77229 = state_76080__$1;
(statearr_76106_77229[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (9))){
var inst_76057 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76107_77230 = state_76080__$1;
(statearr_76107_77230[(2)] = inst_76057);

(statearr_76107_77230[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (5))){
var inst_76018 = cljs.core.deref(mults);
var inst_76019 = cljs.core.vals(inst_76018);
var inst_76020 = cljs.core.seq(inst_76019);
var inst_76021 = inst_76020;
var inst_76022 = null;
var inst_76023 = (0);
var inst_76024 = (0);
var state_76080__$1 = (function (){var statearr_76108 = state_76080;
(statearr_76108[(12)] = inst_76022);

(statearr_76108[(13)] = inst_76023);

(statearr_76108[(14)] = inst_76024);

(statearr_76108[(16)] = inst_76021);

return statearr_76108;
})();
var statearr_76109_77231 = state_76080__$1;
(statearr_76109_77231[(2)] = null);

(statearr_76109_77231[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (14))){
var state_76080__$1 = state_76080;
var statearr_76113_77232 = state_76080__$1;
(statearr_76113_77232[(2)] = null);

(statearr_76113_77232[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (16))){
var inst_76035 = (state_76080[(10)]);
var inst_76039 = cljs.core.chunk_first(inst_76035);
var inst_76040 = cljs.core.chunk_rest(inst_76035);
var inst_76041 = cljs.core.count(inst_76039);
var inst_76021 = inst_76040;
var inst_76022 = inst_76039;
var inst_76023 = inst_76041;
var inst_76024 = (0);
var state_76080__$1 = (function (){var statearr_76114 = state_76080;
(statearr_76114[(12)] = inst_76022);

(statearr_76114[(13)] = inst_76023);

(statearr_76114[(14)] = inst_76024);

(statearr_76114[(16)] = inst_76021);

return statearr_76114;
})();
var statearr_76115_77233 = state_76080__$1;
(statearr_76115_77233[(2)] = null);

(statearr_76115_77233[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (10))){
var inst_76022 = (state_76080[(12)]);
var inst_76023 = (state_76080[(13)]);
var inst_76024 = (state_76080[(14)]);
var inst_76021 = (state_76080[(16)]);
var inst_76029 = cljs.core._nth(inst_76022,inst_76024);
var inst_76030 = cljs.core.async.muxch_STAR_(inst_76029);
var inst_76031 = cljs.core.async.close_BANG_(inst_76030);
var inst_76032 = (inst_76024 + (1));
var tmp76110 = inst_76022;
var tmp76111 = inst_76023;
var tmp76112 = inst_76021;
var inst_76021__$1 = tmp76112;
var inst_76022__$1 = tmp76110;
var inst_76023__$1 = tmp76111;
var inst_76024__$1 = inst_76032;
var state_76080__$1 = (function (){var statearr_76116 = state_76080;
(statearr_76116[(12)] = inst_76022__$1);

(statearr_76116[(13)] = inst_76023__$1);

(statearr_76116[(14)] = inst_76024__$1);

(statearr_76116[(17)] = inst_76031);

(statearr_76116[(16)] = inst_76021__$1);

return statearr_76116;
})();
var statearr_76117_77234 = state_76080__$1;
(statearr_76117_77234[(2)] = null);

(statearr_76117_77234[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (18))){
var inst_76050 = (state_76080[(2)]);
var state_76080__$1 = state_76080;
var statearr_76118_77235 = state_76080__$1;
(statearr_76118_77235[(2)] = inst_76050);

(statearr_76118_77235[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76081 === (8))){
var inst_76023 = (state_76080[(13)]);
var inst_76024 = (state_76080[(14)]);
var inst_76026 = (inst_76024 < inst_76023);
var inst_76027 = inst_76026;
var state_76080__$1 = state_76080;
if(cljs.core.truth_(inst_76027)){
var statearr_76119_77236 = state_76080__$1;
(statearr_76119_77236[(1)] = (10));

} else {
var statearr_76120_77237 = state_76080__$1;
(statearr_76120_77237[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76121 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76121[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76121[(1)] = (1));

return statearr_76121;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76080){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76080);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76122){var ex__74105__auto__ = e76122;
var statearr_76123_77239 = state_76080;
(statearr_76123_77239[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76080[(4)]))){
var statearr_76124_77240 = state_76080;
(statearr_76124_77240[(1)] = cljs.core.first((state_76080[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77242 = state_76080;
state_76080 = G__77242;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76080){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76080);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76125 = f__74232__auto__();
(statearr_76125[(6)] = c__74231__auto___77205);

return statearr_76125;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return p;
}));

(cljs.core.async.pub.cljs$lang$maxFixedArity = 3);

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__76127 = arguments.length;
switch (G__76127) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
}));

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
}));

(cljs.core.async.sub.cljs$lang$maxFixedArity = 4);

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__76129 = arguments.length;
switch (G__76129) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_(p);
}));

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_(p,topic);
}));

(cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2);

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__76131 = arguments.length;
switch (G__76131) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
}));

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (i){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
}),cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__74231__auto___77246 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76174){
var state_val_76175 = (state_76174[(1)]);
if((state_val_76175 === (7))){
var state_76174__$1 = state_76174;
var statearr_76176_77247 = state_76174__$1;
(statearr_76176_77247[(2)] = null);

(statearr_76176_77247[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (1))){
var state_76174__$1 = state_76174;
var statearr_76177_77248 = state_76174__$1;
(statearr_76177_77248[(2)] = null);

(statearr_76177_77248[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (4))){
var inst_76135 = (state_76174[(7)]);
var inst_76134 = (state_76174[(8)]);
var inst_76137 = (inst_76135 < inst_76134);
var state_76174__$1 = state_76174;
if(cljs.core.truth_(inst_76137)){
var statearr_76178_77249 = state_76174__$1;
(statearr_76178_77249[(1)] = (6));

} else {
var statearr_76179_77250 = state_76174__$1;
(statearr_76179_77250[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (15))){
var inst_76160 = (state_76174[(9)]);
var inst_76165 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_76160);
var state_76174__$1 = state_76174;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76174__$1,(17),out,inst_76165);
} else {
if((state_val_76175 === (13))){
var inst_76160 = (state_76174[(9)]);
var inst_76160__$1 = (state_76174[(2)]);
var inst_76161 = cljs.core.some(cljs.core.nil_QMARK_,inst_76160__$1);
var state_76174__$1 = (function (){var statearr_76180 = state_76174;
(statearr_76180[(9)] = inst_76160__$1);

return statearr_76180;
})();
if(cljs.core.truth_(inst_76161)){
var statearr_76181_77251 = state_76174__$1;
(statearr_76181_77251[(1)] = (14));

} else {
var statearr_76182_77252 = state_76174__$1;
(statearr_76182_77252[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (6))){
var state_76174__$1 = state_76174;
var statearr_76183_77253 = state_76174__$1;
(statearr_76183_77253[(2)] = null);

(statearr_76183_77253[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (17))){
var inst_76167 = (state_76174[(2)]);
var state_76174__$1 = (function (){var statearr_76185 = state_76174;
(statearr_76185[(10)] = inst_76167);

return statearr_76185;
})();
var statearr_76186_77254 = state_76174__$1;
(statearr_76186_77254[(2)] = null);

(statearr_76186_77254[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (3))){
var inst_76172 = (state_76174[(2)]);
var state_76174__$1 = state_76174;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76174__$1,inst_76172);
} else {
if((state_val_76175 === (12))){
var _ = (function (){var statearr_76187 = state_76174;
(statearr_76187[(4)] = cljs.core.rest((state_76174[(4)])));

return statearr_76187;
})();
var state_76174__$1 = state_76174;
var ex76184 = (state_76174__$1[(2)]);
var statearr_76188_77255 = state_76174__$1;
(statearr_76188_77255[(5)] = ex76184);


if((ex76184 instanceof Object)){
var statearr_76189_77256 = state_76174__$1;
(statearr_76189_77256[(1)] = (11));

(statearr_76189_77256[(5)] = null);

} else {
throw ex76184;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (2))){
var inst_76133 = cljs.core.reset_BANG_(dctr,cnt);
var inst_76134 = cnt;
var inst_76135 = (0);
var state_76174__$1 = (function (){var statearr_76190 = state_76174;
(statearr_76190[(7)] = inst_76135);

(statearr_76190[(8)] = inst_76134);

(statearr_76190[(11)] = inst_76133);

return statearr_76190;
})();
var statearr_76191_77257 = state_76174__$1;
(statearr_76191_77257[(2)] = null);

(statearr_76191_77257[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (11))){
var inst_76139 = (state_76174[(2)]);
var inst_76140 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_76174__$1 = (function (){var statearr_76192 = state_76174;
(statearr_76192[(12)] = inst_76139);

return statearr_76192;
})();
var statearr_76193_77258 = state_76174__$1;
(statearr_76193_77258[(2)] = inst_76140);

(statearr_76193_77258[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (9))){
var inst_76135 = (state_76174[(7)]);
var _ = (function (){var statearr_76194 = state_76174;
(statearr_76194[(4)] = cljs.core.cons((12),(state_76174[(4)])));

return statearr_76194;
})();
var inst_76146 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_76135) : chs__$1.call(null,inst_76135));
var inst_76147 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_76135) : done.call(null,inst_76135));
var inst_76148 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_76146,inst_76147);
var ___$1 = (function (){var statearr_76195 = state_76174;
(statearr_76195[(4)] = cljs.core.rest((state_76174[(4)])));

return statearr_76195;
})();
var state_76174__$1 = state_76174;
var statearr_76196_77259 = state_76174__$1;
(statearr_76196_77259[(2)] = inst_76148);

(statearr_76196_77259[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (5))){
var inst_76158 = (state_76174[(2)]);
var state_76174__$1 = (function (){var statearr_76197 = state_76174;
(statearr_76197[(13)] = inst_76158);

return statearr_76197;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76174__$1,(13),dchan);
} else {
if((state_val_76175 === (14))){
var inst_76163 = cljs.core.async.close_BANG_(out);
var state_76174__$1 = state_76174;
var statearr_76198_77260 = state_76174__$1;
(statearr_76198_77260[(2)] = inst_76163);

(statearr_76198_77260[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (16))){
var inst_76170 = (state_76174[(2)]);
var state_76174__$1 = state_76174;
var statearr_76199_77261 = state_76174__$1;
(statearr_76199_77261[(2)] = inst_76170);

(statearr_76199_77261[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (10))){
var inst_76135 = (state_76174[(7)]);
var inst_76151 = (state_76174[(2)]);
var inst_76152 = (inst_76135 + (1));
var inst_76135__$1 = inst_76152;
var state_76174__$1 = (function (){var statearr_76200 = state_76174;
(statearr_76200[(7)] = inst_76135__$1);

(statearr_76200[(14)] = inst_76151);

return statearr_76200;
})();
var statearr_76201_77262 = state_76174__$1;
(statearr_76201_77262[(2)] = null);

(statearr_76201_77262[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76175 === (8))){
var inst_76156 = (state_76174[(2)]);
var state_76174__$1 = state_76174;
var statearr_76202_77263 = state_76174__$1;
(statearr_76202_77263[(2)] = inst_76156);

(statearr_76202_77263[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76203 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76203[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76203[(1)] = (1));

return statearr_76203;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76174){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76174);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76204){var ex__74105__auto__ = e76204;
var statearr_76205_77264 = state_76174;
(statearr_76205_77264[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76174[(4)]))){
var statearr_76206_77265 = state_76174;
(statearr_76206_77265[(1)] = cljs.core.first((state_76174[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77267 = state_76174;
state_76174 = G__77267;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76174){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76174);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76207 = f__74232__auto__();
(statearr_76207[(6)] = c__74231__auto___77246);

return statearr_76207;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.map.cljs$lang$maxFixedArity = 3);

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__76210 = arguments.length;
switch (G__76210) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
}));

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77269 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76242){
var state_val_76243 = (state_76242[(1)]);
if((state_val_76243 === (7))){
var inst_76221 = (state_76242[(7)]);
var inst_76222 = (state_76242[(8)]);
var inst_76221__$1 = (state_76242[(2)]);
var inst_76222__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_76221__$1,(0),null);
var inst_76223 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_76221__$1,(1),null);
var inst_76224 = (inst_76222__$1 == null);
var state_76242__$1 = (function (){var statearr_76244 = state_76242;
(statearr_76244[(9)] = inst_76223);

(statearr_76244[(7)] = inst_76221__$1);

(statearr_76244[(8)] = inst_76222__$1);

return statearr_76244;
})();
if(cljs.core.truth_(inst_76224)){
var statearr_76245_77270 = state_76242__$1;
(statearr_76245_77270[(1)] = (8));

} else {
var statearr_76246_77271 = state_76242__$1;
(statearr_76246_77271[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (1))){
var inst_76211 = cljs.core.vec(chs);
var inst_76212 = inst_76211;
var state_76242__$1 = (function (){var statearr_76247 = state_76242;
(statearr_76247[(10)] = inst_76212);

return statearr_76247;
})();
var statearr_76248_77272 = state_76242__$1;
(statearr_76248_77272[(2)] = null);

(statearr_76248_77272[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (4))){
var inst_76212 = (state_76242[(10)]);
var state_76242__$1 = state_76242;
return cljs.core.async.ioc_alts_BANG_(state_76242__$1,(7),inst_76212);
} else {
if((state_val_76243 === (6))){
var inst_76238 = (state_76242[(2)]);
var state_76242__$1 = state_76242;
var statearr_76249_77273 = state_76242__$1;
(statearr_76249_77273[(2)] = inst_76238);

(statearr_76249_77273[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (3))){
var inst_76240 = (state_76242[(2)]);
var state_76242__$1 = state_76242;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76242__$1,inst_76240);
} else {
if((state_val_76243 === (2))){
var inst_76212 = (state_76242[(10)]);
var inst_76214 = cljs.core.count(inst_76212);
var inst_76215 = (inst_76214 > (0));
var state_76242__$1 = state_76242;
if(cljs.core.truth_(inst_76215)){
var statearr_76251_77274 = state_76242__$1;
(statearr_76251_77274[(1)] = (4));

} else {
var statearr_76252_77275 = state_76242__$1;
(statearr_76252_77275[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (11))){
var inst_76212 = (state_76242[(10)]);
var inst_76231 = (state_76242[(2)]);
var tmp76250 = inst_76212;
var inst_76212__$1 = tmp76250;
var state_76242__$1 = (function (){var statearr_76253 = state_76242;
(statearr_76253[(11)] = inst_76231);

(statearr_76253[(10)] = inst_76212__$1);

return statearr_76253;
})();
var statearr_76254_77276 = state_76242__$1;
(statearr_76254_77276[(2)] = null);

(statearr_76254_77276[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (9))){
var inst_76222 = (state_76242[(8)]);
var state_76242__$1 = state_76242;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76242__$1,(11),out,inst_76222);
} else {
if((state_val_76243 === (5))){
var inst_76236 = cljs.core.async.close_BANG_(out);
var state_76242__$1 = state_76242;
var statearr_76255_77281 = state_76242__$1;
(statearr_76255_77281[(2)] = inst_76236);

(statearr_76255_77281[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (10))){
var inst_76234 = (state_76242[(2)]);
var state_76242__$1 = state_76242;
var statearr_76256_77282 = state_76242__$1;
(statearr_76256_77282[(2)] = inst_76234);

(statearr_76256_77282[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76243 === (8))){
var inst_76223 = (state_76242[(9)]);
var inst_76212 = (state_76242[(10)]);
var inst_76221 = (state_76242[(7)]);
var inst_76222 = (state_76242[(8)]);
var inst_76226 = (function (){var cs = inst_76212;
var vec__76217 = inst_76221;
var v = inst_76222;
var c = inst_76223;
return (function (p1__76208_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__76208_SHARP_);
});
})();
var inst_76227 = cljs.core.filterv(inst_76226,inst_76212);
var inst_76212__$1 = inst_76227;
var state_76242__$1 = (function (){var statearr_76257 = state_76242;
(statearr_76257[(10)] = inst_76212__$1);

return statearr_76257;
})();
var statearr_76258_77283 = state_76242__$1;
(statearr_76258_77283[(2)] = null);

(statearr_76258_77283[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76259 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76259[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76259[(1)] = (1));

return statearr_76259;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76242){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76242);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76260){var ex__74105__auto__ = e76260;
var statearr_76261_77284 = state_76242;
(statearr_76261_77284[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76242[(4)]))){
var statearr_76262_77285 = state_76242;
(statearr_76262_77285[(1)] = cljs.core.first((state_76242[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77286 = state_76242;
state_76242 = G__77286;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76242){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76242);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76263 = f__74232__auto__();
(statearr_76263[(6)] = c__74231__auto___77269);

return statearr_76263;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.merge.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__76265 = arguments.length;
switch (G__76265) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77288 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76289){
var state_val_76290 = (state_76289[(1)]);
if((state_val_76290 === (7))){
var inst_76271 = (state_76289[(7)]);
var inst_76271__$1 = (state_76289[(2)]);
var inst_76272 = (inst_76271__$1 == null);
var inst_76273 = cljs.core.not(inst_76272);
var state_76289__$1 = (function (){var statearr_76291 = state_76289;
(statearr_76291[(7)] = inst_76271__$1);

return statearr_76291;
})();
if(inst_76273){
var statearr_76292_77289 = state_76289__$1;
(statearr_76292_77289[(1)] = (8));

} else {
var statearr_76293_77290 = state_76289__$1;
(statearr_76293_77290[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (1))){
var inst_76266 = (0);
var state_76289__$1 = (function (){var statearr_76294 = state_76289;
(statearr_76294[(8)] = inst_76266);

return statearr_76294;
})();
var statearr_76295_77291 = state_76289__$1;
(statearr_76295_77291[(2)] = null);

(statearr_76295_77291[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (4))){
var state_76289__$1 = state_76289;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76289__$1,(7),ch);
} else {
if((state_val_76290 === (6))){
var inst_76284 = (state_76289[(2)]);
var state_76289__$1 = state_76289;
var statearr_76296_77292 = state_76289__$1;
(statearr_76296_77292[(2)] = inst_76284);

(statearr_76296_77292[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (3))){
var inst_76286 = (state_76289[(2)]);
var inst_76287 = cljs.core.async.close_BANG_(out);
var state_76289__$1 = (function (){var statearr_76297 = state_76289;
(statearr_76297[(9)] = inst_76286);

return statearr_76297;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_76289__$1,inst_76287);
} else {
if((state_val_76290 === (2))){
var inst_76266 = (state_76289[(8)]);
var inst_76268 = (inst_76266 < n);
var state_76289__$1 = state_76289;
if(cljs.core.truth_(inst_76268)){
var statearr_76298_77293 = state_76289__$1;
(statearr_76298_77293[(1)] = (4));

} else {
var statearr_76299_77294 = state_76289__$1;
(statearr_76299_77294[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (11))){
var inst_76266 = (state_76289[(8)]);
var inst_76276 = (state_76289[(2)]);
var inst_76277 = (inst_76266 + (1));
var inst_76266__$1 = inst_76277;
var state_76289__$1 = (function (){var statearr_76300 = state_76289;
(statearr_76300[(10)] = inst_76276);

(statearr_76300[(8)] = inst_76266__$1);

return statearr_76300;
})();
var statearr_76301_77295 = state_76289__$1;
(statearr_76301_77295[(2)] = null);

(statearr_76301_77295[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (9))){
var state_76289__$1 = state_76289;
var statearr_76302_77296 = state_76289__$1;
(statearr_76302_77296[(2)] = null);

(statearr_76302_77296[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (5))){
var state_76289__$1 = state_76289;
var statearr_76303_77297 = state_76289__$1;
(statearr_76303_77297[(2)] = null);

(statearr_76303_77297[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (10))){
var inst_76281 = (state_76289[(2)]);
var state_76289__$1 = state_76289;
var statearr_76304_77298 = state_76289__$1;
(statearr_76304_77298[(2)] = inst_76281);

(statearr_76304_77298[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76290 === (8))){
var inst_76271 = (state_76289[(7)]);
var state_76289__$1 = state_76289;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76289__$1,(11),out,inst_76271);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76305 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_76305[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76305[(1)] = (1));

return statearr_76305;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76289){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76289);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76306){var ex__74105__auto__ = e76306;
var statearr_76307_77306 = state_76289;
(statearr_76307_77306[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76289[(4)]))){
var statearr_76308_77307 = state_76289;
(statearr_76308_77307[(1)] = cljs.core.first((state_76289[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77308 = state_76289;
state_76289 = G__77308;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76289){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76289);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76309 = f__74232__auto__();
(statearr_76309[(6)] = c__74231__auto___77288);

return statearr_76309;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.take.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async76311 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async76311 = (function (f,ch,meta76312){
this.f = f;
this.ch = ch;
this.meta76312 = meta76312;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_76313,meta76312__$1){
var self__ = this;
var _76313__$1 = this;
return (new cljs.core.async.t_cljs$core$async76311(self__.f,self__.ch,meta76312__$1));
}));

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_76313){
var self__ = this;
var _76313__$1 = this;
return self__.meta76312;
}));

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async76314 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async76314 = (function (f,ch,meta76312,_,fn1,meta76315){
this.f = f;
this.ch = ch;
this.meta76312 = meta76312;
this._ = _;
this.fn1 = fn1;
this.meta76315 = meta76315;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_76316,meta76315__$1){
var self__ = this;
var _76316__$1 = this;
return (new cljs.core.async.t_cljs$core$async76314(self__.f,self__.ch,self__.meta76312,self__._,self__.fn1,meta76315__$1));
}));

(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_76316){
var self__ = this;
var _76316__$1 = this;
return self__.meta76315;
}));

(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
}));

(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async76314.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return (function (p1__76310_SHARP_){
var G__76317 = (((p1__76310_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__76310_SHARP_) : self__.f.call(null,p1__76310_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__76317) : f1.call(null,G__76317));
});
}));

(cljs.core.async.t_cljs$core$async76314.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta76312","meta76312",-1178727278,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async76311","cljs.core.async/t_cljs$core$async76311",1381805582,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta76315","meta76315",-1913173806,null)], null);
}));

(cljs.core.async.t_cljs$core$async76314.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async76314.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async76314");

(cljs.core.async.t_cljs$core$async76314.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async76314");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async76314.
 */
cljs.core.async.__GT_t_cljs$core$async76314 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async76314(f__$1,ch__$1,meta76312__$1,___$2,fn1__$1,meta76315){
return (new cljs.core.async.t_cljs$core$async76314(f__$1,ch__$1,meta76312__$1,___$2,fn1__$1,meta76315));
});

}

return (new cljs.core.async.t_cljs$core$async76314(self__.f,self__.ch,self__.meta76312,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4221__auto__ = ret;
if(cljs.core.truth_(and__4221__auto__)){
return (!((cljs.core.deref(ret) == null)));
} else {
return and__4221__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__76318 = cljs.core.deref(ret);
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__76318) : self__.f.call(null,G__76318));
})());
} else {
return ret;
}
}));

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76311.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
}));

(cljs.core.async.t_cljs$core$async76311.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta76312","meta76312",-1178727278,null)], null);
}));

(cljs.core.async.t_cljs$core$async76311.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async76311.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async76311");

(cljs.core.async.t_cljs$core$async76311.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async76311");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async76311.
 */
cljs.core.async.__GT_t_cljs$core$async76311 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async76311(f__$1,ch__$1,meta76312){
return (new cljs.core.async.t_cljs$core$async76311(f__$1,ch__$1,meta76312));
});

}

return (new cljs.core.async.t_cljs$core$async76311(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async76319 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async76319 = (function (f,ch,meta76320){
this.f = f;
this.ch = ch;
this.meta76320 = meta76320;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_76321,meta76320__$1){
var self__ = this;
var _76321__$1 = this;
return (new cljs.core.async.t_cljs$core$async76319(self__.f,self__.ch,meta76320__$1));
}));

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_76321){
var self__ = this;
var _76321__$1 = this;
return self__.meta76320;
}));

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76319.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
}));

(cljs.core.async.t_cljs$core$async76319.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta76320","meta76320",854956193,null)], null);
}));

(cljs.core.async.t_cljs$core$async76319.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async76319.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async76319");

(cljs.core.async.t_cljs$core$async76319.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async76319");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async76319.
 */
cljs.core.async.__GT_t_cljs$core$async76319 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async76319(f__$1,ch__$1,meta76320){
return (new cljs.core.async.t_cljs$core$async76319(f__$1,ch__$1,meta76320));
});

}

return (new cljs.core.async.t_cljs$core$async76319(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async76322 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async76322 = (function (p,ch,meta76323){
this.p = p;
this.ch = ch;
this.meta76323 = meta76323;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_76324,meta76323__$1){
var self__ = this;
var _76324__$1 = this;
return (new cljs.core.async.t_cljs$core$async76322(self__.p,self__.ch,meta76323__$1));
}));

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_76324){
var self__ = this;
var _76324__$1 = this;
return self__.meta76323;
}));

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async76322.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
}));

(cljs.core.async.t_cljs$core$async76322.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta76323","meta76323",-944755976,null)], null);
}));

(cljs.core.async.t_cljs$core$async76322.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async76322.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async76322");

(cljs.core.async.t_cljs$core$async76322.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async76322");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async76322.
 */
cljs.core.async.__GT_t_cljs$core$async76322 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async76322(p__$1,ch__$1,meta76323){
return (new cljs.core.async.t_cljs$core$async76322(p__$1,ch__$1,meta76323));
});

}

return (new cljs.core.async.t_cljs$core$async76322(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__76326 = arguments.length;
switch (G__76326) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77325 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76347){
var state_val_76348 = (state_76347[(1)]);
if((state_val_76348 === (7))){
var inst_76343 = (state_76347[(2)]);
var state_76347__$1 = state_76347;
var statearr_76349_77326 = state_76347__$1;
(statearr_76349_77326[(2)] = inst_76343);

(statearr_76349_77326[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (1))){
var state_76347__$1 = state_76347;
var statearr_76350_77327 = state_76347__$1;
(statearr_76350_77327[(2)] = null);

(statearr_76350_77327[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (4))){
var inst_76329 = (state_76347[(7)]);
var inst_76329__$1 = (state_76347[(2)]);
var inst_76330 = (inst_76329__$1 == null);
var state_76347__$1 = (function (){var statearr_76351 = state_76347;
(statearr_76351[(7)] = inst_76329__$1);

return statearr_76351;
})();
if(cljs.core.truth_(inst_76330)){
var statearr_76352_77328 = state_76347__$1;
(statearr_76352_77328[(1)] = (5));

} else {
var statearr_76353_77329 = state_76347__$1;
(statearr_76353_77329[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (6))){
var inst_76329 = (state_76347[(7)]);
var inst_76334 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_76329) : p.call(null,inst_76329));
var state_76347__$1 = state_76347;
if(cljs.core.truth_(inst_76334)){
var statearr_76354_77330 = state_76347__$1;
(statearr_76354_77330[(1)] = (8));

} else {
var statearr_76355_77331 = state_76347__$1;
(statearr_76355_77331[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (3))){
var inst_76345 = (state_76347[(2)]);
var state_76347__$1 = state_76347;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76347__$1,inst_76345);
} else {
if((state_val_76348 === (2))){
var state_76347__$1 = state_76347;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76347__$1,(4),ch);
} else {
if((state_val_76348 === (11))){
var inst_76337 = (state_76347[(2)]);
var state_76347__$1 = state_76347;
var statearr_76356_77332 = state_76347__$1;
(statearr_76356_77332[(2)] = inst_76337);

(statearr_76356_77332[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (9))){
var state_76347__$1 = state_76347;
var statearr_76357_77333 = state_76347__$1;
(statearr_76357_77333[(2)] = null);

(statearr_76357_77333[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (5))){
var inst_76332 = cljs.core.async.close_BANG_(out);
var state_76347__$1 = state_76347;
var statearr_76358_77334 = state_76347__$1;
(statearr_76358_77334[(2)] = inst_76332);

(statearr_76358_77334[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (10))){
var inst_76340 = (state_76347[(2)]);
var state_76347__$1 = (function (){var statearr_76359 = state_76347;
(statearr_76359[(8)] = inst_76340);

return statearr_76359;
})();
var statearr_76360_77335 = state_76347__$1;
(statearr_76360_77335[(2)] = null);

(statearr_76360_77335[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76348 === (8))){
var inst_76329 = (state_76347[(7)]);
var state_76347__$1 = state_76347;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76347__$1,(11),out,inst_76329);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76361 = [null,null,null,null,null,null,null,null,null];
(statearr_76361[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76361[(1)] = (1));

return statearr_76361;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76347){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76347);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76362){var ex__74105__auto__ = e76362;
var statearr_76363_77336 = state_76347;
(statearr_76363_77336[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76347[(4)]))){
var statearr_76364_77337 = state_76347;
(statearr_76364_77337[(1)] = cljs.core.first((state_76347[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77338 = state_76347;
state_76347 = G__77338;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76347){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76347);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76365 = f__74232__auto__();
(statearr_76365[(6)] = c__74231__auto___77325);

return statearr_76365;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__76367 = arguments.length;
switch (G__76367) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
}));

(cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3);

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__74231__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76429){
var state_val_76430 = (state_76429[(1)]);
if((state_val_76430 === (7))){
var inst_76425 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
var statearr_76431_77342 = state_76429__$1;
(statearr_76431_77342[(2)] = inst_76425);

(statearr_76431_77342[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (20))){
var inst_76395 = (state_76429[(7)]);
var inst_76406 = (state_76429[(2)]);
var inst_76407 = cljs.core.next(inst_76395);
var inst_76381 = inst_76407;
var inst_76382 = null;
var inst_76383 = (0);
var inst_76384 = (0);
var state_76429__$1 = (function (){var statearr_76432 = state_76429;
(statearr_76432[(8)] = inst_76406);

(statearr_76432[(9)] = inst_76382);

(statearr_76432[(10)] = inst_76384);

(statearr_76432[(11)] = inst_76383);

(statearr_76432[(12)] = inst_76381);

return statearr_76432;
})();
var statearr_76433_77343 = state_76429__$1;
(statearr_76433_77343[(2)] = null);

(statearr_76433_77343[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (1))){
var state_76429__$1 = state_76429;
var statearr_76434_77344 = state_76429__$1;
(statearr_76434_77344[(2)] = null);

(statearr_76434_77344[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (4))){
var inst_76370 = (state_76429[(13)]);
var inst_76370__$1 = (state_76429[(2)]);
var inst_76371 = (inst_76370__$1 == null);
var state_76429__$1 = (function (){var statearr_76435 = state_76429;
(statearr_76435[(13)] = inst_76370__$1);

return statearr_76435;
})();
if(cljs.core.truth_(inst_76371)){
var statearr_76436_77345 = state_76429__$1;
(statearr_76436_77345[(1)] = (5));

} else {
var statearr_76437_77346 = state_76429__$1;
(statearr_76437_77346[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (15))){
var state_76429__$1 = state_76429;
var statearr_76441_77347 = state_76429__$1;
(statearr_76441_77347[(2)] = null);

(statearr_76441_77347[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (21))){
var state_76429__$1 = state_76429;
var statearr_76442_77348 = state_76429__$1;
(statearr_76442_77348[(2)] = null);

(statearr_76442_77348[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (13))){
var inst_76382 = (state_76429[(9)]);
var inst_76384 = (state_76429[(10)]);
var inst_76383 = (state_76429[(11)]);
var inst_76381 = (state_76429[(12)]);
var inst_76391 = (state_76429[(2)]);
var inst_76392 = (inst_76384 + (1));
var tmp76438 = inst_76382;
var tmp76439 = inst_76383;
var tmp76440 = inst_76381;
var inst_76381__$1 = tmp76440;
var inst_76382__$1 = tmp76438;
var inst_76383__$1 = tmp76439;
var inst_76384__$1 = inst_76392;
var state_76429__$1 = (function (){var statearr_76443 = state_76429;
(statearr_76443[(9)] = inst_76382__$1);

(statearr_76443[(10)] = inst_76384__$1);

(statearr_76443[(11)] = inst_76383__$1);

(statearr_76443[(12)] = inst_76381__$1);

(statearr_76443[(14)] = inst_76391);

return statearr_76443;
})();
var statearr_76444_77349 = state_76429__$1;
(statearr_76444_77349[(2)] = null);

(statearr_76444_77349[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (22))){
var state_76429__$1 = state_76429;
var statearr_76445_77351 = state_76429__$1;
(statearr_76445_77351[(2)] = null);

(statearr_76445_77351[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (6))){
var inst_76370 = (state_76429[(13)]);
var inst_76379 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_76370) : f.call(null,inst_76370));
var inst_76380 = cljs.core.seq(inst_76379);
var inst_76381 = inst_76380;
var inst_76382 = null;
var inst_76383 = (0);
var inst_76384 = (0);
var state_76429__$1 = (function (){var statearr_76446 = state_76429;
(statearr_76446[(9)] = inst_76382);

(statearr_76446[(10)] = inst_76384);

(statearr_76446[(11)] = inst_76383);

(statearr_76446[(12)] = inst_76381);

return statearr_76446;
})();
var statearr_76447_77356 = state_76429__$1;
(statearr_76447_77356[(2)] = null);

(statearr_76447_77356[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (17))){
var inst_76395 = (state_76429[(7)]);
var inst_76399 = cljs.core.chunk_first(inst_76395);
var inst_76400 = cljs.core.chunk_rest(inst_76395);
var inst_76401 = cljs.core.count(inst_76399);
var inst_76381 = inst_76400;
var inst_76382 = inst_76399;
var inst_76383 = inst_76401;
var inst_76384 = (0);
var state_76429__$1 = (function (){var statearr_76448 = state_76429;
(statearr_76448[(9)] = inst_76382);

(statearr_76448[(10)] = inst_76384);

(statearr_76448[(11)] = inst_76383);

(statearr_76448[(12)] = inst_76381);

return statearr_76448;
})();
var statearr_76449_77359 = state_76429__$1;
(statearr_76449_77359[(2)] = null);

(statearr_76449_77359[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (3))){
var inst_76427 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76429__$1,inst_76427);
} else {
if((state_val_76430 === (12))){
var inst_76415 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
var statearr_76450_77360 = state_76429__$1;
(statearr_76450_77360[(2)] = inst_76415);

(statearr_76450_77360[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (2))){
var state_76429__$1 = state_76429;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76429__$1,(4),in$);
} else {
if((state_val_76430 === (23))){
var inst_76423 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
var statearr_76451_77362 = state_76429__$1;
(statearr_76451_77362[(2)] = inst_76423);

(statearr_76451_77362[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (19))){
var inst_76410 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
var statearr_76452_77363 = state_76429__$1;
(statearr_76452_77363[(2)] = inst_76410);

(statearr_76452_77363[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (11))){
var inst_76395 = (state_76429[(7)]);
var inst_76381 = (state_76429[(12)]);
var inst_76395__$1 = cljs.core.seq(inst_76381);
var state_76429__$1 = (function (){var statearr_76453 = state_76429;
(statearr_76453[(7)] = inst_76395__$1);

return statearr_76453;
})();
if(inst_76395__$1){
var statearr_76454_77364 = state_76429__$1;
(statearr_76454_77364[(1)] = (14));

} else {
var statearr_76455_77365 = state_76429__$1;
(statearr_76455_77365[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (9))){
var inst_76417 = (state_76429[(2)]);
var inst_76418 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_76429__$1 = (function (){var statearr_76456 = state_76429;
(statearr_76456[(15)] = inst_76417);

return statearr_76456;
})();
if(cljs.core.truth_(inst_76418)){
var statearr_76457_77367 = state_76429__$1;
(statearr_76457_77367[(1)] = (21));

} else {
var statearr_76458_77368 = state_76429__$1;
(statearr_76458_77368[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (5))){
var inst_76373 = cljs.core.async.close_BANG_(out);
var state_76429__$1 = state_76429;
var statearr_76459_77369 = state_76429__$1;
(statearr_76459_77369[(2)] = inst_76373);

(statearr_76459_77369[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (14))){
var inst_76395 = (state_76429[(7)]);
var inst_76397 = cljs.core.chunked_seq_QMARK_(inst_76395);
var state_76429__$1 = state_76429;
if(inst_76397){
var statearr_76460_77375 = state_76429__$1;
(statearr_76460_77375[(1)] = (17));

} else {
var statearr_76461_77376 = state_76429__$1;
(statearr_76461_77376[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (16))){
var inst_76413 = (state_76429[(2)]);
var state_76429__$1 = state_76429;
var statearr_76462_77378 = state_76429__$1;
(statearr_76462_77378[(2)] = inst_76413);

(statearr_76462_77378[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76430 === (10))){
var inst_76382 = (state_76429[(9)]);
var inst_76384 = (state_76429[(10)]);
var inst_76389 = cljs.core._nth(inst_76382,inst_76384);
var state_76429__$1 = state_76429;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76429__$1,(13),out,inst_76389);
} else {
if((state_val_76430 === (18))){
var inst_76395 = (state_76429[(7)]);
var inst_76404 = cljs.core.first(inst_76395);
var state_76429__$1 = state_76429;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76429__$1,(20),out,inst_76404);
} else {
if((state_val_76430 === (8))){
var inst_76384 = (state_76429[(10)]);
var inst_76383 = (state_76429[(11)]);
var inst_76386 = (inst_76384 < inst_76383);
var inst_76387 = inst_76386;
var state_76429__$1 = state_76429;
if(cljs.core.truth_(inst_76387)){
var statearr_76463_77379 = state_76429__$1;
(statearr_76463_77379[(1)] = (10));

} else {
var statearr_76464_77380 = state_76429__$1;
(statearr_76464_77380[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____0 = (function (){
var statearr_76465 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76465[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__);

(statearr_76465[(1)] = (1));

return statearr_76465;
});
var cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____1 = (function (state_76429){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76429);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76466){var ex__74105__auto__ = e76466;
var statearr_76467_77381 = state_76429;
(statearr_76467_77381[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76429[(4)]))){
var statearr_76468_77382 = state_76429;
(statearr_76468_77382[(1)] = cljs.core.first((state_76429[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77384 = state_76429;
state_76429 = G__77384;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__ = function(state_76429){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____1.call(this,state_76429);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__74102__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76469 = f__74232__auto__();
(statearr_76469[(6)] = c__74231__auto__);

return statearr_76469;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));

return c__74231__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__76471 = arguments.length;
switch (G__76471) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
}));

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
}));

(cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__76473 = arguments.length;
switch (G__76473) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
}));

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
}));

(cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__76475 = arguments.length;
switch (G__76475) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
}));

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77392 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76499){
var state_val_76500 = (state_76499[(1)]);
if((state_val_76500 === (7))){
var inst_76494 = (state_76499[(2)]);
var state_76499__$1 = state_76499;
var statearr_76501_77393 = state_76499__$1;
(statearr_76501_77393[(2)] = inst_76494);

(statearr_76501_77393[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (1))){
var inst_76476 = null;
var state_76499__$1 = (function (){var statearr_76502 = state_76499;
(statearr_76502[(7)] = inst_76476);

return statearr_76502;
})();
var statearr_76503_77394 = state_76499__$1;
(statearr_76503_77394[(2)] = null);

(statearr_76503_77394[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (4))){
var inst_76479 = (state_76499[(8)]);
var inst_76479__$1 = (state_76499[(2)]);
var inst_76480 = (inst_76479__$1 == null);
var inst_76481 = cljs.core.not(inst_76480);
var state_76499__$1 = (function (){var statearr_76504 = state_76499;
(statearr_76504[(8)] = inst_76479__$1);

return statearr_76504;
})();
if(inst_76481){
var statearr_76505_77395 = state_76499__$1;
(statearr_76505_77395[(1)] = (5));

} else {
var statearr_76506_77396 = state_76499__$1;
(statearr_76506_77396[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (6))){
var state_76499__$1 = state_76499;
var statearr_76507_77397 = state_76499__$1;
(statearr_76507_77397[(2)] = null);

(statearr_76507_77397[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (3))){
var inst_76496 = (state_76499[(2)]);
var inst_76497 = cljs.core.async.close_BANG_(out);
var state_76499__$1 = (function (){var statearr_76508 = state_76499;
(statearr_76508[(9)] = inst_76496);

return statearr_76508;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_76499__$1,inst_76497);
} else {
if((state_val_76500 === (2))){
var state_76499__$1 = state_76499;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76499__$1,(4),ch);
} else {
if((state_val_76500 === (11))){
var inst_76479 = (state_76499[(8)]);
var inst_76488 = (state_76499[(2)]);
var inst_76476 = inst_76479;
var state_76499__$1 = (function (){var statearr_76509 = state_76499;
(statearr_76509[(10)] = inst_76488);

(statearr_76509[(7)] = inst_76476);

return statearr_76509;
})();
var statearr_76510_77398 = state_76499__$1;
(statearr_76510_77398[(2)] = null);

(statearr_76510_77398[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (9))){
var inst_76479 = (state_76499[(8)]);
var state_76499__$1 = state_76499;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76499__$1,(11),out,inst_76479);
} else {
if((state_val_76500 === (5))){
var inst_76476 = (state_76499[(7)]);
var inst_76479 = (state_76499[(8)]);
var inst_76483 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_76479,inst_76476);
var state_76499__$1 = state_76499;
if(inst_76483){
var statearr_76512_77399 = state_76499__$1;
(statearr_76512_77399[(1)] = (8));

} else {
var statearr_76513_77400 = state_76499__$1;
(statearr_76513_77400[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (10))){
var inst_76491 = (state_76499[(2)]);
var state_76499__$1 = state_76499;
var statearr_76514_77401 = state_76499__$1;
(statearr_76514_77401[(2)] = inst_76491);

(statearr_76514_77401[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76500 === (8))){
var inst_76476 = (state_76499[(7)]);
var tmp76511 = inst_76476;
var inst_76476__$1 = tmp76511;
var state_76499__$1 = (function (){var statearr_76515 = state_76499;
(statearr_76515[(7)] = inst_76476__$1);

return statearr_76515;
})();
var statearr_76516_77402 = state_76499__$1;
(statearr_76516_77402[(2)] = null);

(statearr_76516_77402[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76517 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_76517[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76517[(1)] = (1));

return statearr_76517;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76499){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76499);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76518){var ex__74105__auto__ = e76518;
var statearr_76519_77403 = state_76499;
(statearr_76519_77403[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76499[(4)]))){
var statearr_76520_77404 = state_76499;
(statearr_76520_77404[(1)] = cljs.core.first((state_76499[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77405 = state_76499;
state_76499 = G__77405;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76499){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76499);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76521 = f__74232__auto__();
(statearr_76521[(6)] = c__74231__auto___77392);

return statearr_76521;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.unique.cljs$lang$maxFixedArity = 2);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__76523 = arguments.length;
switch (G__76523) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77408 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76561){
var state_val_76562 = (state_76561[(1)]);
if((state_val_76562 === (7))){
var inst_76557 = (state_76561[(2)]);
var state_76561__$1 = state_76561;
var statearr_76563_77409 = state_76561__$1;
(statearr_76563_77409[(2)] = inst_76557);

(statearr_76563_77409[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (1))){
var inst_76524 = (new Array(n));
var inst_76525 = inst_76524;
var inst_76526 = (0);
var state_76561__$1 = (function (){var statearr_76564 = state_76561;
(statearr_76564[(7)] = inst_76526);

(statearr_76564[(8)] = inst_76525);

return statearr_76564;
})();
var statearr_76565_77410 = state_76561__$1;
(statearr_76565_77410[(2)] = null);

(statearr_76565_77410[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (4))){
var inst_76529 = (state_76561[(9)]);
var inst_76529__$1 = (state_76561[(2)]);
var inst_76530 = (inst_76529__$1 == null);
var inst_76531 = cljs.core.not(inst_76530);
var state_76561__$1 = (function (){var statearr_76570 = state_76561;
(statearr_76570[(9)] = inst_76529__$1);

return statearr_76570;
})();
if(inst_76531){
var statearr_76571_77414 = state_76561__$1;
(statearr_76571_77414[(1)] = (5));

} else {
var statearr_76572_77415 = state_76561__$1;
(statearr_76572_77415[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (15))){
var inst_76551 = (state_76561[(2)]);
var state_76561__$1 = state_76561;
var statearr_76573_77416 = state_76561__$1;
(statearr_76573_77416[(2)] = inst_76551);

(statearr_76573_77416[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (13))){
var state_76561__$1 = state_76561;
var statearr_76574_77417 = state_76561__$1;
(statearr_76574_77417[(2)] = null);

(statearr_76574_77417[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (6))){
var inst_76526 = (state_76561[(7)]);
var inst_76547 = (inst_76526 > (0));
var state_76561__$1 = state_76561;
if(cljs.core.truth_(inst_76547)){
var statearr_76575_77418 = state_76561__$1;
(statearr_76575_77418[(1)] = (12));

} else {
var statearr_76576_77419 = state_76561__$1;
(statearr_76576_77419[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (3))){
var inst_76559 = (state_76561[(2)]);
var state_76561__$1 = state_76561;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76561__$1,inst_76559);
} else {
if((state_val_76562 === (12))){
var inst_76525 = (state_76561[(8)]);
var inst_76549 = cljs.core.vec(inst_76525);
var state_76561__$1 = state_76561;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76561__$1,(15),out,inst_76549);
} else {
if((state_val_76562 === (2))){
var state_76561__$1 = state_76561;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76561__$1,(4),ch);
} else {
if((state_val_76562 === (11))){
var inst_76541 = (state_76561[(2)]);
var inst_76542 = (new Array(n));
var inst_76525 = inst_76542;
var inst_76526 = (0);
var state_76561__$1 = (function (){var statearr_76577 = state_76561;
(statearr_76577[(10)] = inst_76541);

(statearr_76577[(7)] = inst_76526);

(statearr_76577[(8)] = inst_76525);

return statearr_76577;
})();
var statearr_76578_77421 = state_76561__$1;
(statearr_76578_77421[(2)] = null);

(statearr_76578_77421[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (9))){
var inst_76525 = (state_76561[(8)]);
var inst_76539 = cljs.core.vec(inst_76525);
var state_76561__$1 = state_76561;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76561__$1,(11),out,inst_76539);
} else {
if((state_val_76562 === (5))){
var inst_76529 = (state_76561[(9)]);
var inst_76534 = (state_76561[(11)]);
var inst_76526 = (state_76561[(7)]);
var inst_76525 = (state_76561[(8)]);
var inst_76533 = (inst_76525[inst_76526] = inst_76529);
var inst_76534__$1 = (inst_76526 + (1));
var inst_76535 = (inst_76534__$1 < n);
var state_76561__$1 = (function (){var statearr_76579 = state_76561;
(statearr_76579[(11)] = inst_76534__$1);

(statearr_76579[(12)] = inst_76533);

return statearr_76579;
})();
if(cljs.core.truth_(inst_76535)){
var statearr_76580_77426 = state_76561__$1;
(statearr_76580_77426[(1)] = (8));

} else {
var statearr_76581_77427 = state_76561__$1;
(statearr_76581_77427[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (14))){
var inst_76554 = (state_76561[(2)]);
var inst_76555 = cljs.core.async.close_BANG_(out);
var state_76561__$1 = (function (){var statearr_76583 = state_76561;
(statearr_76583[(13)] = inst_76554);

return statearr_76583;
})();
var statearr_76584_77428 = state_76561__$1;
(statearr_76584_77428[(2)] = inst_76555);

(statearr_76584_77428[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (10))){
var inst_76545 = (state_76561[(2)]);
var state_76561__$1 = state_76561;
var statearr_76585_77430 = state_76561__$1;
(statearr_76585_77430[(2)] = inst_76545);

(statearr_76585_77430[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76562 === (8))){
var inst_76534 = (state_76561[(11)]);
var inst_76525 = (state_76561[(8)]);
var tmp76582 = inst_76525;
var inst_76525__$1 = tmp76582;
var inst_76526 = inst_76534;
var state_76561__$1 = (function (){var statearr_76586 = state_76561;
(statearr_76586[(7)] = inst_76526);

(statearr_76586[(8)] = inst_76525__$1);

return statearr_76586;
})();
var statearr_76587_77431 = state_76561__$1;
(statearr_76587_77431[(2)] = null);

(statearr_76587_77431[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76588 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76588[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76588[(1)] = (1));

return statearr_76588;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76561){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76561);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76589){var ex__74105__auto__ = e76589;
var statearr_76590_77432 = state_76561;
(statearr_76590_77432[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76561[(4)]))){
var statearr_76591_77433 = state_76561;
(statearr_76591_77433[(1)] = cljs.core.first((state_76561[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77434 = state_76561;
state_76561 = G__77434;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76561){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76561);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76592 = f__74232__auto__();
(statearr_76592[(6)] = c__74231__auto___77408);

return statearr_76592;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.partition.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__76594 = arguments.length;
switch (G__76594) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
}));

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__74231__auto___77441 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__74232__auto__ = (function (){var switch__74101__auto__ = (function (state_76641){
var state_val_76642 = (state_76641[(1)]);
if((state_val_76642 === (7))){
var inst_76637 = (state_76641[(2)]);
var state_76641__$1 = state_76641;
var statearr_76643_77442 = state_76641__$1;
(statearr_76643_77442[(2)] = inst_76637);

(statearr_76643_77442[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (1))){
var inst_76595 = [];
var inst_76596 = inst_76595;
var inst_76597 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_76641__$1 = (function (){var statearr_76644 = state_76641;
(statearr_76644[(7)] = inst_76597);

(statearr_76644[(8)] = inst_76596);

return statearr_76644;
})();
var statearr_76645_77443 = state_76641__$1;
(statearr_76645_77443[(2)] = null);

(statearr_76645_77443[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (4))){
var inst_76600 = (state_76641[(9)]);
var inst_76600__$1 = (state_76641[(2)]);
var inst_76601 = (inst_76600__$1 == null);
var inst_76602 = cljs.core.not(inst_76601);
var state_76641__$1 = (function (){var statearr_76646 = state_76641;
(statearr_76646[(9)] = inst_76600__$1);

return statearr_76646;
})();
if(inst_76602){
var statearr_76647_77444 = state_76641__$1;
(statearr_76647_77444[(1)] = (5));

} else {
var statearr_76648_77445 = state_76641__$1;
(statearr_76648_77445[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (15))){
var inst_76596 = (state_76641[(8)]);
var inst_76629 = cljs.core.vec(inst_76596);
var state_76641__$1 = state_76641;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76641__$1,(18),out,inst_76629);
} else {
if((state_val_76642 === (13))){
var inst_76624 = (state_76641[(2)]);
var state_76641__$1 = state_76641;
var statearr_76649_77446 = state_76641__$1;
(statearr_76649_77446[(2)] = inst_76624);

(statearr_76649_77446[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (6))){
var inst_76596 = (state_76641[(8)]);
var inst_76626 = inst_76596.length;
var inst_76627 = (inst_76626 > (0));
var state_76641__$1 = state_76641;
if(cljs.core.truth_(inst_76627)){
var statearr_76650_77447 = state_76641__$1;
(statearr_76650_77447[(1)] = (15));

} else {
var statearr_76651_77448 = state_76641__$1;
(statearr_76651_77448[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (17))){
var inst_76634 = (state_76641[(2)]);
var inst_76635 = cljs.core.async.close_BANG_(out);
var state_76641__$1 = (function (){var statearr_76652 = state_76641;
(statearr_76652[(10)] = inst_76634);

return statearr_76652;
})();
var statearr_76653_77449 = state_76641__$1;
(statearr_76653_77449[(2)] = inst_76635);

(statearr_76653_77449[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (3))){
var inst_76639 = (state_76641[(2)]);
var state_76641__$1 = state_76641;
return cljs.core.async.impl.ioc_helpers.return_chan(state_76641__$1,inst_76639);
} else {
if((state_val_76642 === (12))){
var inst_76596 = (state_76641[(8)]);
var inst_76617 = cljs.core.vec(inst_76596);
var state_76641__$1 = state_76641;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_76641__$1,(14),out,inst_76617);
} else {
if((state_val_76642 === (2))){
var state_76641__$1 = state_76641;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_76641__$1,(4),ch);
} else {
if((state_val_76642 === (11))){
var inst_76605 = (state_76641[(11)]);
var inst_76600 = (state_76641[(9)]);
var inst_76596 = (state_76641[(8)]);
var inst_76614 = inst_76596.push(inst_76600);
var tmp76654 = inst_76596;
var inst_76596__$1 = tmp76654;
var inst_76597 = inst_76605;
var state_76641__$1 = (function (){var statearr_76655 = state_76641;
(statearr_76655[(12)] = inst_76614);

(statearr_76655[(7)] = inst_76597);

(statearr_76655[(8)] = inst_76596__$1);

return statearr_76655;
})();
var statearr_76656_77450 = state_76641__$1;
(statearr_76656_77450[(2)] = null);

(statearr_76656_77450[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (9))){
var inst_76597 = (state_76641[(7)]);
var inst_76610 = cljs.core.keyword_identical_QMARK_(inst_76597,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var state_76641__$1 = state_76641;
var statearr_76657_77451 = state_76641__$1;
(statearr_76657_77451[(2)] = inst_76610);

(statearr_76657_77451[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (5))){
var inst_76605 = (state_76641[(11)]);
var inst_76597 = (state_76641[(7)]);
var inst_76606 = (state_76641[(13)]);
var inst_76600 = (state_76641[(9)]);
var inst_76605__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_76600) : f.call(null,inst_76600));
var inst_76606__$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_76605__$1,inst_76597);
var state_76641__$1 = (function (){var statearr_76658 = state_76641;
(statearr_76658[(11)] = inst_76605__$1);

(statearr_76658[(13)] = inst_76606__$1);

return statearr_76658;
})();
if(inst_76606__$1){
var statearr_76659_77452 = state_76641__$1;
(statearr_76659_77452[(1)] = (8));

} else {
var statearr_76664_77453 = state_76641__$1;
(statearr_76664_77453[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (14))){
var inst_76605 = (state_76641[(11)]);
var inst_76600 = (state_76641[(9)]);
var inst_76619 = (state_76641[(2)]);
var inst_76620 = [];
var inst_76621 = inst_76620.push(inst_76600);
var inst_76596 = inst_76620;
var inst_76597 = inst_76605;
var state_76641__$1 = (function (){var statearr_76665 = state_76641;
(statearr_76665[(14)] = inst_76619);

(statearr_76665[(7)] = inst_76597);

(statearr_76665[(15)] = inst_76621);

(statearr_76665[(8)] = inst_76596);

return statearr_76665;
})();
var statearr_76666_77454 = state_76641__$1;
(statearr_76666_77454[(2)] = null);

(statearr_76666_77454[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (16))){
var state_76641__$1 = state_76641;
var statearr_76667_77455 = state_76641__$1;
(statearr_76667_77455[(2)] = null);

(statearr_76667_77455[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (10))){
var inst_76612 = (state_76641[(2)]);
var state_76641__$1 = state_76641;
if(cljs.core.truth_(inst_76612)){
var statearr_76668_77456 = state_76641__$1;
(statearr_76668_77456[(1)] = (11));

} else {
var statearr_76669_77457 = state_76641__$1;
(statearr_76669_77457[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (18))){
var inst_76631 = (state_76641[(2)]);
var state_76641__$1 = state_76641;
var statearr_76670_77458 = state_76641__$1;
(statearr_76670_77458[(2)] = inst_76631);

(statearr_76670_77458[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_76642 === (8))){
var inst_76606 = (state_76641[(13)]);
var state_76641__$1 = state_76641;
var statearr_76671_77459 = state_76641__$1;
(statearr_76671_77459[(2)] = inst_76606);

(statearr_76671_77459[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__74102__auto__ = null;
var cljs$core$async$state_machine__74102__auto____0 = (function (){
var statearr_76672 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_76672[(0)] = cljs$core$async$state_machine__74102__auto__);

(statearr_76672[(1)] = (1));

return statearr_76672;
});
var cljs$core$async$state_machine__74102__auto____1 = (function (state_76641){
while(true){
var ret_value__74103__auto__ = (function (){try{while(true){
var result__74104__auto__ = switch__74101__auto__(state_76641);
if(cljs.core.keyword_identical_QMARK_(result__74104__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__74104__auto__;
}
break;
}
}catch (e76673){var ex__74105__auto__ = e76673;
var statearr_76674_77460 = state_76641;
(statearr_76674_77460[(2)] = ex__74105__auto__);


if(cljs.core.seq((state_76641[(4)]))){
var statearr_76675_77461 = state_76641;
(statearr_76675_77461[(1)] = cljs.core.first((state_76641[(4)])));

} else {
throw ex__74105__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__74103__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__77462 = state_76641;
state_76641 = G__77462;
continue;
} else {
return ret_value__74103__auto__;
}
break;
}
});
cljs$core$async$state_machine__74102__auto__ = function(state_76641){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__74102__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__74102__auto____1.call(this,state_76641);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__74102__auto____0;
cljs$core$async$state_machine__74102__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__74102__auto____1;
return cljs$core$async$state_machine__74102__auto__;
})()
})();
var state__74233__auto__ = (function (){var statearr_76676 = f__74232__auto__();
(statearr_76676[(6)] = c__74231__auto___77441);

return statearr_76676;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__74233__auto__);
}));


return out;
}));

(cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3);


//# sourceMappingURL=cljs.core.async.js.map
